# StochasticDiffEqWeak.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/sde_solve/)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

StochasticDiffEqWeak.jl is a component of the [OrdinaryDiffEq.jl](https://github.com/SciML/OrdinaryDiffEq.jl) monorepo providing weak-order stochastic Runge-Kutta methods for computing expectations of SDE solutions. While completely independent and usable on its own, users wanting all SDE solvers should use [StochasticDiffEq.jl](https://github.com/SciML/StochasticDiffEq.jl).

## Solvers

### Roessler SRK Methods (weak order 2)
- `DRI1`, `DRI1NM` - Debrabant-Roessler methods for Ito SDEs
- `RI1`, `RI3`, `RI5`, `RI6` - Roessler weak order 2 methods for Ito SDEs
- `RDI1WM`, `RDI2WM`, `RDI3WM`, `RDI4WM` - Roessler-Debrabant methods

### Stratonovich Weak Methods
- `RS1`, `RS2` - Roessler weak order 2 methods for Stratonovich SDEs

### Platen Methods
- `PL1WM`, `PL1WMA` - Platen's weak order 2 method

### Komori-Burrage Methods
- `NON`, `NON2` - Komori non-commutative noise methods
- `COM` - Komori commutative noise method

### Semi-Implicit/Semi-Explicit
- `SIEA`, `SIEB` - Semi-implicit Euler type A/B
- `SMEA`, `SMEB` - Semi-implicit Milstein type A/B

### Tang-Xiao Methods
- `W2Ito1` - Weak order 2 Ito method

### Implicit Weak Methods
- `IRI1` - Implicit Roessler weak order 2 (drift-implicit)

## Example

```julia
using StochasticDiffEqWeak
f(u, p, t) = 1.01 * u
g(u, p, t) = 0.87 * u
u0 = 0.5
tspan = (0.0, 1.0)
prob = SDEProblem(f, g, u0, tspan)
sol = solve(prob, DRI1())
```

## Available Solvers

For the full list of available SDE solvers, refer to the [DifferentialEquations.jl SDE Solvers](https://docs.sciml.ai/DiffEqDocs/stable/solvers/sde_solve/) documentation.

################################################################################
# Implicit Weak Order 2 SRK Caches
# These caches are for drift-implicit versions of weak order 2 SRK methods

"""
    IRI1ConstantCache

Constant cache for the IRI1 (Implicit Rößler 1) method.
Contains the nlsolver for implicit drift treatment and the RI1 tableau coefficients.
"""
mutable struct IRI1ConstantCache{N, T, T2} <: StochasticDiffEqConstantCache
    nlsolver::N
    # RI1 Tableau coefficients (same as DRI1ConstantCache but stored directly)
    a021::T
    a031::T
    a032::T
    a121::T
    a131::T
    b021::T
    b031::T
    b121::T
    b131::T
    b221::T
    b222::T
    b223::T
    b231::T
    b232::T
    b233::T
    α1::T
    α2::T
    α3::T
    c02::T2
    c03::T2
    c12::T2
    c13::T2
    beta11::T
    beta12::T
    beta13::T
    beta22::T
    beta23::T
    beta31::T
    beta32::T
    beta33::T
    beta42::T
    beta43::T
    NORMAL_ONESIX_QUANTILE::T
end

function IRI1ConstantCache(nlsolver::N, ::Type{T}, ::Type{T2}) where {N, T, T2}
    # RI1 coefficients from the original RI1ConstantCache function
    a021 = convert(T, 2 // 3)
    a031 = convert(T, -1 // 3)
    a032 = convert(T, 1)

    a121 = convert(T, 1)
    a131 = convert(T, 1)

    b021 = convert(T, 1)
    b031 = convert(T, 0)

    b121 = convert(T, 1)
    b131 = convert(T, -1)

    b221 = convert(T, 1)
    b222 = convert(T, 0)
    b223 = convert(T, 0)
    b231 = convert(T, -1)
    b232 = convert(T, 0)
    b233 = convert(T, 0)

    α1 = convert(T, 1 // 4)
    α2 = convert(T, 1 // 2)
    α3 = convert(T, 1 // 4)

    c02 = convert(T2, 2 // 3)
    c03 = convert(T2, 2 // 3)

    c12 = convert(T2, 1)
    c13 = convert(T2, 1)

    beta11 = convert(T, 1 // 2)
    beta12 = convert(T, 1 // 4)
    beta13 = convert(T, 1 // 4)

    beta22 = convert(T, 1 // 2)
    beta23 = convert(T, -1 // 2)

    beta31 = convert(T, -1 // 2)
    beta32 = convert(T, 1 // 4)
    beta33 = convert(T, 1 // 4)

    beta42 = convert(T, 1 // 2)
    beta43 = convert(T, -1 // 2)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return IRI1ConstantCache(
        nlsolver, a021, a031, a032, a121, a131, b021, b031, b121, b131,
        b221, b222, b223, b231, b232, b233, α1, α2, α3, c02, c03, c12, c13,
        beta11, beta12, beta13, beta22, beta23, beta31, beta32, beta33, beta42, beta43,
        NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::IRI1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    γ, c = alg.theta, zero(t)
    nlsolver = OrdinaryDiffEqNonlinearSolve.build_nlsolver(
        alg, u, uprev, p, t, dt, f, rate_prototype, uEltypeNoUnits,
        uBottomEltypeNoUnits, tTypeNoUnits, γ, c, Val(false), verbose
    )
    return IRI1ConstantCache(nlsolver, real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

# IRI1Cache: Mutable cache for the IRI1 (Implicit Rößler 1) method (in-place version).
# Contains all the working arrays needed for the implicit weak order 2 SRK method.
@cache mutable struct IRI1Cache{
        uType, randType, rateNoiseType, rateType, noUnitsType, N, T, T2,
    } <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    uhat::uType
    _dW::randType
    _dZ::randType
    chi1::randType
    g1::rateNoiseType
    g2::Vector{rateNoiseType}
    g3::Vector{rateNoiseType}
    k1::rateType
    k2::rateType
    k3::rateType
    H02::uType
    H03::uType
    H12::Vector{uType}
    H13::Vector{uType}
    H22::Vector{uType}
    H23::Vector{uType}
    tmp::uType
    tmpg::rateNoiseType
    resids::noUnitsType
    nlsolver::N
    a021::T
    a031::T
    a032::T
    a121::T
    a131::T
    b021::T
    b031::T
    b121::T
    b131::T
    b221::T
    b222::T
    b223::T
    b231::T
    b232::T
    b233::T
    α1::T
    α2::T
    α3::T
    c02::T2
    c03::T2
    c12::T2
    c13::T2
    beta11::T
    beta12::T
    beta13::T
    beta22::T
    beta23::T
    beta31::T
    beta32::T
    beta33::T
    beta42::T
    beta43::T
    NORMAL_ONESIX_QUANTILE::T
end

function alg_cache(
        alg::IRI1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    T = real(uBottomEltypeNoUnits)
    T2 = real(tTypeNoUnits)

    # Build nonlinear solver
    γ, c = alg.theta, zero(t)
    nlsolver = OrdinaryDiffEqNonlinearSolve.build_nlsolver(
        alg, u, uprev, p, t, dt, f, rate_prototype, uEltypeNoUnits,
        uBottomEltypeNoUnits, tTypeNoUnits, γ, c, Val(true), verbose
    )

    # Allocate arrays
    uhat = zero(u)

    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = ΔZ === nothing ? nothing : copy(ΔZ)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = ΔZ === nothing ? nothing : zero(ΔZ)
        chi1 = zero(ΔW)
    end

    m = is_diagonal_noise(prob) ? length(ΔW) : size(noise_rate_prototype, 2)

    g1 = zero(noise_rate_prototype)
    g2 = [zero(noise_rate_prototype) for _ in 1:m]
    g3 = [zero(noise_rate_prototype) for _ in 1:m]

    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)

    H02 = zero(u)
    H03 = zero(u)
    H12 = [zero(u) for _ in 1:m]
    H13 = [zero(u) for _ in 1:m]
    H22 = [zero(u) for _ in 1:m]
    H23 = [zero(u) for _ in 1:m]

    tmp = zero(u)
    tmpg = zero(noise_rate_prototype)
    resids = fill!(similar(u, uEltypeNoUnits), zero(uEltypeNoUnits))

    # RI1 coefficients
    a021 = convert(T, 2 // 3)
    a031 = convert(T, -1 // 3)
    a032 = convert(T, 1)
    a121 = convert(T, 1)
    a131 = convert(T, 1)
    b021 = convert(T, 1)
    b031 = convert(T, 0)
    b121 = convert(T, 1)
    b131 = convert(T, -1)
    b221 = convert(T, 1)
    b222 = convert(T, 0)
    b223 = convert(T, 0)
    b231 = convert(T, -1)
    b232 = convert(T, 0)
    b233 = convert(T, 0)
    α1 = convert(T, 1 // 4)
    α2 = convert(T, 1 // 2)
    α3 = convert(T, 1 // 4)
    c02 = convert(T2, 2 // 3)
    c03 = convert(T2, 2 // 3)
    c12 = convert(T2, 1)
    c13 = convert(T2, 1)
    beta11 = convert(T, 1 // 2)
    beta12 = convert(T, 1 // 4)
    beta13 = convert(T, 1 // 4)
    beta22 = convert(T, 1 // 2)
    beta23 = convert(T, -1 // 2)
    beta31 = convert(T, -1 // 2)
    beta32 = convert(T, 1 // 4)
    beta33 = convert(T, 1 // 4)
    beta42 = convert(T, 1 // 2)
    beta43 = convert(T, -1 // 2)
    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return IRI1Cache(
        u, uprev, uhat, _dW, _dZ, chi1, g1, g2, g3, k1, k2, k3,
        H02, H03, H12, H13, H22, H23, tmp, tmpg, resids, nlsolver,
        a021, a031, a032, a121, a131, b021, b031, b121, b131,
        b221, b222, b223, b231, b232, b233, α1, α2, α3, c02, c03, c12, c13,
        beta11, beta12, beta13, beta22, beta23, beta31, beta32, beta33, beta42, beta43,
        NORMAL_ONESIX_QUANTILE
    )
end

"""
 Tests for  https://link.springer.com/article/10.1007/s10543-007-0130-3 with test problems as in the paper.
 RS1, RS2
 and for https://www.sciencedirect.com/science/article/pii/S0377042706003906
 NON, COM, NON2
"""

import Statistics # for mean values of trajectories
import LinearAlgebra # for the normn
using StochasticDiffEqWeak
using Test
using Random
using DiffEqDevTools
#using DiffEqGPU

seed = 137475

function prob_func(prob, i, repeat)
    return remake(prob, seed = seeds[i])
end

"""
 Test non-commutative noise SDEs (iip)
"""

@info "Non-commutative noise"

u₀ = [0.1, 0.1]
function f2!(du, u, p, t)
    du[1] = 5 // 4 * u[2] - 5 // 4 * u[1]
    return du[2] = 1 // 4 * u[1] - 1 // 4 * u[2]
end
function g2!(du, u, p, t)
    du[1, 1] = sqrt(3) / 2 * (u[1] - u[2])
    du[1, 2] = 1 // 2 * (u[1] + u[2])
    #du[2,1] = 0
    return du[2, 2] = u[1]
end
dts = 1 .// 2 .^ (4:-1:1)
tspan = (0.0, 1.0)

h2(z) = z^2 # E(x_i) = 1/10 exp(1/2t) or E(x_1* x_2) = 1/100 exp(2t)

prob = SDEProblem(f2!, g2!, u₀, tspan, noise_rate_prototype = zeros(2, 2))
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h2(sol.u[end][1]), false),
    prob_func = prob_func
)

numtraj = Int(1.0e8)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RS1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(2)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RS1:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, RS2(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(2)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RS2:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, NON(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(2)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("NON:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, NON2(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(2)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("NON2:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e8)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, COM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(2)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("COM:", sim.𝒪est[:weak_final])
# COM tests are passing; problem might be not hard enough..

################################################################################
# Roessler SRK for second order weak approx

struct DRI1ConstantCache{T, T2} <: StochasticDiffEqConstantCache
    # hard-coded version
    a021::T
    a031::T
    a032::T

    a121::T
    a131::T
    #a132::T

    #a221::T
    #a231::T
    #a232::T

    b021::T
    b031::T
    #b032::T

    b121::T
    b131::T
    #b132::T

    b221::T
    b222::T
    b223::T
    b231::T
    b232::T
    b233::T

    α1::T
    α2::T
    α3::T

    c02::T2
    c03::T2

    #c11::T2
    c12::T2
    c13::T2

    #c21::T2
    #c22::T2
    #c23::T2

    beta11::T
    beta12::T
    beta13::T

    #beta21::T
    beta22::T
    beta23::T

    beta31::T
    beta32::T
    beta33::T

    #beta41::T
    beta42::T
    beta43::T

    #quantile(Normal(),1/6)
    NORMAL_ONESIX_QUANTILE::T
end

function DRI1ConstantCache(::Type{T}, ::Type{T2}) where {T, T2}
    a021 = convert(T, 1 // 2)
    a031 = convert(T, -1)
    a032 = convert(T, 2)

    a121 = convert(T, 342 // 491)
    a131 = convert(T, 342 // 491)

    b021 = convert(T, (6 - sqrt(6)) / 10)
    b031 = convert(T, (3 + 2 * sqrt(6)) / 5)

    b121 = convert(T, 3 * sqrt(38 // 491))
    b131 = convert(T, -3 * sqrt(38 / 491))

    b221 = convert(T, -214 // 513 * sqrt(1105 // 991))
    b222 = convert(T, -491 // 513 * sqrt(221 // 4955))
    b223 = convert(T, -491 // 513 * sqrt(221 // 4955))
    b231 = convert(T, 214 // 513 * sqrt(1105 // 991))
    b232 = convert(T, 491 // 513 * sqrt(221 // 4955))
    b233 = convert(T, 491 // 513 * sqrt(221 // 4955))

    α1 = convert(T, 1 // 6)
    α2 = convert(T, 2 // 3)
    α3 = convert(T, 1 // 6)

    c02 = convert(T2, 1 // 2)
    c03 = convert(T2, 1)

    c12 = convert(T2, 342 // 491)
    c13 = convert(T2, 342 // 491)

    beta11 = convert(T, 193 // 684)
    beta12 = convert(T, 491 // 1368)
    beta13 = convert(T, 491 // 1368)

    beta22 = convert(T, 1 // 6 * sqrt(491 // 38))
    beta23 = convert(T, -1 // 6 * sqrt(491 // 38))

    beta31 = convert(T, -4955 // 7072)
    beta32 = convert(T, 4955 // 14144)
    beta33 = convert(T, 4955 // 14144)

    beta42 = convert(T, -1 // 8 * sqrt(4955 // 221))
    beta43 = convert(T, 1 // 8 * sqrt(4955 // 221))

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return DRI1ConstantCache(
        a021, a031, a032, a121, a131, b021, b031, b121, b131, b221, b222, b223, b231,
        b232, b233, α1, α2, α3, c02, c03, c12, c13, beta11, beta12, beta13, beta22,
        beta23, beta31, beta32, beta33, beta42, beta43, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::DRI1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return DRI1ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function RI1ConstantCache(T::Type, T2::Type)
    a021 = convert(T, 2 // 3) # convert(T, 2//3)
    a031 = convert(T, -1 // 3)
    a032 = convert(T, 1)

    a121 = convert(T, 1)
    a131 = convert(T, 1)

    b021 = convert(T, 1)
    b031 = convert(T, 0)

    b121 = convert(T, 1)
    b131 = convert(T, -1)

    b221 = convert(T, 1)
    b222 = convert(T, 0)
    b223 = convert(T, 0)
    b231 = convert(T, -1)
    b232 = convert(T, 0)
    b233 = convert(T, 0)

    α1 = convert(T, 1 // 4)
    α2 = convert(T, 1 // 2)
    α3 = convert(T, 1 // 4)

    c02 = convert(T2, 2 // 3)
    c03 = convert(T2, 2 // 3)

    c12 = convert(T2, 1)
    c13 = convert(T2, 1)

    beta11 = convert(T, 1 // 2)
    beta12 = convert(T, 1 // 4)
    beta13 = convert(T, 1 // 4)

    beta22 = convert(T, 1 // 2)
    beta23 = convert(T, -1 // 2)

    beta31 = convert(T, -1 // 2)
    beta32 = convert(T, 1 // 4)
    beta33 = convert(T, 1 // 4)

    beta42 = convert(T, 1 // 2)
    beta43 = convert(T, -1 // 2)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return DRI1ConstantCache(
        a021, a031, a032, a121, a131, b021, b031, b121, b131, b221, b222, b223, b231,
        b232, b233, α1, α2, α3, c02, c03, c12, c13, beta11, beta12, beta13, beta22,
        beta23, beta31, beta32, beta33, beta42, beta43, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::RI1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return RI1ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function RI3ConstantCache(T::Type, T2::Type)
    a021 = convert(T, 1)
    a031 = convert(T, 1 // 4)
    a032 = convert(T, 1 // 4)

    a121 = convert(T, 1)
    a131 = convert(T, 1)

    b021 = convert(T, (3 - 2 * sqrt(6)) / 5)
    b031 = convert(T, (6 + sqrt(6)) / 10)

    b121 = convert(T, 1)
    b131 = convert(T, -1)

    b221 = convert(T, 1)
    b222 = convert(T, 0)
    b223 = convert(T, 0)
    b231 = convert(T, -1)
    b232 = convert(T, 0)
    b233 = convert(T, 0)

    α1 = convert(T, 1 // 6)
    α2 = convert(T, 1 // 6)
    α3 = convert(T, 2 // 3)

    c02 = convert(T2, 1)
    c03 = convert(T2, 1 // 2)

    c12 = convert(T2, 1)
    c13 = convert(T2, 1)

    beta11 = convert(T, 1 // 2)
    beta12 = convert(T, 1 // 4)
    beta13 = convert(T, 1 // 4)

    beta22 = convert(T, 1 // 2)
    beta23 = convert(T, -1 // 2)

    beta31 = convert(T, -1 // 2)
    beta32 = convert(T, 1 // 4)
    beta33 = convert(T, 1 // 4)

    beta42 = convert(T, 1 // 2)
    beta43 = convert(T, -1 // 2)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return DRI1ConstantCache(
        a021, a031, a032, a121, a131, b021, b031, b121, b131, b221, b222, b223, b231,
        b232, b233, α1, α2, α3, c02, c03, c12, c13, beta11, beta12, beta13, beta22,
        beta23, beta31, beta32, beta33, beta42, beta43, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::RI3, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return RI3ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function RI5ConstantCache(T::Type, T2::Type)
    a021 = convert(T, 1)
    a031 = convert(T, 25 // 144)
    a032 = convert(T, 35 // 144)

    a121 = convert(T, 1 // 4)
    a131 = convert(T, 1 // 4)

    b021 = convert(T, 1 // 3)
    b031 = convert(T, -5 // 6)

    b121 = convert(T, 1 // 2)
    b131 = convert(T, -1 // 2)

    b221 = convert(T, 1)
    b222 = convert(T, 0)
    b223 = convert(T, 0)
    b231 = convert(T, -1)
    b232 = convert(T, 0)
    b233 = convert(T, 0)

    α1 = convert(T, 1 // 10)
    α2 = convert(T, 3 // 14)
    α3 = convert(T, 24 // 35)

    c02 = convert(T2, 1)
    c03 = convert(T2, 5 // 12)

    c12 = convert(T2, 1 // 4)
    c13 = convert(T2, 1 // 4)

    beta11 = convert(T, 1)
    beta12 = convert(T, -1)
    beta13 = convert(T, -1)

    beta22 = convert(T, 1)
    beta23 = convert(T, -1)

    beta31 = convert(T, 1 // 2)
    beta32 = convert(T, -1 // 4)
    beta33 = convert(T, -1 // 4)

    beta42 = convert(T, 1 // 2)
    beta43 = convert(T, -1 // 2)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return DRI1ConstantCache(
        a021, a031, a032, a121, a131, b021, b031, b121, b131, b221, b222, b223, b231,
        b232, b233, α1, α2, α3, c02, c03, c12, c13, beta11, beta12, beta13, beta22,
        beta23, beta31, beta32, beta33, beta42, beta43, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::RI5, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return RI5ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function RI6ConstantCache(T::Type, T2::Type)
    a021 = convert(T, 1)
    a031 = convert(T, 0)
    a032 = convert(T, 0)

    a121 = convert(T, 1)
    a131 = convert(T, 1)

    b021 = convert(T, 1)
    b031 = convert(T, 0)

    b121 = convert(T, 1)
    b131 = convert(T, -1)

    b221 = convert(T, 1)
    b222 = convert(T, 0)
    b223 = convert(T, 0)
    b231 = convert(T, -1)
    b232 = convert(T, 0)
    b233 = convert(T, 0)

    α1 = convert(T, 1 // 2)
    α2 = convert(T, 1 // 2)
    α3 = convert(T, 0)

    c02 = convert(T2, 1)
    c03 = convert(T2, 0)

    c12 = convert(T2, 1)
    c13 = convert(T2, 1)

    beta11 = convert(T, 1 // 2)
    beta12 = convert(T, 1 // 4)
    beta13 = convert(T, 1 // 4)

    beta22 = convert(T, 1 // 2)
    beta23 = convert(T, -1 // 2)

    beta31 = convert(T, -1 // 2)
    beta32 = convert(T, 1 // 4)
    beta33 = convert(T, 1 // 4)

    beta42 = convert(T, 1 // 2)
    beta43 = convert(T, -1 // 2)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return DRI1ConstantCache(
        a021, a031, a032, a121, a131, b021, b031, b121, b131, b221, b222, b223, b231,
        b232, b233, α1, α2, α3, c02, c03, c12, c13, beta11, beta12, beta13, beta22,
        beta23, beta31, beta32, beta33, beta42, beta43, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::RI6, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return RI6ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function RDI2WMConstantCache(T::Type, T2::Type)
    a021 = convert(T, 1)
    a031 = convert(T, 0)
    a032 = convert(T, 0)

    a121 = convert(T, 2 // 3)
    a131 = convert(T, 2 // 3)

    b021 = convert(T, 1)
    b031 = convert(T, 0)

    b121 = convert(T, sqrt(2 // 3))
    b131 = convert(T, -sqrt(2 // 3))

    b221 = convert(T, sqrt(2))
    b222 = convert(T, 0)
    b223 = convert(T, 0)
    b231 = convert(T, -sqrt(2))
    b232 = convert(T, 0)
    b233 = convert(T, 0)

    α1 = convert(T, 1 // 2)
    α2 = convert(T, 1 // 2)
    α3 = convert(T, 0)

    c02 = convert(T2, 1)
    c03 = convert(T2, 0)

    c12 = convert(T2, 2 // 3)
    c13 = convert(T2, 2 // 3)

    beta11 = convert(T, 1 // 4)
    beta12 = convert(T, 3 // 8)
    beta13 = convert(T, 3 // 8)

    beta22 = convert(T, sqrt(6) / 4)
    beta23 = convert(T, -sqrt(6) / 4)

    beta31 = convert(T, -1 // 4)
    beta32 = convert(T, 1 // 8)
    beta33 = convert(T, 1 // 8)

    beta42 = convert(T, sqrt(2) / 4)
    beta43 = convert(T, -sqrt(2) / 4)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return DRI1ConstantCache(
        a021, a031, a032, a121, a131, b021, b031, b121, b131, b221, b222, b223, b231,
        b232, b233, α1, α2, α3, c02, c03, c12, c13, beta11, beta12, beta13, beta22,
        beta23, beta31, beta32, beta33, beta42, beta43, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::RDI2WM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return RDI2WMConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function RDI3WMConstantCache(T::Type, T2::Type)
    a021 = convert(T, 1 // 2)
    a031 = convert(T, 0)
    a032 = convert(T, 3 // 4)

    a121 = convert(T, 2 // 3)
    a131 = convert(T, 2 // 3)

    b021 = convert(T, (9 - 2 * sqrt(15)) / 14)
    b031 = convert(T, (18 + 3 * sqrt(15)) / 28)

    b121 = convert(T, sqrt(2 // 3))
    b131 = convert(T, -sqrt(2 // 3))

    b221 = convert(T, sqrt(2))
    b222 = convert(T, 0)
    b223 = convert(T, 0)
    b231 = convert(T, -sqrt(2))
    b232 = convert(T, 0)
    b233 = convert(T, 0)

    α1 = convert(T, 2 // 9)
    α2 = convert(T, 1 // 3)
    α3 = convert(T, 4 // 9)

    c02 = convert(T2, 1 // 2)
    c03 = convert(T2, 3 // 4)

    c12 = convert(T2, 2 // 3)
    c13 = convert(T2, 2 // 3)

    beta11 = convert(T, 1 // 4)
    beta12 = convert(T, 3 // 8)
    beta13 = convert(T, 3 // 8)

    beta22 = convert(T, sqrt(6) / 4)
    beta23 = convert(T, -sqrt(6) / 4)

    beta31 = convert(T, -1 // 4)
    beta32 = convert(T, 1 // 8)
    beta33 = convert(T, 1 // 8)

    beta42 = convert(T, sqrt(2) / 4)
    beta43 = convert(T, -sqrt(2) / 4)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return DRI1ConstantCache(
        a021, a031, a032, a121, a131, b021, b031, b121, b131, b221, b222, b223, b231,
        b232, b233, α1, α2, α3, c02, c03, c12, c13, beta11, beta12, beta13, beta22,
        beta23, beta31, beta32, beta33, beta42, beta43, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::RDI3WM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return RDI3WMConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function RDI4WMConstantCache(T::Type, T2::Type)
    a021 = convert(T, 1 // 2)
    a031 = convert(T, -1)
    a032 = convert(T, 2)

    a121 = convert(T, 2 // 3)
    a131 = convert(T, 2 // 3)

    b021 = convert(T, (6 - sqrt(6)) / 10)
    b031 = convert(T, (3 + 2 * sqrt(6)) / 5)

    b121 = convert(T, sqrt(2 // 3))
    b131 = convert(T, -sqrt(2 // 3))

    b221 = convert(T, sqrt(2))
    b222 = convert(T, 0)
    b223 = convert(T, 0)
    b231 = convert(T, -sqrt(2))
    b232 = convert(T, 0)
    b233 = convert(T, 0)

    α1 = convert(T, 1 // 6)
    α2 = convert(T, 2 // 3)
    α3 = convert(T, 1 // 6)

    c02 = convert(T2, 1 // 2)
    c03 = convert(T2, 1)

    c12 = convert(T2, 2 // 3)
    c13 = convert(T2, 2 // 3)

    beta11 = convert(T, 1 // 4)
    beta12 = convert(T, 3 // 8)
    beta13 = convert(T, 3 // 8)

    beta22 = convert(T, sqrt(6) / 4)
    beta23 = convert(T, -sqrt(6) / 4)

    beta31 = convert(T, -1 // 4)
    beta32 = convert(T, 1 // 8)
    beta33 = convert(T, 1 // 8)

    beta42 = convert(T, sqrt(2) / 4)
    beta43 = convert(T, -sqrt(2) / 4)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return DRI1ConstantCache(
        a021, a031, a032, a121, a131, b021, b031, b121, b131, b221, b222, b223, b231,
        b232, b233, α1, α2, α3, c02, c03, c12, c13, beta11, beta12, beta13, beta22,
        beta23, beta31, beta32, beta33, beta42, beta43, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::RDI4WM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return RDI4WMConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

@cache struct DRI1Cache{
        uType, randType, tabType, rateNoiseType, rateType, possibleRateType,
    } <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    uhat::uType

    _dW::randType
    _dZ::randType
    chi1::randType

    tab::tabType

    g1::rateNoiseType
    g2::Vector{rateNoiseType}
    g3::Vector{rateNoiseType}

    k1::rateType
    k2::rateType
    k3::rateType

    H02::uType
    H03::uType
    H12::Vector{uType}
    H13::Vector{uType}
    H22::Vector{uType}
    H23::Vector{uType}

    tmp1::possibleRateType
    tmpg::rateNoiseType

    tmp::uType
    resids::uType
end

@cache struct DRI1NMCache{
        uType, randType, tabType, rateNoiseType, rateType, possibleRateType,
    } <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    uhat::uType

    _dW::randType
    chi1::randType

    tab::tabType

    g1::rateNoiseType
    g2::rateNoiseType
    g3::rateNoiseType

    k1::rateType
    k2::rateType
    k3::rateType

    H02::uType
    H03::uType
    H12::rateNoiseType
    H13::rateNoiseType

    tmp1::possibleRateType
    tmpg::rateNoiseType

    tmp::uType
    resids::uType
end

function alg_cache(
        alg::DRI1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = DRI1ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = [zero(noise_rate_prototype) for k in 1:m]
    g3 = [zero(noise_rate_prototype) for k in 1:m]
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)

    H02 = zero(u)
    H03 = zero(u)
    H12 = Vector{typeof(u)}()
    H13 = Vector{typeof(u)}()
    H22 = Vector{typeof(u)}()
    H23 = Vector{typeof(u)}()

    for k in 1:m
        push!(H12, zero(u))
        push!(H13, zero(u))
        push!(H22, zero(u))
        push!(H23, zero(u))
    end

    tmp1 = zero(rate_prototype)
    tmpg = zero(noise_rate_prototype)

    uhat = copy(uprev)
    tmp = zero(u)
    resids = zero(u)

    return DRI1Cache(
        u, uprev, uhat, _dW, _dZ, chi1, tab, g1, g2, g3, k1, k2,
        k3, H02, H03, H12, H13, H22, H23, tmp1, tmpg, tmp, resids
    )
end

function alg_cache(
        alg::DRI1NM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = DRI1ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = zero(noise_rate_prototype)
    g3 = zero(noise_rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)

    H02 = zero(u)
    H03 = zero(u)
    H12 = zero(noise_rate_prototype)
    H13 = zero(noise_rate_prototype)
    #H22 = zero(noise_rate_prototype)
    #H23 = zero(noise_rate_prototype)

    tmp1 = zero(rate_prototype)
    tmpg = zero(noise_rate_prototype)

    uhat = copy(uprev)
    tmp = zero(u)
    resids = zero(u)

    return DRI1NMCache(
        u, uprev, uhat, _dW, chi1, tab, g1, g2, g3, k1, k2,
        k3, H02, H03, H12, H13, tmp1, tmpg, tmp, resids
    )
end

function alg_cache(
        alg::RI1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = RI1ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = [zero(noise_rate_prototype) for k in 1:m]
    g3 = [zero(noise_rate_prototype) for k in 1:m]
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)

    H02 = zero(u)
    H03 = zero(u)
    H12 = Vector{typeof(u)}()
    H13 = Vector{typeof(u)}()
    H22 = Vector{typeof(u)}()
    H23 = Vector{typeof(u)}()

    for k in 1:m
        push!(H12, zero(u))
        push!(H13, zero(u))
        push!(H22, zero(u))
        push!(H23, zero(u))
    end

    tmp1 = zero(rate_prototype)
    tmpg = zero(noise_rate_prototype)

    uhat = copy(uprev)
    tmp = zero(u)
    resids = zero(u)

    return DRI1Cache(
        u, uprev, uhat, _dW, _dZ, chi1, tab, g1, g2, g3, k1, k2,
        k3, H02, H03, H12, H13, H22, H23, tmp1, tmpg, tmp, resids
    )
end

function alg_cache(
        alg::RI3, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = RI3ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = [zero(noise_rate_prototype) for k in 1:m]
    g3 = [zero(noise_rate_prototype) for k in 1:m]
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)

    H02 = zero(u)
    H03 = zero(u)
    H12 = Vector{typeof(u)}()
    H13 = Vector{typeof(u)}()
    H22 = Vector{typeof(u)}()
    H23 = Vector{typeof(u)}()

    for k in 1:m
        push!(H12, zero(u))
        push!(H13, zero(u))
        push!(H22, zero(u))
        push!(H23, zero(u))
    end

    tmp1 = zero(rate_prototype)
    tmpg = zero(noise_rate_prototype)

    uhat = copy(uprev)
    tmp = zero(u)
    resids = zero(u)

    return DRI1Cache(
        u, uprev, uhat, _dW, _dZ, chi1, tab, g1, g2, g3, k1, k2,
        k3, H02, H03, H12, H13, H22, H23, tmp1, tmpg, tmp, resids
    )
end

function alg_cache(
        alg::RI5, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = RI5ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = [zero(noise_rate_prototype) for k in 1:m]
    g3 = [zero(noise_rate_prototype) for k in 1:m]
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)

    H02 = zero(u)
    H03 = zero(u)
    H12 = Vector{typeof(u)}()
    H13 = Vector{typeof(u)}()
    H22 = Vector{typeof(u)}()
    H23 = Vector{typeof(u)}()

    for k in 1:m
        push!(H12, zero(u))
        push!(H13, zero(u))
        push!(H22, zero(u))
        push!(H23, zero(u))
    end

    tmp1 = zero(rate_prototype)
    tmpg = zero(noise_rate_prototype)

    uhat = copy(uprev)
    tmp = zero(u)
    resids = zero(u)

    return DRI1Cache(
        u, uprev, uhat, _dW, _dZ, chi1, tab, g1, g2, g3, k1, k2,
        k3, H02, H03, H12, H13, H22, H23, tmp1, tmpg, tmp, resids
    )
end

function alg_cache(
        alg::RI6, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = RI6ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = [zero(noise_rate_prototype) for k in 1:m]
    g3 = [zero(noise_rate_prototype) for k in 1:m]
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)

    H02 = zero(u)
    H03 = zero(u)
    H12 = Vector{typeof(u)}()
    H13 = Vector{typeof(u)}()
    H22 = Vector{typeof(u)}()
    H23 = Vector{typeof(u)}()

    for k in 1:m
        push!(H12, zero(u))
        push!(H13, zero(u))
        push!(H22, zero(u))
        push!(H23, zero(u))
    end

    tmp1 = zero(rate_prototype)
    tmpg = zero(noise_rate_prototype)

    uhat = copy(uprev)
    tmp = zero(u)
    resids = zero(u)

    return DRI1Cache(
        u, uprev, uhat, _dW, _dZ, chi1, tab, g1, g2, g3, k1, k2,
        k3, H02, H03, H12, H13, H22, H23, tmp1, tmpg, tmp, resids
    )
end

function alg_cache(
        alg::RDI2WM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = RDI2WMConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = [zero(noise_rate_prototype) for k in 1:m]
    g3 = [zero(noise_rate_prototype) for k in 1:m]
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)

    H02 = zero(u)
    H03 = zero(u)
    H12 = Vector{typeof(u)}()
    H13 = Vector{typeof(u)}()
    H22 = Vector{typeof(u)}()
    H23 = Vector{typeof(u)}()

    for k in 1:m
        push!(H12, zero(u))
        push!(H13, zero(u))
        push!(H22, zero(u))
        push!(H23, zero(u))
    end

    tmp1 = zero(rate_prototype)
    tmpg = zero(noise_rate_prototype)

    uhat = copy(uprev)
    tmp = zero(u)
    resids = zero(u)

    return DRI1Cache(
        u, uprev, uhat, _dW, _dZ, chi1, tab, g1, g2, g3, k1, k2,
        k3, H02, H03, H12, H13, H22, H23, tmp1, tmpg, tmp, resids
    )
end

function alg_cache(
        alg::RDI3WM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = RDI3WMConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = [zero(noise_rate_prototype) for k in 1:m]
    g3 = [zero(noise_rate_prototype) for k in 1:m]
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)

    H02 = zero(u)
    H03 = zero(u)
    H12 = Vector{typeof(u)}()
    H13 = Vector{typeof(u)}()
    H22 = Vector{typeof(u)}()
    H23 = Vector{typeof(u)}()

    for k in 1:m
        push!(H12, zero(u))
        push!(H13, zero(u))
        push!(H22, zero(u))
        push!(H23, zero(u))
    end

    tmp1 = zero(rate_prototype)
    tmpg = zero(noise_rate_prototype)

    uhat = copy(uprev)
    tmp = zero(u)
    resids = zero(u)

    return DRI1Cache(
        u, uprev, uhat, _dW, _dZ, chi1, tab, g1, g2, g3, k1, k2,
        k3, H02, H03, H12, H13, H22, H23, tmp1, tmpg, tmp, resids
    )
end

function alg_cache(
        alg::RDI4WM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = RDI4WMConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = [zero(noise_rate_prototype) for k in 1:m]
    g3 = [zero(noise_rate_prototype) for k in 1:m]
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)

    H02 = zero(u)
    H03 = zero(u)
    H12 = Vector{typeof(u)}()
    H13 = Vector{typeof(u)}()
    H22 = Vector{typeof(u)}()
    H23 = Vector{typeof(u)}()

    for k in 1:m
        push!(H12, zero(u))
        push!(H13, zero(u))
        push!(H22, zero(u))
        push!(H23, zero(u))
    end

    tmp1 = zero(rate_prototype)
    tmpg = zero(noise_rate_prototype)

    uhat = copy(uprev)
    tmp = zero(u)
    resids = zero(u)

    return DRI1Cache(
        u, uprev, uhat, _dW, _dZ, chi1, tab, g1, g2, g3, k1, k2,
        k3, H02, H03, H12, H13, H22, H23, tmp1, tmpg, tmp, resids
    )
end

# Roessler SRK for first order weak approx
struct RDI1WMConstantCache{T, T2} <: StochasticDiffEqConstantCache
    # hard-coded version
    a021::T

    #a121::T

    #a221::T

    b021::T

    #b121::T

    #b221::T

    α1::T
    α2::T

    c02::T2

    #c11::T2
    #c12::T2

    #c21::T2
    #c22::T2

    beta11::T
    #beta12::T

    #beta21::T
    #beta22::T

    #beta31::T
    #beta32::T

    #beta41::T
    #beta42::T

    #quantile(Normal(),1/6)
    NORMAL_ONESIX_QUANTILE::T
end

function RDI1WMConstantCache(::Type{T}, ::Type{T2}) where {T, T2}
    a021 = convert(T, 2 // 3)

    b021 = convert(T, 2 // 3)

    α1 = convert(T, 1 // 4)
    α2 = convert(T, 3 // 4)

    c02 = convert(T2, 2 // 3)

    beta11 = convert(T, 1)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return RDI1WMConstantCache(a021, b021, α1, α2, c02, beta11, NORMAL_ONESIX_QUANTILE)
end

function alg_cache(
        alg::RDI1WM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return RDI1WMConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

@cache struct RDI1WMCache{
        uType, randType, tabType, rateNoiseType, rateType, possibleRateType,
    } <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType

    _dW::randType
    chi1::randType

    tab::tabType

    g1::rateNoiseType

    k1::rateType
    k2::rateType

    H02::uType

    tmp1::possibleRateType
end

function alg_cache(
        alg::RDI1WM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = RDI1WMConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)

    H02 = zero(u)

    tmp1 = zero(rate_prototype)

    return RDI1WMCache(u, uprev, _dW, chi1, tab, g1, k1, k2, H02, tmp1)
end

# Stratonovich sense

struct RSConstantCache{T, T2} <: StochasticDiffEqConstantCache
    # hard-coded version
    a021::T
    a031::T
    a032::T

    a131::T
    a141::T

    b031::T
    b032::T

    b121::T
    b131::T
    b132::T
    b141::T
    b142::T
    b143::T

    b221::T
    b231::T

    b331::T
    b332::T
    b341::T
    b342::T

    α1::T
    α2::T
    α3::T
    α4::T

    c02::T2
    c03::T2

    c13::T2
    c14::T2

    beta11::T
    beta12::T
    beta13::T
    beta14::T

    beta22::T
    beta23::T

    #quantile(Normal(),1/6)
    NORMAL_ONESIX_QUANTILE::T
end

function RS1ConstantCache(T::Type, T2::Type)
    a021 = convert(T, 0)
    a031 = convert(T, 1)
    a032 = convert(T, 0)

    a131 = convert(T, 1)
    a141 = convert(T, 1)

    b031 = convert(T, 1 // 4)
    b032 = convert(T, 3 // 4)

    b121 = convert(T, 2 // 3)
    b131 = convert(T, 1 // 12)
    b132 = convert(T, 1 // 4)
    b141 = convert(T, -5 // 4)
    b142 = convert(T, 1 // 4)
    b143 = convert(T, 2)

    b221 = convert(T, 1)
    b231 = convert(T, -1)

    b331 = convert(T, 1 // 4)
    b332 = convert(T, 3 // 4)
    b341 = convert(T, 1 // 4)
    b342 = convert(T, 3 // 4)

    α1 = convert(T, 0)
    α2 = convert(T, 0)
    α3 = convert(T, 1 // 2)
    α4 = convert(T, 1 // 2)

    c02 = convert(T2, 0)
    c03 = convert(T2, 1)

    c13 = convert(T2, 1)
    c14 = convert(T2, 1)

    beta11 = convert(T, 1 // 8)
    beta12 = convert(T, 3 // 8)
    beta13 = convert(T, 3 // 8)
    beta14 = convert(T, 1 // 8)

    beta22 = convert(T, -1 // 4)
    beta23 = convert(T, 1 // 4)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return RSConstantCache(
        a021, a031, a032, a131, a141, b031, b032, b121, b131, b132, b141, b142, b143,
        b221, b231, b331, b332, b341, b342, α1, α2, α3, α4, c02, c03, c13, c14,
        beta11, beta12, beta13, beta14, beta22, beta23, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::RS1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return RS1ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function RS2ConstantCache(T::Type, T2::Type)
    a021 = convert(T, 2 // 3)
    a031 = convert(T, 1 // 6)
    a032 = convert(T, 1 // 2)

    a131 = convert(T, 1)
    a141 = convert(T, 1)

    b031 = convert(T, 1 // 4)
    b032 = convert(T, 3 // 4)

    b121 = convert(T, 2 // 3)
    b131 = convert(T, 1 // 12)
    b132 = convert(T, 1 // 4)
    b141 = convert(T, -5 // 4)
    b142 = convert(T, 1 // 4)
    b143 = convert(T, 2)

    b221 = convert(T, 1)
    b231 = convert(T, -1)

    b331 = convert(T, 1 // 4)
    b332 = convert(T, 3 // 4)
    b341 = convert(T, 1 // 4)
    b342 = convert(T, 3 // 4)

    α1 = convert(T, 1 // 4)
    α2 = convert(T, 1 // 4)
    α3 = convert(T, 1 // 2)
    α4 = convert(T, 0)

    c02 = convert(T2, 2 // 3)
    c03 = convert(T2, 2 // 3)

    c13 = convert(T2, 1)
    c14 = convert(T2, 1)

    beta11 = convert(T, 1 // 8)
    beta12 = convert(T, 3 // 8)
    beta13 = convert(T, 3 // 8)
    beta14 = convert(T, 1 // 8)

    beta22 = convert(T, -1 // 4)
    beta23 = convert(T, 1 // 4)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return RSConstantCache(
        a021, a031, a032, a131, a141, b031, b032, b121, b131, b132, b141, b142, b143,
        b221, b231, b331, b332, b341, b342, α1, α2, α3, α4, c02, c03, c13, c14,
        beta11, beta12, beta13, beta14, beta22, beta23, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::RS2, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return RS2ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

@cache struct RSCache{
        uType, randType, tabType, rateNoiseType, rateType, possibleRateType,
    } <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType

    _dW::randType
    _dZ::randType
    chi1::randType

    tab::tabType

    g1::rateNoiseType
    g2::Vector{rateNoiseType}
    g3::Vector{rateNoiseType}
    g4::Vector{rateNoiseType}

    k1::rateType
    k2::rateType
    k3::rateType

    H02::uType
    H03::uType
    H12::Vector{uType}
    H13::Vector{uType}
    H14::Vector{uType}
    H22::Vector{uType}
    H23::Vector{uType}

    tmp1::possibleRateType
    tmpg::rateNoiseType
end

function alg_cache(
        alg::RS1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = RS1ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = [zero(noise_rate_prototype) for k in 1:m]
    g3 = [zero(noise_rate_prototype) for k in 1:m]
    g4 = [zero(noise_rate_prototype) for k in 1:m]
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)

    H02 = zero(u)
    H03 = zero(u)
    H12 = Vector{typeof(u)}()
    H13 = Vector{typeof(u)}()
    H14 = Vector{typeof(u)}()
    H22 = Vector{typeof(u)}()
    H23 = Vector{typeof(u)}()

    for k in 1:m
        push!(H12, zero(u))
        push!(H13, zero(u))
        push!(H14, zero(u))
        push!(H22, zero(u))
        push!(H23, zero(u))
    end

    tmp1 = zero(rate_prototype)
    tmpg = zero(noise_rate_prototype)

    return RSCache(
        u, uprev, _dW, _dZ, chi1, tab, g1, g2, g3, g4, k1, k2,
        k3, H02, H03, H12, H13, H14, H22, H23, tmp1, tmpg
    )
end

function alg_cache(
        alg::RS2, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = RS2ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = [zero(noise_rate_prototype) for k in 1:m]
    g3 = [zero(noise_rate_prototype) for k in 1:m]
    g4 = [zero(noise_rate_prototype) for k in 1:m]
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)

    H02 = zero(u)
    H03 = zero(u)
    H12 = Vector{typeof(u)}()
    H13 = Vector{typeof(u)}()
    H14 = Vector{typeof(u)}()
    H22 = Vector{typeof(u)}()
    H23 = Vector{typeof(u)}()

    for k in 1:m
        push!(H12, zero(u))
        push!(H13, zero(u))
        push!(H14, zero(u))
        push!(H22, zero(u))
        push!(H23, zero(u))
    end

    tmp1 = zero(rate_prototype)
    tmpg = zero(noise_rate_prototype)

    return RSCache(
        u, uprev, _dW, _dZ, chi1, tab, g1, g2, g3, g4, k1, k2,
        k3, H02, H03, H12, H13, H14, H22, H23, tmp1, tmpg
    )
end

# PL1WM
struct PL1WMConstantCache{T} <: StochasticDiffEqConstantCache
    #quantile(Normal(),1/6)
    NORMAL_ONESIX_QUANTILE::T
end

function PL1WMConstantCache(T::Type)
    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return PL1WMConstantCache(NORMAL_ONESIX_QUANTILE)
end

function alg_cache(
        alg::PL1WM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return PL1WMConstantCache(real(uBottomEltypeNoUnits))
end

struct PL1WMAConstantCache{T} <: StochasticDiffEqConstantCache
    #quantile(Normal(),1/6)
    NORMAL_ONESIX_QUANTILE::T
end

function PL1WMAConstantCache(T::Type)
    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return PL1WMAConstantCache(NORMAL_ONESIX_QUANTILE)
end

function alg_cache(
        alg::PL1WMA, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return PL1WMAConstantCache(real(uBottomEltypeNoUnits))
end

@cache struct PL1WMCache{
        uType, randType, rand2Type, tabType, rateNoiseType, rateType, possibleRateType,
    } <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType

    _dW::randType
    _dZ::rand2Type
    chi1::randType

    tab::tabType

    g1::rateNoiseType

    k1::rateType
    k2::rateType

    Y::uType
    Yp::Vector{uType}
    Ym::Vector{uType}

    tmp1::possibleRateType
    tmpg1::rateNoiseType
    tmpg2::rateNoiseType
    Ulp::uType
    Ulm::uType
end

function alg_cache(
        alg::PL1WM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = copy(ΔZ)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zero(ΔZ)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = PL1WMConstantCache(real(uBottomEltypeNoUnits))
    g1 = zero(noise_rate_prototype)

    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)

    Y = zero(u)
    Yp = Vector{typeof(u)}()
    Ym = Vector{typeof(u)}()

    for k in 1:m
        push!(Yp, zero(u))
        push!(Ym, zero(u))
    end

    tmp1 = zero(rate_prototype)
    tmpg1 = zero(noise_rate_prototype)
    tmpg2 = zero(noise_rate_prototype)

    Ulp = zero(u)
    Ulm = zero(u)

    return PL1WMCache(
        u, uprev, _dW, _dZ, chi1, tab, g1, k1, k2, Y, Yp, Ym, tmp1, tmpg1, tmpg2, Ulp, Ulm
    )
end

# additive noise
@cache struct PL1WMACache{
        uType, randType, tabType, rateNoiseType, rateType, possibleRateType,
    } <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType

    _dW::randType
    chi1::randType
    tab::tabType

    g1::rateNoiseType
    k1::rateType
    k2::rateType

    Y::uType
    tmp1::possibleRateType
end

function alg_cache(
        alg::PL1WMA, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        chi1 = zero(ΔW)
    end

    tab = PL1WMConstantCache(real(uBottomEltypeNoUnits))
    g1 = zero(noise_rate_prototype)

    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)

    Y = zero(u)

    tmp1 = zero(rate_prototype)

    return PL1WMACache(u, uprev, _dW, chi1, tab, g1, k1, k2, Y, tmp1)
end

#NON
struct NONConstantCache{T} <: StochasticDiffEqConstantCache
    c01::T
    c02::T
    c03::T
    c04::T

    cj1::T
    cj2::T
    cj3::T
    cj4::T

    cjl2::T
    cjl3::T

    clj2::T
    clj3::T

    a0021::T
    a0032::T
    a0043::T

    aj021::T
    aj041::T

    a0j21::T
    a0j31::T
    a0j32::T
    a0j41::T

    ajj21::T
    ajj31::T
    ajj32::T
    ajj41::T
    ajj42::T
    ajj43::T

    ajl31::T
    ajl32::T
    ajl41::T
    ajl42::T

    ajljj31::T

    aljjl21::T
    aljjl31::T

    #quantile(Normal(),1/6)
    NORMAL_ONESIX_QUANTILE::T
end

function NONConstantCache(T::Type)
    c01 = convert(T, 1 // 6)
    c02 = convert(T, 1 // 3)
    c03 = convert(T, 1 // 3)
    c04 = convert(T, 1 // 6)

    cj1 = convert(T, 1 // 8)
    cj2 = convert(T, 3 // 8)
    cj3 = convert(T, 3 // 8)
    cj4 = convert(T, 1 // 8)

    cjl2 = convert(T, 1 // 2)
    cjl3 = convert(T, -1 // 2)

    clj2 = convert(T, -1 // 2)
    clj3 = convert(T, 1 // 2)

    a0021 = convert(T, 1 // 2)
    a0032 = convert(T, 1 // 2)
    a0043 = convert(T, 1)

    aj021 = convert(T, 2)
    aj041 = convert(T, -2)

    a0j21 = convert(T, 1)
    a0j31 = convert(T, -9 // 8)
    a0j32 = convert(T, 9 // 8)
    a0j41 = convert(T, 1)

    ajj21 = convert(T, 2 // 3)
    ajj31 = convert(T, 1 // 12)
    ajj32 = convert(T, 1 // 4)
    ajj41 = convert(T, -5 // 4)
    ajj42 = convert(T, 1 // 4)
    ajj43 = convert(T, 2)

    ajl31 = convert(T, 1 // 4)
    ajl32 = convert(T, 3 // 4)
    ajl41 = convert(T, 1 // 4)
    ajl42 = convert(T, 3 // 4)

    ajljj31 = convert(T, 1)

    aljjl21 = convert(T, -1 // 2)
    aljjl31 = convert(T, 1 // 2)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return NONConstantCache(
        c01, c02, c03, c04, cj1, cj2, cj3, cj4, cjl2, cjl3, clj2, clj3, a0021, a0032, a0043,
        aj021, aj041, a0j21, a0j31, a0j32, a0j41, ajj21, ajj31, ajj32, ajj41, ajj42, ajj43,
        ajl31, ajl32, ajl41, ajl42, ajljj31, aljjl21, aljjl31, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::NON, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return NONConstantCache(real(uBottomEltypeNoUnits))
end

@cache struct NONCache{uType, randType, tabType, rateNoiseType, rateType} <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType

    _dW::randType
    _dZ::randType
    chi1::randType

    tab::tabType

    gtmp::rateNoiseType
    ktmp::rateType

    Y100::uType
    Y200::uType
    Y300::uType
    Y400::uType
    Y1jajb::Array{uType}
    Y2jajb::Array{uType}
    Y3jajb::Array{uType}
    Y4jajb::Array{uType}

    tmpu::uType
    #tmpg::rateNoiseType

end

function alg_cache(
        alg::NON, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = NONConstantCache(real(uBottomEltypeNoUnits))

    gtmp = zero(noise_rate_prototype)
    ktmp = zero(rate_prototype)

    Y100 = zero(u)
    Y200 = zero(u)
    Y300 = zero(u)
    Y400 = zero(u)
    Y1jajb = [zero(u) for ja in 1:m, jb in 1:m]
    Y2jajb = [zero(u) for ja in 1:m, jb in 1:m]
    Y3jajb = [zero(u) for ja in 1:m, jb in 1:m]
    Y4jajb = [zero(u) for ja in 1:m, jb in 1:m]

    tmpu = zero(u)

    return NONCache(
        u, uprev, _dW, _dZ, chi1, tab, gtmp, ktmp, Y100, Y200,
        Y300, Y400, Y1jajb, Y2jajb, Y3jajb, Y4jajb, tmpu
    )
end

# COM
struct COMConstantCache{T} <: StochasticDiffEqConstantCache
    c01::T
    c02::T
    c03::T
    c04::T

    cj1::T
    cj2::T
    cj3::T
    cj4::T

    a0021::T
    a0032::T
    a0043::T

    aj021::T
    aj041::T

    a0j21::T
    a0j31::T
    a0j32::T
    a0j41::T

    ajj21::T
    ajj31::T
    ajj32::T
    ajj41::T
    ajj42::T
    ajj43::T

    ajl31::T
    ajl32::T
    ajl41::T
    ajl42::T

    #quantile(Normal(),1/6)
    NORMAL_ONESIX_QUANTILE::T
end

function COMConstantCache(T::Type)
    c01 = convert(T, 1 // 6)
    c02 = convert(T, 1 // 3)
    c03 = convert(T, 1 // 3)
    c04 = convert(T, 1 // 6)

    cj1 = convert(T, 1 // 8)
    cj2 = convert(T, 3 // 8)
    cj3 = convert(T, 3 // 8)
    cj4 = convert(T, 1 // 8)

    a0021 = convert(T, 1 // 2)
    a0032 = convert(T, 1 // 2)
    a0043 = convert(T, 1)

    aj021 = convert(T, 2)
    aj041 = convert(T, -2)

    a0j21 = convert(T, 1)
    a0j31 = convert(T, -9 // 8)
    a0j32 = convert(T, 9 // 8)
    a0j41 = convert(T, 1)

    ajj21 = convert(T, 2 // 3)
    ajj31 = convert(T, 1 // 12)
    ajj32 = convert(T, 1 // 4)
    ajj41 = convert(T, -5 // 4)
    ajj42 = convert(T, 1 // 4)
    ajj43 = convert(T, 2)

    ajl31 = convert(T, 1 // 4)
    ajl32 = convert(T, 3 // 4)
    ajl41 = convert(T, 1 // 4)
    ajl42 = convert(T, 3 // 4)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return COMConstantCache(
        c01, c02, c03, c04, cj1, cj2, cj3, cj4, a0021, a0032, a0043, aj021,
        aj041, a0j21, a0j31, a0j32, a0j41, ajj21, ajj31, ajj32, ajj41,
        ajj42, ajj43, ajl31, ajl32, ajl41, ajl42, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::COM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return COMConstantCache(real(uBottomEltypeNoUnits))
end

@cache struct COMCache{uType, randType, tabType, rateNoiseType, rateType} <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType

    _dW::randType

    tab::tabType

    gtmp::rateNoiseType
    ktmp::rateType

    Y10::uType
    Y20::uType
    Y30::uType
    Y40::uType
    Y1j::rateNoiseType
    Y2j::rateNoiseType
    Y3j::rateNoiseType
    Y4j::rateNoiseType

    tmpu::uType
    tmpu2::uType
end

function alg_cache(
        alg::COM, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
    else
        _dW = zero(ΔW)
    end
    m = length(ΔW)
    tab = COMConstantCache(real(uBottomEltypeNoUnits))

    gtmp = zero(noise_rate_prototype)
    ktmp = zero(rate_prototype)

    Y10 = zero(u)
    Y20 = zero(u)
    Y30 = zero(u)
    Y40 = zero(u)
    Y1j = zero(noise_rate_prototype)
    Y2j = zero(noise_rate_prototype)
    Y3j = zero(noise_rate_prototype)
    Y4j = zero(noise_rate_prototype)

    tmpu = zero(u)
    tmpu2 = zero(u)

    return COMCache(
        u, uprev, _dW, tab, gtmp, ktmp, Y10, Y20, Y30, Y40, Y1j, Y2j, Y3j, Y4j, tmpu, tmpu2
    )
end

# NON2
struct NON2ConstantCache{T} <: StochasticDiffEqConstantCache
    c01::T
    c02::T
    c03::T
    c04::T

    cj1::T
    cj2::T
    cj3::T
    cj4::T

    a0021::T
    a0032::T
    a0043::T

    aj021::T
    aj041::T

    a0j21::T
    a0j31::T
    a0j32::T
    a0j41::T

    ajj21::T
    ajj31::T
    ajj32::T
    ajj41::T
    ajj42::T
    ajj43::T

    ajl31::T
    ajl32::T
    ajl41::T
    ajl42::T

    # for non-commuting terms
    #ckj3::T
    #ckj4::T
    #akjjl32::T
    #akjjl42::T
    # are all expressed in terms of γ
    γ::T

    #quantile(Normal(),1/6)
    NORMAL_ONESIX_QUANTILE::T
end

function NON2ConstantCache(T::Type)
    c01 = convert(T, 1 // 6)
    c02 = convert(T, 1 // 3)
    c03 = convert(T, 1 // 3)
    c04 = convert(T, 1 // 6)

    cj1 = convert(T, 1 // 8)
    cj2 = convert(T, 3 // 8)
    cj3 = convert(T, 3 // 8)
    cj4 = convert(T, 1 // 8)

    a0021 = convert(T, 1 // 2)
    a0032 = convert(T, 1 // 2)
    a0043 = convert(T, 1)

    aj021 = convert(T, 2)
    aj041 = convert(T, -2)

    a0j21 = convert(T, 1)
    a0j31 = convert(T, -9 // 8)
    a0j32 = convert(T, 9 // 8)
    a0j41 = convert(T, 1)

    ajj21 = convert(T, 2 // 3)
    ajj31 = convert(T, 1 // 12)
    ajj32 = convert(T, 1 // 4)
    ajj41 = convert(T, -5 // 4)
    ajj42 = convert(T, 1 // 4)
    ajj43 = convert(T, 2)

    ajl31 = convert(T, 1 // 4)
    ajl32 = convert(T, 3 // 4)
    ajl41 = convert(T, 1 // 4)
    ajl42 = convert(T, 3 // 4)

    γ = convert(T, 1)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return NON2ConstantCache(
        c01, c02, c03, c04, cj1, cj2, cj3, cj4, a0021, a0032, a0043, aj021,
        aj041, a0j21, a0j31, a0j32, a0j41, ajj21, ajj31, ajj32, ajj41,
        ajj42, ajj43, ajl31, ajl32, ajl41, ajl42, γ, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::NON2, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return NON2ConstantCache(real(uBottomEltypeNoUnits))
end

@cache struct NON2Cache{uType, randType, MType1, tabType, rateNoiseType, rateType} <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType

    _dW::randType
    _dZ::randType
    chi1::randType
    Ihat2::MType1

    tab::tabType

    gtmp::rateNoiseType
    gtmp1::rateNoiseType
    ktmp::rateType

    Y10::uType
    Y20::uType
    Y30::uType
    Y40::uType
    Y1j::rateNoiseType
    Y2j::rateNoiseType
    Y3j::rateNoiseType
    Y4j::rateNoiseType

    tmpu::uType
    tmpu2::uType
end

function alg_cache(
        alg::NON2, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = copy(ΔW)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zero(ΔW)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    Ihat2 = zeros(eltype(ΔW), m, m)
    tab = NON2ConstantCache(real(uBottomEltypeNoUnits))

    gtmp = zero(noise_rate_prototype)
    gtmp1 = zero(noise_rate_prototype)
    ktmp = zero(rate_prototype)

    Y10 = zero(u)
    Y20 = zero(u)
    Y30 = zero(u)
    Y40 = zero(u)
    Y1j = zero(noise_rate_prototype)
    Y2j = zero(noise_rate_prototype)
    Y3j = zero(noise_rate_prototype)
    Y4j = zero(noise_rate_prototype)

    tmpu = zero(u)
    tmpu2 = zero(u)

    return NON2Cache(
        u, uprev, _dW, _dZ, chi1, Ihat2, tab, gtmp, gtmp1, ktmp,
        Y10, Y20, Y30, Y40, Y1j, Y2j, Y3j, Y4j, tmpu, tmpu2
    )
end

# SIE / SME methods

struct SIESMEConstantCache{T, T2} <: StochasticDiffEqConstantCache
    α1::T
    α2::T

    γ1::T

    λ1::T
    λ2::T
    λ3::T

    µ1::T
    µ2::T
    µ3::T

    µ0::T2
    µbar0::T2

    λ0::T
    λbar0::T

    ν1::T
    ν2::T

    β2::T
    β3::T

    δ2::T
    δ3::T
end

function SIEAConstantCache(::Type{T}, ::Type{T2}) where {T, T2}
    α1 = convert(T, 1 // 2)
    α2 = convert(T, 1 // 2)

    γ1 = convert(T, 1 // 2)

    λ1 = convert(T, 1 // 4)
    λ2 = convert(T, -1 // 4)
    λ3 = convert(T, 1 // 4)

    µ1 = convert(T, 1 // 4)
    µ2 = convert(T, 1 // 4)
    µ3 = convert(T, -1 // 4)

    µ0 = convert(T2, 1 // 1)
    µbar0 = convert(T2, 1 // 1)

    λ0 = convert(T, 1 // 1)
    λbar0 = convert(T, 1 // 1)

    ν1 = convert(T, 1 // 1)
    ν2 = convert(T, 0)

    β2 = convert(T, 1 // 1)
    β3 = convert(T, 0)

    δ2 = convert(T, -1 // 1)
    δ3 = convert(T, 0)

    return SIESMEConstantCache(
        α1, α2, γ1, λ1, λ2, λ3, µ1, µ2, µ3, µ0, µbar0, λ0, λbar0, ν1, ν2, β2, β3, δ2, δ3
    )
end

function alg_cache(
        alg::SIEA, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SIEAConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function SMEAConstantCache(::Type{T}, ::Type{T2}) where {T, T2}
    α1 = convert(T, 0)
    α2 = convert(T, 1 // 1)

    γ1 = convert(T, 1 // 2)

    λ1 = convert(T, 1 // 4)
    λ2 = convert(T, -1 // 4)
    λ3 = convert(T, 1 // 4)

    µ1 = convert(T, 1 // 4)
    µ2 = convert(T, 1 // 4)
    µ3 = convert(T, -1 // 4)

    µ0 = convert(T2, 1 // 2)
    µbar0 = convert(T2, 1 // 1)

    λ0 = convert(T, 1 // 2)
    λbar0 = convert(T, 1 // 1)

    ν1 = convert(T, (2 - sqrt(6)) / 4)
    ν2 = convert(T, sqrt(6) / 12)

    β2 = convert(T, 1 // 1)
    β3 = convert(T, 0)

    δ2 = convert(T, -1 // 1)
    δ3 = convert(T, 0)

    return SIESMEConstantCache(
        α1, α2, γ1, λ1, λ2, λ3, µ1, µ2, µ3, µ0, µbar0, λ0, λbar0, ν1, ν2, β2, β3, δ2, δ3
    )
end

function alg_cache(
        alg::SMEA, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SMEAConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function SIEBConstantCache(::Type{T}, ::Type{T2}) where {T, T2}
    α1 = convert(T, 1 // 2)
    α2 = convert(T, 1 // 2)

    γ1 = convert(T, -1 // 5)

    λ1 = convert(T, 3 // 5)
    λ2 = convert(T, 3 // 2)
    λ3 = convert(T, -1 // 2)

    µ1 = convert(T, 3 // 5)
    µ2 = convert(T, -3 // 2)
    µ3 = convert(T, 1 // 2)

    µ0 = convert(T2, 1 // 1)
    µbar0 = convert(T2, 5 // 12)

    λ0 = convert(T, 1 // 1)
    λbar0 = convert(T, 5 // 12)

    ν1 = convert(T, 1 // 1)
    ν2 = convert(T, 0)

    β2 = convert(T, 0)
    β3 = convert(T, -1 // 6)

    δ2 = convert(T, 0)
    δ3 = convert(T, 1 // 6)

    return SIESMEConstantCache(
        α1, α2, γ1, λ1, λ2, λ3, µ1, µ2, µ3, µ0, µbar0, λ0, λbar0, ν1, ν2, β2, β3, δ2, δ3
    )
end

function alg_cache(
        alg::SIEB, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SIEBConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function SMEBConstantCache(::Type{T}, ::Type{T2}) where {T, T2}
    α1 = convert(T, 0)
    α2 = convert(T, 1 // 1)

    γ1 = convert(T, -1 // 5)

    λ1 = convert(T, 3 // 5)
    λ2 = convert(T, 3 // 2)
    λ3 = convert(T, -1 // 2)

    µ1 = convert(T, 3 // 5)
    µ2 = convert(T, -3 // 2)
    µ3 = convert(T, 1 // 2)

    µ0 = convert(T2, 1 // 2)
    µbar0 = convert(T2, 5 // 12)

    λ0 = convert(T, 1 // 2)
    λbar0 = convert(T, 5 // 12)

    ν1 = convert(T, (2 - sqrt(6)) / 4)
    ν2 = convert(T, sqrt(6) / 12)

    β2 = convert(T, 0)
    β3 = convert(T, -1 // 6)

    δ2 = convert(T, 0)
    δ3 = convert(T, 1 // 6)

    return SIESMEConstantCache(
        α1, α2, γ1, λ1, λ2, λ3, µ1, µ2, µ3, µ0, µbar0, λ0, λbar0, ν1, ν2, β2, β3, δ2, δ3
    )
end

function alg_cache(
        alg::SMEB, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SMEBConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

@cache struct SIESMECache{uType, randType, tabType, rateNoiseType, rateType} <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType

    W2::randType
    W3::randType

    tab::tabType

    k0::rateType
    k1::rateType

    g0::rateNoiseType
    g1::rateNoiseType
    g2::rateNoiseType

    #tmp1::possibleRateType
    tmpu::uType
end

function alg_cache(
        alg::SIEA, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        W2 = copy(ΔW)
        W3 = copy(ΔW)
    else
        W2 = zero(ΔW)
        W3 = zero(ΔW)
    end

    k0 = zero(u)
    k1 = zero(u)

    g0 = zero(noise_rate_prototype)
    g1 = zero(noise_rate_prototype)
    g2 = zero(noise_rate_prototype)

    tmpu = zero(u)

    tab = SIEAConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))

    return SIESMECache(u, uprev, W2, W3, tab, k0, k1, g0, g1, g2, tmpu)
end

function alg_cache(
        alg::SMEA, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        W2 = copy(ΔW)
        W3 = copy(ΔW)
    else
        W2 = zero(ΔW)
        W3 = zero(ΔW)
    end

    k0 = zero(u)
    k1 = zero(u)

    g0 = zero(noise_rate_prototype)
    g1 = zero(noise_rate_prototype)
    g2 = zero(noise_rate_prototype)

    tmpu = zero(u)

    tab = SMEAConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))

    return SIESMECache(u, uprev, W2, W3, tab, k0, k1, g0, g1, g2, tmpu)
end

function alg_cache(
        alg::SIEB, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        W2 = copy(ΔW)
        W3 = copy(ΔW)
    else
        W2 = zero(ΔW)
        W3 = zero(ΔW)
    end

    k0 = zero(u)
    k1 = zero(u)

    g0 = zero(noise_rate_prototype)
    g1 = zero(noise_rate_prototype)
    g2 = zero(noise_rate_prototype)

    tmpu = zero(u)

    tab = SIEBConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))

    return SIESMECache(u, uprev, W2, W3, tab, k0, k1, g0, g1, g2, tmpu)
end

function alg_cache(
        alg::SMEB, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        W2 = copy(ΔW)
        W3 = copy(ΔW)
    else
        W2 = zero(ΔW)
        W3 = zero(ΔW)
    end

    k0 = zero(u)
    k1 = zero(u)

    g0 = zero(noise_rate_prototype)
    g1 = zero(noise_rate_prototype)
    g2 = zero(noise_rate_prototype)

    tmpu = zero(u)

    tab = SMEBConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))

    return SIESMECache(u, uprev, W2, W3, tab, k0, k1, g0, g1, g2, tmpu)
end

# Tang & Xiao: DOI 10.1007/s10543-016-0618-9 W2Ito1 and W2Ito2 methods

struct W2Ito1ConstantCache{T} <: StochasticDiffEqConstantCache
    # hard-coded version
    a021::T
    a031::T
    a032::T

    a121::T
    a131::T
    #a132::T

    #a221::T
    #a231::T
    #a232::T

    b021::T
    b031::T
    #b032::T

    b121::T
    b131::T
    #b132::T

    b221::T
    #b222::T
    #b223::T
    #b231::T
    #b232::T
    #b233::T

    α1::T
    α2::T
    α3::T

    beta01::T
    beta02::T
    beta03::T

    beta11::T
    #beta12::T
    beta13::T

    #quantile(Normal(),1/6)
    NORMAL_ONESIX_QUANTILE::T
end

function W2Ito1ConstantCache(::Type{T}, ::Type{T2}) where {T, T2}
    a021 = convert(T, 1 // 2)
    a031 = convert(T, -1)
    a032 = convert(T, 2)

    a121 = convert(T, 1 // 4)
    a131 = convert(T, 1 // 4)

    b021 = convert(T, (6 - sqrt(6)) / 10)
    b031 = convert(T, (3 + 2 * sqrt(6)) / 5)

    b121 = convert(T, 1 // 2)
    b131 = convert(T, -1 // 2)

    b221 = convert(T, 1)

    α1 = convert(T, 1 // 6)
    α2 = convert(T, 2 // 3)
    α3 = convert(T, 1 // 6)

    beta01 = convert(T, -1)
    beta02 = convert(T, 1)
    beta03 = convert(T, 1)

    beta11 = convert(T, 2)
    beta13 = convert(T, -2)

    NORMAL_ONESIX_QUANTILE = convert(T, -0.9674215661017014)

    return W2Ito1ConstantCache(
        a021, a031, a032, a121, a131, b021, b031, b121, b131, b221, α1, α2,
        α3, beta01, beta02, beta03, beta11, beta13, NORMAL_ONESIX_QUANTILE
    )
end

function alg_cache(
        alg::W2Ito1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return W2Ito1ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

@cache struct W2Ito1Cache{
        uType, randType, tabType, rateNoiseType, rateType, possibleRateType,
    } <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    uhat::uType

    _dW::randType
    _dZ::randType
    chi1::randType

    tab::tabType

    g1::rateNoiseType
    g2::rateNoiseType
    g3::rateNoiseType

    k1::rateType
    k2::rateType
    k3::rateType

    H02::uType
    H03::uType
    H12::Vector{uType}
    H13::Vector{uType}

    tmp1::possibleRateType
    tmpg::rateNoiseType

    tmp::uType
    resids::uType
end

function alg_cache(
        alg::W2Ito1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        _dW = copy(ΔW)
        _dZ = zeros(eltype(ΔW), 2)
        chi1 = copy(ΔW)
    else
        _dW = zero(ΔW)
        _dZ = zeros(eltype(ΔW), 2)
        chi1 = zero(ΔW)
    end
    m = length(ΔW)
    tab = W2Ito1ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = zero(noise_rate_prototype)
    g3 = zero(noise_rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)

    H02 = zero(u)
    H03 = zero(u)
    H12 = Vector{typeof(u)}()
    H13 = Vector{typeof(u)}()

    for k in 1:m
        push!(H12, zero(u))
        push!(H13, zero(u))
    end

    tmp1 = zero(rate_prototype)
    tmpg = zero(noise_rate_prototype)

    uhat = copy(uprev)
    tmp = zero(u)
    resids = zero(u)

    return W2Ito1Cache(
        u, uprev, uhat, _dW, _dZ, chi1, tab, g1, g2, g3, k1,
        k2, k3, H02, H03, H12, H13, tmp1, tmpg, tmp, resids
    )
end

struct DRI1 <: StochasticDiffEqAdaptiveAlgorithm end

"""
    DRI1NM()

**DRI1NM: Debrabant-Rößler Implicit Non-Mixing Method (High Weak Order)**

Specialized version of DRI1 for non-mixing diagonal and scalar additive noise problems.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0 (optimized with minimized error constants)
  - **Deterministic Order**: 3.0 (when noise = 0)
  - **Time stepping**: Adaptive
  - **Noise types**: Non-mixing diagonal and scalar additive noise
  - **SDE interpretation**: Itô

## When to Use

  - Non-mixing diagonal problems: `du[k] = f(u[k]) dt + σ[k] dW[k]`
  - Scalar additive noise problems
  - When DRI1 is too general/expensive for the problem structure
  - Monte Carlo simulations with special structure

## Non-Mixing Diagonal Structure

Optimized for problems where:

```
du[1] = f₁(u[1])dt + σ₁ dW[1]
du[2] = f₂(u[2])dt + σ₂ dW[2]
...
```

Each component depends only on itself (no coupling).

## Algorithm Advantages

  - More efficient than general DRI1 for structured problems
  - Exploits special structure for better performance
  - Maintains weak order 2.0 with minimized constants

## References

  - Debrabant, K. and Rößler A., "Families of efficient second order Runge–Kutta methods for the weak approximation of Itô stochastic differential equations", Applied Numerical Mathematics 59, pp. 582–594 (2009). DOI: 10.1016/j.apnum.2008.03.012.
"""
struct DRI1NM <: StochasticDiffEqAdaptiveAlgorithm end

"""
    RI1()

**RI1: Rößler Implicit Method 1 (High Weak Order)**

Adaptive weak order 2.0 method for Itô SDEs with deterministic order 3.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 3.0 (when noise = 0)
  - **Time stepping**: Adaptive
  - **Noise types**: All forms (diagonal, non-diagonal, non-commuting, scalar additive)
  - **SDE interpretation**: Itô

## When to Use

  - General weak convergence problems
  - Monte Carlo simulations with various noise structures
  - When weak order 2.0 is sufficient
  - Alternative to DRI1 with different characteristics

## References

  - Rößler A., "Second Order Runge–Kutta Methods for Itô Stochastic Differential Equations", SIAM J. Numer. Anal., 47, pp. 1713-1738 (2009). DOI: 10.1137/060673308.
"""
struct RI1 <: StochasticDiffEqAdaptiveAlgorithm end

"""
    RI3()

**RI3: Rößler Implicit Method 3 (High Weak Order)**

Alternative adaptive weak order 2.0 method with different stability characteristics.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 3.0 (when noise = 0)
  - **Time stepping**: Adaptive
  - **Noise types**: All forms (diagonal, non-diagonal, non-commuting, scalar additive)
  - **SDE interpretation**: Itô

## When to Use

  - Alternative to RI1 with different characteristics
  - When RI1 performance is unsatisfactory
  - Benchmarking different weak order 2.0 methods

## References

  - Rößler A., "Second Order Runge–Kutta Methods for Itô Stochastic Differential Equations", SIAM J. Numer. Anal., 47, pp. 1713-1738 (2009). DOI: 10.1137/060673308
"""
struct RI3 <: StochasticDiffEqAdaptiveAlgorithm end

"""
    RI5()

**RI5: Rößler Implicit Method 5 (High Weak Order)**

Another variant in the RI family of weak order 2.0 methods.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 3.0 (when noise = 0)
  - **Time stepping**: Adaptive
  - **Noise types**: All forms (diagonal, non-diagonal, non-commuting, scalar additive)
  - **SDE interpretation**: Itô

## When to Use

  - Part of RI family comparison studies
  - When other RI methods don't provide desired characteristics
  - Research applications requiring different RI variants

## References

  - Rößler A., "Second Order Runge–Kutta Methods for Itô Stochastic Differential Equations", SIAM J. Numer. Anal., 47, pp. 1713-1738 (2009). DOI: 10.1137/060673308
"""
struct RI5 <: StochasticDiffEqAdaptiveAlgorithm end

"""
    RI6()

**RI6: Rößler Implicit Method 6 (High Weak Order)**

Final method in the RI family with deterministic order 2 (lower than other RI methods).

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 2.0 (when noise = 0)
  - **Time stepping**: Adaptive
  - **Noise types**: All forms (diagonal, non-diagonal, non-commuting, scalar additive)
  - **SDE interpretation**: Itô

## When to Use

  - When lower deterministic order is acceptable
  - Potentially more efficient than RI1/RI3/RI5
  - Completing RI family comparisons

## Algorithm Features

  - Lower deterministic order may reduce computational cost
  - Still maintains weak order 2.0 for stochastic problems
  - Final variant in the comprehensive RI family

## References

  - Rößler A., "Second Order Runge–Kutta Methods for Itô Stochastic Differential Equations", SIAM J. Numer. Anal., 47, pp. 1713-1738 (2009). DOI: 10.1137/060673308
"""
struct RI6 <: StochasticDiffEqAdaptiveAlgorithm end

"""
    RDI1WM()

**RDI1WM: Runge-Kutta Debrabant Implicit 1 Weak Method (High Weak Order)**

Fixed step method with weak order 1.0 for Itô SDEs.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 1.0
  - **Deterministic Order**: 2.0 (when noise = 0)
  - **Time stepping**: Fixed step size
  - **Noise types**: All forms (diagonal, non-diagonal, non-commuting, scalar additive)
  - **SDE interpretation**: Itô

## When to Use

  - Fixed step applications where step size is predetermined
  - When weak order 1.0 is sufficient
  - Simpler alternative to higher-order weak methods
  - Baseline for comparing higher-order methods

## References

  - Debrabant, K. and Rößler A., "Classification of Stochastic Runge–Kutta Methods for the Weak Approximation of Stochastic Differential Equations", Mathematics and Computers in Simulation 77, pp. 408-420 (2008). DOI: 10.1016/j.matcom.2007.04.016
"""
struct RDI1WM <: StochasticDiffEqAlgorithm end

"""
    RDI2WM()

**RDI2WM: Runge-Kutta Debrabant Implicit 2 Weak Method (High Weak Order)**

Adaptive weak order 2.0 method for Itô SDEs with deterministic order 2.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 2.0 (when noise = 0)
  - **Time stepping**: Adaptive
  - **Noise types**: All forms (diagonal, non-diagonal, non-commuting, scalar additive)
  - **SDE interpretation**: Itô

## When to Use

  - Weak order 2.0 problems with adaptive stepping
  - Alternative to DRI1 and RI methods
  - When deterministic order 2.0 is sufficient
  - Monte Carlo simulations requiring adaptive control

## References

  - Debrabant, K. and Rößler A., "Classification of Stochastic Runge–Kutta Methods for the Weak Approximation of Stochastic Differential Equations", Mathematics and Computers in Simulation 77, pp. 408-420 (2008). DOI: 10.1016/j.matcom.2007.04.016.
"""
struct RDI2WM <: StochasticDiffEqAdaptiveAlgorithm end

"""
    RDI3WM()

**RDI3WM: Runge-Kutta Debrabant Implicit 3 Weak Method (High Weak Order)**

Adaptive weak order 2.0 method with higher deterministic order 3.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 3.0 (when noise = 0)
  - **Time stepping**: Adaptive
  - **Noise types**: All forms (diagonal, non-diagonal, non-commuting, scalar additive)
  - **SDE interpretation**: Itô

## When to Use

  - When both weak order 2.0 and deterministic order 3.0 are needed
  - Problems with significant deterministic components
  - Alternative to DRI1 with different characteristics
  - High accuracy requirements for both stochastic and deterministic parts

## References

  - Debrabant, K. and Rößler A., "Classification of Stochastic Runge–Kutta Methods for the Weak Approximation of Stochastic Differential Equations", Mathematics and Computers in Simulation 77, pp. 408-420 (2008). DOI: 10.1016/j.matcom.2007.04.016.
"""
struct RDI3WM <: StochasticDiffEqAdaptiveAlgorithm end

"""
    RDI4WM()

**RDI4WM: Runge-Kutta Debrabant Implicit 4 Weak Method (High Weak Order)**

Fourth variant in the RDI family with weak order 2.0 and deterministic order 3.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 3.0 (when noise = 0)
  - **Time stepping**: Adaptive
  - **Noise types**: All forms (diagonal, non-diagonal, non-commuting, scalar additive)
  - **SDE interpretation**: Itô

## When to Use

  - Final alternative in the RDI family
  - When other RDI methods don't provide desired performance
  - Completing comprehensive RDI method comparisons
  - Research applications requiring all RDI variants

## References

  - Debrabant, K. and Rößler A., "Classification of Stochastic Runge–Kutta Methods for the Weak Approximation of Stochastic Differential Equations", Mathematics and Computers in Simulation 77, pp. 408-420 (2008). DOI: 10.1016/j.matcom.2007.04.016.
"""
struct RDI4WM <: StochasticDiffEqAdaptiveAlgorithm end

"""
    W2Ito1()

**W2Ito1: Wang-Tang-Xiao Weak Order 2 Method (High Weak Order)**

Efficient weak second-order method for Itô SDEs with adaptive stepping.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 3.0 (when noise = 0)
  - **Time stepping**: Adaptive
  - **Noise types**: All forms (diagonal, non-diagonal, non-commuting, scalar additive)
  - **SDE interpretation**: Itô

## When to Use

  - Modern efficient weak order 2.0 method
  - When computational efficiency is important for weak convergence
  - Alternative to older weak order 2.0 methods
  - Monte Carlo simulations requiring good performance

## Algorithm Features

  - Designed for computational efficiency
  - Good balance of accuracy and cost for weak problems
  - More recent development than classical methods

## References

  - Tang, X., & Xiao, A., "Efficient weak second-order stochastic Runge–Kutta methods for Itô stochastic differential equations", BIT Numerical Mathematics, 57, 241-260 (2017). DOI: 10.1007/s10543-016-0618-9
"""
struct W2Ito1 <: StochasticDiffEqAdaptiveAlgorithm end

# Stratonovich sense

"""
    RS1()

**RS1: Rößler Stratonovich Method 1 (High Weak Order)**

Fixed step weak order 2.0 method specifically designed for Stratonovich SDEs.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 2.0 (when noise = 0)
  - **Time stepping**: Fixed step size
  - **Noise types**: All forms (diagonal, non-diagonal, non-commuting, scalar additive)
  - **SDE interpretation**: Stratonovich

## When to Use

  - Stratonovich SDEs requiring weak order 2.0
  - Fixed step applications with predetermined step size
  - Problems naturally formulated in Stratonovich interpretation
  - When physical interpretation requires Stratonovich calculus

## Stratonovich Interpretation

Optimized for SDEs in Stratonovich form:

```math
du = f(u,t)dt + g(u,t)∘dW
```

where ∘ denotes Stratonovich integration.

## References

  - Rößler A., "Second order Runge–Kutta methods for Stratonovich stochastic differential equations", BIT Numerical Mathematics 47, pp. 657-680 (2007) DOI: 10.1007/s10543-007-0130-3.
"""
struct RS1 <: StochasticDiffEqAlgorithm end

"""
    RS2()

**RS2: Rößler Stratonovich Method 2 (High Weak Order)**

Alternative fixed step weak order 2.0 method for Stratonovich SDEs with higher deterministic order.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 3.0 (when noise = 0)
  - **Time stepping**: Fixed step size
  - **Noise types**: All forms (diagonal, non-diagonal, non-commuting, scalar additive)
  - **SDE interpretation**: Stratonovich

## When to Use

  - Stratonovich SDEs with significant deterministic components
  - When higher deterministic accuracy than RS1 is needed
  - Fixed step applications requiring better deterministic performance
  - Benchmarking against RS1

## Algorithm Features

  - Higher deterministic order than RS1
  - May be more expensive per step than RS1
  - Better for problems with large deterministic components

## References

  - Rößler A., "Second order Runge–Kutta methods for Stratonovich stochastic differential equations", BIT Numerical Mathematics 47, pp. 657-680 (2007). DOI: 10.1007/s10543-007-0130-3
"""
struct RS2 <: StochasticDiffEqAlgorithm end

"""
    PL1WM()

**PL1WM: Platen Weak Method 1 (High Weak Order)**

Fixed step weak order 2.0 method from the classical Kloeden-Platen textbook.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 2.0 (when noise = 0)
  - **Time stepping**: Fixed step size
  - **Noise types**: All forms (diagonal, non-diagonal, non-commuting, scalar additive)
  - **SDE interpretation**: Itô

## When to Use

  - Classical reference implementation for weak order 2.0
  - Fixed step applications with predetermined step size
  - Educational purposes and textbook examples
  - Baseline comparison for more advanced methods

## Algorithm Features

  - Well-established classical method
  - Simple implementation
  - Standard reference from foundational SDE literature

## References

  - Kloeden, P.E., Platen, E., "Numerical Solution of Stochastic Differential Equations", Springer. Berlin Heidelberg (2011). ISBN 978-3-540-54062-5. DOI: 10.1007/978-3-662-12616-5.
"""
struct PL1WM <: StochasticDiffEqAlgorithm end

"""
    PL1WMA()

**PL1WMA: Platen Weak Method 1 Additive (High Weak Order)**

Specialized version of PL1WM optimized for additive noise problems.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 2.0 (when noise = 0)
  - **Time stepping**: Fixed step size
  - **Noise types**: Additive noise only
  - **SDE interpretation**: Itô

## When to Use

  - Additive noise problems with fixed step size
  - When PL1WM is too general for additive structure
  - Classical reference for additive noise weak methods
  - Educational and benchmarking purposes

## Additive Noise Structure

Specialized for SDEs of the form:

```math
du = f(u,t)dt + σ(t) dW
```

where diffusion σ doesn't depend on solution u.

## Algorithm Features

  - More efficient than PL1WM for additive problems
  - Classical foundation method
  - Simplified implementation for additive case

## References

  - Kloeden, P.E., Platen, E., "Numerical Solution of Stochastic Differential Equations", Springer. Berlin Heidelberg (2011). ISBN 978-3-540-54062-5. DOI: 10.1007/978-3-662-12616-5.
"""
struct PL1WMA <: StochasticDiffEqAlgorithm end

"""
    NON()

NON: High Weak Order Method
Fixed step weak order 2.0 for Stratonovich SDEs (deterministic order 4).
Can handle diagonal, non-diagonal, non-commuting, and scalar additive noise.

## References

  - Komori, Y., Weak second-order stochastic Runge–Kutta methods for non-commutative stochastic differential equations, Journal of Computational and Applied Mathematics 206, pp. 158 – 173 (2007). DOI: 10.1016/j.cam.2006.06.006.
"""
struct NON <: StochasticDiffEqAlgorithm end

"""
    COM()

**COM: Commutative Stratonovich Method (High Weak Order)**

Fixed step method optimized for commutative Stratonovich SDEs.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: Depends on implementation
  - **Time stepping**: Fixed step size
  - **Noise types**: Commutative noise only
  - **SDE interpretation**: Stratonovich

## When to Use

  - Commutative Stratonovich SDEs
  - When noise terms satisfy commutativity conditions
  - More efficient alternative to NON for commutative cases
  - Fixed step applications with commutative structure

## Commutative Noise

Optimized for Stratonovich SDEs where:

```
[g_i, g_j] = g_i(∂g_j/∂x) - g_j(∂g_i/∂x) = 0
```

for all noise terms.

## Algorithm Features

  - More efficient than NON for commutative cases
  - Exploits commutativity for computational savings
  - Specialized for Stratonovich interpretation

## References

  - Komori, Y., "Weak order stochastic Runge–Kutta methods for commutative stochastic differential equations", Journal of Computational and Applied Mathematics 203, pp. 57 – 79 (2007). Bibcode: 2007JCoAM.203...57K
"""
struct COM <: StochasticDiffEqAlgorithm end

"""
    NON2()

**NON2: Enhanced Non-commutative Stratonovich Method (High Weak Order)**

Improved version of the NON method with enhanced efficiency for non-commutative Stratonovich SDEs.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Time stepping**: Fixed step size
  - **Noise types**: Non-commutative noise
  - **SDE interpretation**: Stratonovich

## When to Use

  - Enhanced version of NON with better efficiency
  - Non-commutative Stratonovich SDEs requiring improved performance
  - When NON is too expensive or inefficient
  - Modern alternative to classical NON method

## Algorithm Features

  - More efficient than original NON method
  - Maintains weak order 2.0 convergence
  - Enhanced computational techniques

## References

  - Komori, Y., & Burrage, K., "Supplement: Efficient weak second order stochastic Runge–Kutta methods for non-commutative Stratonovich stochastic differential equations", Journal of computational and applied mathematics, 235(17), pp. 5326-5329 (2011)
"""
struct NON2 <: StochasticDiffEqAlgorithm end

"""
    SIEA()

**SIEA: Stochastic Improved Euler A Method (High Weak Order)**

Stochastic generalization of the improved Euler method for Itô SDEs.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 2.0 (when noise = 0)
  - **Time stepping**: Fixed step size
  - **Noise types**: Diagonal and scalar additive noise
  - **SDE interpretation**: Itô

## When to Use

  - Fixed step applications with diagonal/scalar additive noise
  - When stochastic version of improved Euler is desired
  - Educational purposes (connection to classical methods)
  - Baseline for Tocino-Vigo-Aguiar method comparisons

## Algorithm Features

  - Based on classical improved Euler method
  - Specialized for additive noise structures
  - Simple and well-understood foundation

## References

  - Tocino, A. and Vigo-Aguiar, J., "Weak Second Order Conditions for Stochastic Runge-Kutta Methods", SIAM Journal on Scientific Computing 24, pp. 507-523 (2002). DOI: 10.1137/S1064827501387814.
"""
struct SIEA <: StochasticDiffEqAlgorithm end

"""
    SMEA()

**SMEA: Stochastic Modified Euler A Method (High Weak Order)**

Stochastic generalization of the modified Euler method for Itô SDEs.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 2.0 (when noise = 0)
  - **Time stepping**: Fixed step size
  - **Noise types**: Diagonal and scalar additive noise
  - **SDE interpretation**: Itô

## When to Use

  - Fixed step applications with diagonal/scalar additive noise
  - When stochastic version of modified Euler is desired
  - Alternative to SIEA with different characteristics
  - Educational and comparison purposes

## Algorithm Features

  - Based on classical modified Euler method
  - Different approach than SIEA for same problem class
  - Specialized for additive noise structures

## References

  - Tocino, A. and Vigo-Aguiar, J., "Weak Second Order Conditions for Stochastic Runge-Kutta Methods", SIAM Journal on Scientific Computing 24, pp. 507-523 (2002). DOI: 10.1137/S1064827501387814.
"""
struct SMEA <: StochasticDiffEqAlgorithm end

"""
    SIEB()

**SIEB: Stochastic Improved Euler B Method (High Weak Order)**

Alternative stochastic generalization of the improved Euler method.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 2.0 (when noise = 0)
  - **Time stepping**: Fixed step size
  - **Noise types**: Diagonal and scalar additive noise
  - **SDE interpretation**: Itô

## When to Use

  - Alternative to SIEA with different coefficients
  - Fixed step applications requiring different stability properties
  - Comparing different improved Euler generalizations
  - When SIEA performance is unsatisfactory

## Algorithm Features

  - Variant B of stochastic improved Euler approach
  - Different coefficients than SIEA
  - May have different stability or accuracy characteristics

## References

  - Tocino, A. and Vigo-Aguiar, J., "Weak Second Order Conditions for Stochastic Runge-Kutta Methods", SIAM Journal on Scientific Computing 24, pp. 507-523 (2002). DOI: 10.1137/S1064827501387814.
"""
struct SIEB <: StochasticDiffEqAlgorithm end

"""
    SMEB()

**SMEB: Stochastic Modified Euler B Method (High Weak Order)**

Alternative stochastic generalization of the modified Euler method.

## Method Properties

  - **Strong Order**: Not optimized for strong convergence
  - **Weak Order**: 2.0
  - **Deterministic Order**: 2.0 (when noise = 0)
  - **Time stepping**: Fixed step size
  - **Noise types**: Diagonal and scalar additive noise
  - **SDE interpretation**: Itô

## When to Use

  - Alternative to SMEA with different coefficients
  - Fixed step applications requiring different characteristics
  - Completing Tocino-Vigo-Aguiar method family comparisons
  - When SMEA performance is unsatisfactory

## Algorithm Features

  - Variant B of stochastic modified Euler approach
  - Different coefficients than SMEA
  - Completes the family of Tocino-Vigo-Aguiar methods

## References

  - Tocino, A. and Vigo-Aguiar, J., "Weak Second Order Conditions for Stochastic Runge-Kutta Methods", SIAM Journal on Scientific Computing 24, pp. 507-523 (2002). DOI: 10.1137/S1064827501387814
"""
struct SMEB <: StochasticDiffEqAlgorithm end

struct IRI1{CS, AD, F, F2, P, FDT, ST, CJ, T2, Controller} <:
    StochasticDiffEqNewtonAdaptiveAlgorithm{CS, AD, FDT, ST, CJ, Controller}
    linsolve::F
    nlsolve::F2
    precs::P
    theta::T2
    extrapolant::Symbol
    new_jac_conv_bound::T2
end
function IRI1(;
        chunk_size = 0, autodiff = true, diff_type = Val{:central},
        standardtag = Val{true}(), concrete_jac = nothing,
        precs = OrdinaryDiffEqCore.DEFAULT_PRECS,
        linsolve = nothing, nlsolve = NLNewton(),
        extrapolant = :constant,
        theta = 1,
        new_jac_conv_bound = 1.0e-3,
        controller = :Predictive
    )
    return IRI1{
        chunk_size, autodiff,
        typeof(linsolve), typeof(nlsolve), typeof(precs), diff_type,
        SciMLBase._unwrap_val(standardtag),
        SciMLBase._unwrap_val(concrete_jac),
        typeof(new_jac_conv_bound), controller,
    }(
        linsolve, nlsolve, precs,
        theta,
        extrapolant, new_jac_conv_bound
    )
end

"""
 Tests for PL1WM
"""

import Statistics # for mean values of trajectories
import LinearAlgebra # for the normn
using StochasticDiffEqWeak
using Test
using Random
using DiffEqDevTools
#using DiffEqGPU

function prob_func(prob, i, repeat)
    return remake(prob, seed = seeds[i])
end

"""
 Test Scalar SDEs (oop)
"""

@info "Scalar oop noise"

# PC exercise 14.2.2
numtraj = Int(2.0e4)
u₀ = 0.1
f(u, p, t) = p[1] * u
g(u, p, t) = p[2] * u
dts = 1 .// 2 .^ (6:-1:3)
tspan = (0.0, 1.0)
p = [3 // 2, 1 // 100]

h1(z) = z
#analytical_sol(t) = E(f(X(t))) =

seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

prob = SDEProblem(f, g, u₀, tspan, p)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h1(sol.u[end]), false),
    prob_func = prob_func
)

sim = test_convergence(
    dts, ensemble_prob, PL1WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.34 # order is 2.34
println("PL1WM:", sim.𝒪est[:weak_final])

"""
 Test Scalar SDEs (iip)
"""

@info "Scalar iip noise"

u₀ = [0.1]
f1!(du, u, p, t) = (du[1] = p[1] * u[1])
g1!(du, u, p, t) = (du[1] = p[2] * u[1])
dts = 1 .// 2 .^ (6:-1:3)
tspan = (0.0, 1.0)
p = [3 // 2, 1 // 100]

prob = SDEProblem(f1!, g1!, u₀, tspan, p)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h1(sol.u[end][1]), false),
    prob_func = prob_func
)

numtraj = Int(2.0e4)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, PL1WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.34 # order is 2.34
println("PL1WM:", sim.𝒪est[:weak_final])

"""
 Test non-commutative noise SDEs (iip)
"""

@info "Non-commutative noise"

u₀ = [1 / 8, 1 / 8, 1 / 1, 1 / 8]
function f2!(du, u, p, t)
    du[1] = 243 // 154 * u[1] - 27 // 77 * u[2] + 23 // 154 * u[3] - 65 // 154 * u[4]
    du[2] = 27 // 77 * u[1] - 243 // 154 * u[2] + 65 // 154 * u[3] - 23 // 154 * u[4]
    du[3] = 5 // 154 * u[1] - 61 // 154 * u[2] + 162 // 77 * u[3] - 36 // 77 * u[4]
    return du[4] = 61 // 154 * u[1] - 5 // 154 * u[2] + 36 // 77 * u[3] - 162 // 77 * u[4]
end
function g2!(du, u, p, t)
    du[1, 1] = 1 // 9 * sqrt(u[2]^2 + u[3]^2 + 2 // 23) * 1 // 13
    du[1, 2] = 1 // 8 * sqrt(u[4]^2 + u[1]^2 + 1 // 11) * 1 // 14
    du[1, 3] = p[1] * 1 // 12 * sqrt(u[1]^2 + u[2]^2 + 1 // 9) * 1 // 6
    du[1, 4] = p[1] * 1 // 14 * sqrt(u[3]^2 + u[4]^2 + 3 // 29) * 1 // 8
    du[2, 1] = 1 // 9 * sqrt(u[2]^2 + u[3]^2 + 2 // 23) * 1 // 14
    du[2, 2] = 1 // 8 * sqrt(u[4]^2 + u[1]^2 + 1 // 11) * 1 // 16
    du[2, 3] = p[1] * 1 // 12 * sqrt(u[1]^2 + u[2]^2 + 1 // 9) * 1 // 5
    du[2, 4] = p[1] * 1 // 14 * sqrt(u[3]^2 + u[4]^2 + 3 // 29) * 1 // 9
    du[3, 1] = 1 // 9 * sqrt(u[2]^2 + u[3]^2 + 2 // 23) * 1 // 13
    du[3, 2] = 1 // 8 * sqrt(u[4]^2 + u[1]^2 + 1 // 11) * 1 // 16
    du[3, 3] = p[1] * 1 // 12 * sqrt(u[1]^2 + u[2]^2 + 1 // 9) * 1 // 5
    du[3, 4] = p[1] * 1 // 14 * sqrt(u[3]^2 + u[4]^2 + 3 // 29) * 1 // 8
    du[4, 1] = 1 // 9 * sqrt(u[2]^2 + u[3]^2 + 2 // 23) * 1 // 15
    du[4, 2] = 1 // 8 * sqrt(u[4]^2 + u[1]^2 + 1 // 11) * 1 // 12
    du[4, 3] = p[1] * 1 // 12 * sqrt(u[1]^2 + u[2]^2 + 1 // 9) * 1 // 6
    return du[4, 4] = p[1] * 1 // 14 * sqrt(u[3]^2 + u[4]^2 + 3 // 29) * 1 // 9
end
dts = 1 .// 2 .^ (6:-1:1)
tspan = (0.0, 1.0)
p = [1]
h2(z) = z
# solution: E(X^i) = 1/8 exp(2*T), for i=1,2,4; E(X^3) = exp(2*T)

prob = SDEProblem(f2!, g2!, u₀, tspan, p, noise_rate_prototype = zeros(4, 4))
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h2(sol.u[end][1]), false),
    prob_func = prob_func
)

numtraj = Int(1.0e5)
seed = 235
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, PL1WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀[1] * exp(2 * 1.0)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.33 # order is 1.6748033428458136
println("PL1WM:", sim.𝒪est[:weak_final])

"""
 Test Diagonal noise SDEs (iip), SIAM Journal on Numerical Analysis, 47 (2009), pp. 1713–1738
"""

@info "Diagonal noise"

u₀ = [0.1, 0.1]
function f3!(du, u, p, t)
    du[1] = 3 // 2 * u[1]
    return du[2] = 3 // 2 * u[2]
end
function g3!(du, u, p, t)
    du[1] = 1 // 10 * u[1]
    return du[2] = 1 // 10 * u[2]
end
dts = 1 .// 2 .^ (3:-1:0)
tspan = (0.0, 1.0)

h3(z) = z^2 # == 1//10**exp(3//2*t) if h3(z) = z and  == 1//100**exp(301//100*t) if h3(z) = z^2 )

prob = SDEProblem(f3!, g3!, u₀, tspan)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h3(sol.u[end][1]), false),
    prob_func = prob_func
)

numtraj = Int(5.0e4)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, PL1WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3 # order is 1.7612533343540109
println("PL1WM:", sim.𝒪est[:weak_final])

"""
 Test Additive noise SDEs Kloeden & Platen Exercise 14.4.1
"""

numtraj = Int(1.0e4)
u₀ = 0.1
fadd(u, p, t) = p[1] * u
gadd(u, p, t) = p[2]
dts = 1 .// 2 .^ (4:-1:0)
tspan = (0.0, 1.0)
p = [2 // 2, 1 // 100]

seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

prob = SDEProblem(fadd, gadd, u₀, tspan, p)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (sol.u[end], false),
    prob_func = prob_func
)

sim = test_convergence(
    dts, ensemble_prob, PL1WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)

@test abs(sim.𝒪est[:weak_final] - 2) < 0.3 # order is 1.9494776704064192
println("PL1WM:", sim.𝒪est[:weak_final])

sim1 = test_convergence(
    dts, ensemble_prob, PL1WMA(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)

@test abs(sim1.𝒪est[:weak_final] - 2) < 0.3 # order is PL1WMA:1.9494776704064316
println("PL1WMA:", sim1.𝒪est[:weak_final])

@test all(
    [
        all([sim.solutions[i].u[j] ≈ sim1.solutions[i].u[j] for j in 1:numtraj])
            for i in 1:length(sim.solutions)
    ]
)

#inplace

u₀ = [0.1]
fadd!(du, u, p, t) = @.(du = p[1] * u)
gadd!(du, u, p, t) = @.(du = p[2])

prob = SDEProblem(fadd!, gadd!, u₀, tspan, p)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (sol.u[end][1], false),
    prob_func = prob_func
)

sim = test_convergence(
    dts, ensemble_prob, PL1WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)

@test abs(sim.𝒪est[:weak_final] - 2) < 0.3 # order is 1.9494776704064192
println("PL1WM:", sim.𝒪est[:weak_final])

sim1 = test_convergence(
    dts, ensemble_prob, PL1WMA(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)

@test abs(sim1.𝒪est[:weak_final] - 2) < 0.3 # order is 1.9494776704064316
println("PL1WMA:", sim1.𝒪est[:weak_final])

@test all(
    [
        all([sim.solutions[i].u[j] ≈ sim1.solutions[i].u[j] for j in 1:numtraj])
            for i in 1:length(sim.solutions)
    ]
)

################################################################################
# Implicit Weak Order 2 SRK Methods
# IRI1: Implicit Rößler 1 - drift-implicit version of RI1 with weak order 2.0

"""
IRI1 perform_step! implementation (constant cache, out-of-place)

This implements a drift-implicit weak order 2 stochastic Runge-Kutta method
based on the RI1 scheme with theta-method implicitization of the drift.
"""
@muladd function perform_step!(integrator, cache::IRI1ConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (;
        nlsolver, a021, a031, a032, a121, a131, b021, b031, b121, b131,
        b221, b222, b223, b231, b232, b233, α1, α2, α3, c02, c03, c12, c13,
        beta11, beta12, beta13, beta22, beta23, beta31, beta32, beta33,
        beta42, beta43, NORMAL_ONESIX_QUANTILE,
    ) = cache

    alg = unwrap_alg(integrator, true)
    theta = alg.theta
    OrdinaryDiffEqNonlinearSolve.markfirststage!(nlsolver)
    repeat_step = false

    # Define three-point distributed random variables
    dW_scaled = W.dW / sqrt(dt)
    sq3dt = sqrt(3 * dt)
    _dW = map(x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), dW_scaled)
    chi1 = map(x -> (x^2 - dt) / 2, _dW)  # diagonal of Ihat2

    if !(W.dW isa Number)
        m = length(W.dW)
        _dZ = map(x -> calc_twopoint_random(integrator.sqdt, x), W.dZ)
    else
        m = 1
    end

    # Stage 1: Compute k1 implicitly
    # For implicit treatment: k1 = f(Y1) where Y1 = uprev + theta*dt*k1
    # Using nlsolver to find k1

    # Initial guess for z (where z = theta*dt*k1)
    z = zero(uprev)
    nlsolver.z = z
    nlsolver.c = theta
    nlsolver.tmp = uprev
    z = OrdinaryDiffEqNonlinearSolve.nlsolve!(nlsolver, integrator, cache, repeat_step)
    OrdinaryDiffEqNonlinearSolve.nlsolvefail(nlsolver) && return nothing

    # k1 = z / (theta * dt) but we store the full drift contribution
    Y1 = uprev + z  # Y1 is the implicit stage value
    k1 = integrator.f(Y1, p, t)  # Evaluate drift at implicit stage

    # Compute g1 at uprev (diffusion remains explicit)
    g1 = integrator.f.g(uprev, p, t)

    # H^(0) Stage 2
    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        H02 = uprev + a021 * k1 * dt + b021 * g1 * _dW
    else
        H02 = uprev + a021 * k1 * dt + b021 * g1 .* _dW
    end

    # Stage 2: Compute k2 implicitly at H02
    nlsolver.z = zero(uprev)
    nlsolver.tmp = H02
    nlsolver.c = theta
    z2 = OrdinaryDiffEqNonlinearSolve.nlsolve!(nlsolver, integrator, cache, repeat_step)
    OrdinaryDiffEqNonlinearSolve.nlsolvefail(nlsolver) && return nothing

    Y2 = H02 + z2
    k2 = integrator.f(Y2, p, t + c02 * dt)

    # H^(0) Stage 3
    H03 = uprev + a032 * k2 * dt + a031 * k1 * dt
    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        H03 += b031 * g1 * _dW
    else
        H03 += b031 * g1 .* _dW
    end

    # Stage 3: Compute k3 implicitly at H03
    nlsolver.z = zero(uprev)
    nlsolver.tmp = H03
    nlsolver.c = theta
    z3 = OrdinaryDiffEqNonlinearSolve.nlsolve!(nlsolver, integrator, cache, repeat_step)
    OrdinaryDiffEqNonlinearSolve.nlsolvefail(nlsolver) && return nothing

    Y3 = H03 + z3
    k3 = integrator.f(Y3, p, t + c03 * dt)

    # H^(k) stages for diffusion (explicit as in original RI1)
    if W.dW isa Number
        H12 = uprev + a121 * k1 * dt + b121 * g1 * integrator.sqdt
        H13 = uprev + a131 * k1 * dt + b131 * g1 * integrator.sqdt
    else
        H12 = [uprev .+ a121 * k1 * dt for k in 1:m]
        H13 = [uprev .+ a131 * k1 * dt for k in 1:m]
        for k in 1:m
            if is_diagonal_noise(integrator.sol.prob)
                tmp = zero(integrator.u)
                tmp[k] = g1[k]
                H12[k] += b121 * tmp * integrator.sqdt
                H13[k] += b131 * tmp * integrator.sqdt
            else
                H12[k] += b121 * g1[:, k] * integrator.sqdt
                H13[k] += b131 * g1[:, k] * integrator.sqdt
            end
        end
    end

    # Compute g2 and g3 at H12 and H13
    if W.dW isa Number
        g2 = integrator.f.g(H12, p, t + c12 * dt)
        g3 = integrator.f.g(H13, p, t + c13 * dt)
    else
        g2 = [integrator.f.g(H12[k], p, t + c12 * dt) for k in 1:m]
        g3 = [integrator.f.g(H13[k], p, t + c13 * dt) for k in 1:m]
        H22 = [copy(uprev) for k in 1:m]
        H23 = [copy(uprev) for k in 1:m]
        for k in 1:m
            if is_diagonal_noise(integrator.sol.prob)
                tmp = zero(integrator.u)
                tmp[k] = b221 * g1[k] + b222 * g2[k][k] + b223 * g3[k][k]
                H22[k] += tmp * integrator.sqdt
                tmp[k] = b231 * g1[k] + b232 * g2[k][k] + b233 * g3[k][k]
                H23[k] += tmp * integrator.sqdt
            else
                H22[k] += (b221 * g1[:, k] + b222 * g2[k][:, k] + b223 * g3[k][:, k]) *
                    integrator.sqdt
                H23[k] += (b231 * g1[:, k] + b232 * g2[k][:, k] + b233 * g3[k][:, k]) *
                    integrator.sqdt
            end
        end
    end

    # Final update: combine drift (implicit) and diffusion (explicit)
    u = uprev + α1 * k1 * dt + α2 * k2 * dt + α3 * k3 * dt

    # Add noise contribution (same as explicit RI1)
    if W.dW isa Number
        u += g1 * (_dW * beta11) + g2 * (_dW * beta12 + chi1 * beta22 / integrator.sqdt) +
            g3 * (_dW * beta13 + chi1 * beta23 / integrator.sqdt)
    else
        if is_diagonal_noise(integrator.sol.prob)
            u += g1 .* _dW * beta11
            for k in 1:m
                u[k] += g2[k][k] * _dW[k] * beta12 + g3[k][k] * _dW[k] * beta13
                u[k] += g2[k][k] * chi1[k] * beta22 / integrator.sqdt +
                    g3[k][k] * chi1[k] * beta23 / integrator.sqdt
                u[k] += (m - 1) * beta31 * g1[k] * _dW[k]
                for l in 1:m
                    if l != k
                        ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, k, l)
                        tmpg = integrator.f.g(H22[l], p, t)
                        u[k] += tmpg[k] *
                            (_dW[k] * beta32 + ihat2 * beta42 / integrator.sqdt)
                        tmpg = integrator.f.g(H23[l], p, t)
                        u[k] += tmpg[k] *
                            (_dW[k] * beta33 + ihat2 * beta43 / integrator.sqdt)
                    end
                end
            end
        else
            for k in 1:m
                g1k = @view g1[:, k]
                g2k = @view g2[k][:, k]
                g3k = @view g3[k][:, k]
                @.. u = u + g1k * _dW[k] * (beta11 + (m - 1) * beta31)
                @.. u = u + g2k * _dW[k] * beta12 + g3k * _dW[k] * beta13
                @.. u = u + g2k * chi1[k] * beta22 / integrator.sqdt +
                    g3k * chi1[k] * beta23 / integrator.sqdt
                for l in 1:m
                    if l != k
                        ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, k, l)
                        tmpg = integrator.f.g(H22[l], p, t)
                        tmpgk = @view tmpg[:, k]
                        @.. u = u +
                            tmpgk * (_dW[k] * beta32 + ihat2 * beta42 / integrator.sqdt)
                        tmpg = integrator.f.g(H23[l], p, t)
                        tmpgk = @view tmpg[:, k]
                        @.. u = u +
                            tmpgk * (_dW[k] * beta33 + ihat2 * beta43 / integrator.sqdt)
                    end
                end
            end
        end
    end

    # Adaptive error estimation
    if integrator.opts.adaptive &&
            (W.dW isa Number || is_diagonal_noise(integrator.sol.prob) || m == 1)
        # Compare against lower order method (similar to DRI1)
        if c03 != 0.0
            rat = c02 / c03
            δ₁ = integrator.opts.delta * (rat - 1)
            δ₂ = -integrator.opts.delta * rat
            uhat = uprev +
                ((α1 + δ₁) * k1 + (α2 + integrator.opts.delta) * k2 + (α3 + δ₂) * k3) *
                dt
        else
            uhat = uprev + k1 * dt
        end
        if is_diagonal_noise(integrator.sol.prob)
            uhat += g1 .* _dW
        else
            uhat += g1 * _dW
        end

        resids = calculate_residuals(
            u - uhat, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end

    integrator.u = u
end

# Ihat2 for IRI1ConstantCache (same as DRI1)
function Ihat2(cache::IRI1ConstantCache, _dW, _dZ, sqdt, k, l)
    # Two-point approximation of iterated integral (same as DRI1)
    if k < l
        return (_dW[k] * _dW[l] - sqdt * _dZ[k]) / 2
    elseif l < k
        return (_dW[k] * _dW[l] + sqdt * _dZ[l]) / 2
    else
        # l == k
        return (_dW[k]^2 - sqdt^2) / 2
    end
end

"""
IRI1 perform_step! implementation (mutable cache, in-place)
"""
@muladd function perform_step!(integrator, cache::IRI1Cache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (;
        _dW, _dZ, chi1, g1, g2, g3, k1, k2, k3, H02, H03, H12, H13, H22, H23,
        tmp, tmpg, resids, nlsolver, uhat,
        a021, a031, a032, a121, a131, b021, b031, b121, b131,
        b221, b222, b223, b231, b232, b233, α1, α2, α3, c02, c03, c12, c13,
        beta11, beta12, beta13, beta22, beta23, beta31, beta32, beta33,
        beta42, beta43, NORMAL_ONESIX_QUANTILE,
    ) = cache
    (; z) = nlsolver

    alg = unwrap_alg(integrator, true)
    theta = alg.theta
    OrdinaryDiffEqNonlinearSolve.markfirststage!(nlsolver)
    repeat_step = false

    m = is_diagonal_noise(integrator.sol.prob) ? length(W.dW) : size(g1, 2)
    sq3dt = sqrt(3 * dt)

    # Define three-point distributed random variables
    if W.dW isa Union{SArray, Number}
        _dW = map(
            x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x),
            W.dW / sqrt(dt)
        )
    else
        sqrtdt = sqrt(dt)
        @.. chi1 = W.dW / sqrtdt
        calc_threepoint_random!(_dW, sq3dt, NORMAL_ONESIX_QUANTILE, chi1)
        map!(x -> (x^2 - dt) / 2, chi1, _dW)

        if m > 1 && _dZ !== nothing
            calc_twopoint_random!(_dZ, integrator.sqdt, W.dZ)
        end
    end

    # Compute g1 (diffusion is explicit)
    integrator.f.g(g1, uprev, p, t)

    # Stage 1: Implicit solve for k1
    @.. z = zero(eltype(u))
    nlsolver.z = z
    nlsolver.c = theta
    @.. nlsolver.tmp = uprev

    z = OrdinaryDiffEqNonlinearSolve.nlsolve!(nlsolver, integrator, cache, repeat_step)
    OrdinaryDiffEqNonlinearSolve.nlsolvefail(nlsolver) && return

    @.. tmp = uprev + z  # Y1
    integrator.f(k1, tmp, p, t)

    # H^(0) Stage 2
    if is_diagonal_noise(integrator.sol.prob)
        @.. H02 = uprev + a021 * k1 * dt + b021 * g1 * _dW
    else
        mul!(tmp, g1, _dW)
        @.. H02 = uprev + a021 * k1 * dt + b021 * tmp
    end

    # Stage 2: Implicit solve for k2
    @.. z = zero(eltype(u))
    nlsolver.z = z
    nlsolver.c = theta
    @.. nlsolver.tmp = H02

    z = OrdinaryDiffEqNonlinearSolve.nlsolve!(nlsolver, integrator, cache, repeat_step)
    OrdinaryDiffEqNonlinearSolve.nlsolvefail(nlsolver) && return

    @.. tmp = H02 + z  # Y2
    integrator.f(k2, tmp, p, t + c02 * dt)

    # H^(0) Stage 3
    @.. H03 = uprev + a032 * k2 * dt + a031 * k1 * dt
    if is_diagonal_noise(integrator.sol.prob)
        @.. H03 += b031 * g1 * _dW
    else
        mul!(tmp, g1, _dW)
        @.. H03 += b031 * tmp
    end

    # Stage 3: Implicit solve for k3
    @.. z = zero(eltype(u))
    nlsolver.z = z
    nlsolver.c = theta
    @.. nlsolver.tmp = H03

    z = OrdinaryDiffEqNonlinearSolve.nlsolve!(nlsolver, integrator, cache, repeat_step)
    OrdinaryDiffEqNonlinearSolve.nlsolvefail(nlsolver) && return

    @.. tmp = H03 + z  # Y3
    integrator.f(k3, tmp, p, t + c03 * dt)

    # H^(k) stages for diffusion (explicit)
    for k in 1:m
        @.. H12[k] = uprev + a121 * k1 * dt
        @.. H13[k] = uprev + a131 * k1 * dt
        if is_diagonal_noise(integrator.sol.prob)
            H12[k][k] += b121 * g1[k] * integrator.sqdt
            H13[k][k] += b131 * g1[k] * integrator.sqdt
        else
            g1k = @view g1[:, k]
            @.. H12[k] += b121 * g1k * integrator.sqdt
            @.. H13[k] += b131 * g1k * integrator.sqdt
        end
    end

    # Compute g2 and g3
    for k in 1:m
        integrator.f.g(g2[k], H12[k], p, t + c12 * dt)
        integrator.f.g(g3[k], H13[k], p, t + c13 * dt)
    end

    # H22 and H23 for non-diagonal noise
    if m > 1
        for k in 1:m
            @.. H22[k] = uprev
            @.. H23[k] = uprev
            if is_diagonal_noise(integrator.sol.prob)
                H22[k][k] += (b221 * g1[k] + b222 * g2[k][k] + b223 * g3[k][k]) *
                    integrator.sqdt
                H23[k][k] += (b231 * g1[k] + b232 * g2[k][k] + b233 * g3[k][k]) *
                    integrator.sqdt
            else
                g1k = @view g1[:, k]
                g2kk = @view g2[k][:, k]
                g3kk = @view g3[k][:, k]
                @.. H22[k] += (b221 * g1k + b222 * g2kk + b223 * g3kk) * integrator.sqdt
                @.. H23[k] += (b231 * g1k + b232 * g2kk + b233 * g3kk) * integrator.sqdt
            end
        end
    end

    # Final update
    @.. u = uprev + α1 * k1 * dt + α2 * k2 * dt + α3 * k3 * dt

    # Add noise contribution
    if is_diagonal_noise(integrator.sol.prob)
        @.. u += g1 * _dW * beta11
        for k in 1:m
            u[k] += g2[k][k] * _dW[k] * beta12 + g3[k][k] * _dW[k] * beta13
            u[k] += g2[k][k] * chi1[k] * beta22 / integrator.sqdt +
                g3[k][k] * chi1[k] * beta23 / integrator.sqdt
            u[k] += (m - 1) * beta31 * g1[k] * _dW[k]
            for l in 1:m
                if l != k
                    ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, k, l)
                    integrator.f.g(tmpg, H22[l], p, t)
                    u[k] += tmpg[k] * (_dW[k] * beta32 + ihat2 * beta42 / integrator.sqdt)
                    integrator.f.g(tmpg, H23[l], p, t)
                    u[k] += tmpg[k] * (_dW[k] * beta33 + ihat2 * beta43 / integrator.sqdt)
                end
            end
        end
    else
        for k in 1:m
            g1k = @view g1[:, k]
            g2k = @view g2[k][:, k]
            g3k = @view g3[k][:, k]
            @.. u = u + g1k * _dW[k] * (beta11 + (m - 1) * beta31)
            @.. u = u + g2k * _dW[k] * beta12 + g3k * _dW[k] * beta13
            @.. u = u + g2k * chi1[k] * beta22 / integrator.sqdt +
                g3k * chi1[k] * beta23 / integrator.sqdt
            for l in 1:m
                if l != k
                    ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, k, l)
                    integrator.f.g(tmpg, H22[l], p, t)
                    tmpgk = @view tmpg[:, k]
                    @.. u = u + tmpgk * (_dW[k] * beta32 + ihat2 * beta42 / integrator.sqdt)
                    integrator.f.g(tmpg, H23[l], p, t)
                    tmpgk = @view tmpg[:, k]
                    @.. u = u + tmpgk * (_dW[k] * beta33 + ihat2 * beta43 / integrator.sqdt)
                end
            end
        end
    end

    # Adaptive error estimation
    if integrator.opts.adaptive &&
            (W.dW isa Number || is_diagonal_noise(integrator.sol.prob) || m == 1)
        if c03 != 0.0
            rat = c02 / c03
            δ₁ = integrator.opts.delta * (rat - 1)
            δ₂ = -integrator.opts.delta * rat
            @.. uhat = uprev +
                (
                (α1 + δ₁) * k1 + (α2 + integrator.opts.delta) * k2 +
                    (α3 + δ₂) * k3
            ) * dt
        else
            @.. uhat = uprev + k1 * dt
        end
        if is_diagonal_noise(integrator.sol.prob)
            @.. uhat += g1 * _dW
        else
            mul!(tmp, g1, _dW)
            @.. uhat += tmp
        end

        @.. tmp = u - uhat
        calculate_residuals!(
            resids, tmp, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end
end

# Ihat2 for IRI1Cache (same as DRI1)
function Ihat2(cache::IRI1Cache, _dW, _dZ, sqdt, k, l)
    # Two-point approximation of iterated integral (same as DRI1)
    if k < l
        return (_dW[k] * _dW[l] - sqdt * _dZ[k]) / 2
    elseif l < k
        return (_dW[k] * _dW[l] + sqdt * _dZ[l]) / 2
    else
        # l == k
        return (_dW[k]^2 - sqdt^2) / 2
    end
end

using StochasticDiffEqWeak, Test, DiffEqNoiseProcess
using Random

function brusselator_f!(du, u, p, t)
    @inbounds begin
        du[1] = (p[1] - 1) * u[1] + p[1] * u[1]^2 + (u[1] + 1)^2 * u[2]
        du[2] = -p[1] * u[1] - p[1] * u[1]^2 - (u[1] + 1)^2 * u[2]
    end
    return nothing
end

function scalar_noise!(du, u, p, t)
    @inbounds begin
        du[1] = p[2] * u[1] * (1 + u[1])
        du[2] = -p[2] * u[1] * (1 + u[1])
    end
    return nothing
end

function prob_func(prob, i, repeat)
    Random.seed!(seeds[i])
    W = WienerProcess(0.0, 0.0, 0.0)
    return remake(prob, noise = W)
end

# fix seeds
seed = 100
Random.seed!(seed)
numtraj = 100
seeds = rand(UInt, numtraj)
W = WienerProcess(0.0, 0.0, 0.0)

#CUDA.allowscalar(false)
u0 = [-0.1f0, 0.0f0]
tspan = (0.0f0, 100.0f0)
p = [1.9f0, 0.1f0]

prob = SDEProblem(brusselator_f!, scalar_noise!, u0, tspan, p, noise = W)
ensembleprob = EnsembleProblem(prob, prob_func = prob_func)

@info "Brusselator"

#Performance check with nvvp
# CUDAnative.CUDAdrv.@profile
# check either on CPU with EnsembleCPUArray() or on GPU with EnsembleGPUArray()
@test_nowarn sol = @time solve(ensembleprob, DRI1(), EnsembleThreads(), trajectories = numtraj)
#sol = @time solve(ensembleprob,DRI1(),EnsembleGPUArray(),trajectories=numtraj)

@muladd function perform_step!(integrator, cache::DRI1ConstantCache)
    (;
        a021, a031, a032, a121, a131, b021, b031, b121, b131, b221, b222, b223, b231,
        b232, b233, α1, α2, α3, c02, c03, c12, c13, beta11, beta12, beta13, beta22,
        beta23, beta31, beta32, beta33, beta42, beta43, NORMAL_ONESIX_QUANTILE,
    ) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    # define three-point distributed random variables
    dW_scaled = W.dW / sqrt(dt)
    sq3dt = sqrt(3 * dt)
    _dW = map(x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), dW_scaled)
    chi1 = map(x -> (x^2 - dt) / 2, _dW) # diagonal of Ihat2
    if !(W.dW isa Number)
        m = length(W.dW)
        # define two-point distributed random variables
        _dZ = map(x -> calc_twopoint_random(integrator.sqdt, x), W.dZ)
    end

    # compute stage values
    k1 = integrator.f(uprev, p, t)
    g1 = integrator.f.g(uprev, p, t)

    # H_i^(0), stage 1
    # H01 = uprev
    # H_i^(0), stage 2
    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        H02 = uprev + a021 * k1 * dt + b021 * g1 * _dW
    else
        H02 = uprev + a021 * k1 * dt + b021 * g1 .* _dW
    end

    # H_i^(0), stage 3 (requires H_i^(k) stage 2 in general)
    k2 = integrator.f(H02, p, t + c02 * dt)
    H03 = uprev + a032 * k2 * dt + a031 * k1 * dt
    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        H03 += b031 * g1 * _dW
    else
        H03 += b031 * g1 .* _dW
    end

    k3 = integrator.f(H03, p, t + c03 * dt)

    # H_i^(k), stage 1
    # H11 = uprev
    # H_i^(k), stage 2 and 3
    if W.dW isa Number
        H12 = uprev + a121 * k1 * dt + b121 * g1 * integrator.sqdt
        H13 = uprev + a131 * k1 * dt + b131 * g1 * integrator.sqdt
    else
        H12 = [uprev .+ a121 * k1 * dt for k in 1:m]
        H13 = [uprev .+ a131 * k1 * dt for k in 1:m]
        for k in 1:m
            if is_diagonal_noise(integrator.sol.prob)
                tmp = zero(integrator.u)
                tmp[k] = g1[k]
                H12[k] += b121 * tmp * integrator.sqdt
                H13[k] += b131 * tmp * integrator.sqdt
            else
                H12[k] += b121 * g1[:, k] * integrator.sqdt
                H13[k] += b131 * g1[:, k] * integrator.sqdt
            end
        end
    end

    # H^_i^(k), stage 1
    # H21 = uprev
    # H^_i^(k), stage 2 and 3

    if W.dW isa Number
        g2 = integrator.f.g(H12, p, t + c12 * dt)
        g3 = integrator.f.g(H13, p, t + c13 * dt)
        # for m=1:  H22 = uprev
    else
        g2 = [integrator.f.g(H12[k], p, t + c12 * dt) for k in 1:m]
        g3 = [integrator.f.g(H13[k], p, t + c13 * dt) for k in 1:m]
        H22 = [copy(uprev) for k in 1:m]
        H23 = [copy(uprev) for k in 1:m]
        # add inbounds for speed if working properly
        for k in 1:m
            if is_diagonal_noise(integrator.sol.prob)
                tmp = zero(integrator.u)
                tmp[k] = b221 * g1[k] + b222 * g2[k][k] + b223 * g3[k][k]
                H22[k] += tmp * integrator.sqdt
                tmp[k] = b231 * g1[k] + b232 * g2[k][k] + b233 * g3[k][k]
                H23[k] += tmp * integrator.sqdt
            else
                H22[k] += (b221 * g1[:, l] + b222 * g2[l][:, l] + b223 * g3[l][:, l]) * integrator.sqdt
                H23[k] += (b231 * g1[:, l] + b232 * g2[l][:, l] + b233 * g3[l][:, l]) * integrator.sqdt
            end
        end
    end

    # add stages together Eq. (3)
    u = uprev + α1 * k1 * dt + α2 * k2 * dt + α3 * k3 * dt

    # add noise
    if W.dW isa Number
        # lines 2 and 3
        u += g1 * (_dW * beta11) + g2 * (_dW * beta12 + chi1 * beta22 / integrator.sqdt) +
            g3 * (_dW * beta13 + chi1 * beta23 / integrator.sqdt)
        # lines 4 and 5 are zero by construction
        # u += g1*(_dW*(beta31+beta32+beta33)+chi1*integrator.sqdt*(beta42+beta43))
    else
        if is_diagonal_noise(integrator.sol.prob)
            u += g1 .* _dW * beta11
            for k in 1:m
                u[k] += g2[k][k] * _dW[k] * beta12 + g3[k][k] * _dW[k] * beta13
                u[k] += g2[k][k] * chi1[k] * beta22 / integrator.sqdt +
                    g3[k][k] * chi1[k] * beta23 / integrator.sqdt
                u[k] += (m - 1) * beta31 * g1[k] * _dW[k]
                for l in 1:m
                    if l != k
                        ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, k, l)
                        tmpg = integrator.f.g(H22[l], p, t)
                        u[k] += tmpg[k] * (_dW[k] * beta32 + ihat2 * beta42 / integrator.sqdt)
                        tmpg = integrator.f.g(H23[l], p, t)
                        u[k] += tmpg[k] * (_dW[k] * beta33 + ihat2 * beta43 / integrator.sqdt)
                    end
                end
            end
        else
            # non-diag noise
            for k in 1:m
                g1k = @view g1[:, k]
                g2k = @view g2[k][:, k]
                g3k = @view g3[k][:, k]
                @.. u = u + g1k * _dW[k] * (beta11 + (m - 1) * beta31)
                @.. u = u + g2k * _dW[k] * beta12 + g3k * _dW[k] * beta13
                @.. u = u + g2k * chi1[k] * beta22 / integrator.sqdt +
                    g3k * chi1[k] * beta23 / integrator.sqdt
                for l in 1:m
                    if l != k
                        ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, k, l)
                        tmpg = integrator.f.g(H22[l], p, t)
                        tmpgk = @view tmpg[:, k]
                        @.. u = u + tmpgk * (_dW[k] * beta32 + ihat2 * beta42 / integrator.sqdt)
                        tmpg = integrator.f.g(H23[l], p, t)
                        tmpgk = @view tmpg[:, k]
                        @.. u = u + tmpgk * (_dW[k] * beta33 + ihat2 * beta43 / integrator.sqdt)
                    end
                end
            end
        end
    end

    if integrator.opts.adaptive &&
            (W.dW isa Number || is_diagonal_noise(integrator.sol.prob) || m == 1)

        # schemes with lower convergence order
        if c03 != 0.0
            # scheme has det. conv. order 3 and we look for det. conv. order 2 scheme
            rat = c02 / c03
            δ₁ = integrator.opts.delta * (rat - 1)
            δ₂ = -integrator.opts.delta * rat
            uhat = uprev + ((α1 + δ₁) * k1 + (α2 + integrator.opts.delta) * k2 + (α3 + δ₂) * k3) * dt
        else
            # check against EM
            uhat = uprev + k1 * dt
        end
        if is_diagonal_noise(integrator.sol.prob)
            uhat += g1 .* _dW
        else
            uhat += g1 * _dW
        end

        resids = calculate_residuals(
            u - uhat, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end

    integrator.u = u
end

@muladd function perform_step!(integrator, cache::DRI1Cache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (;
        _dW, _dZ, chi1, tab, g1, g2, g3, k1, k2, k3, H02, H03, H12,
        H13, H22, H23, tmp1, tmpg, uhat, tmp, resids,
    ) = cache
    (;
        a021,
        a031, a032, a121, a131, b021, b031, b121, b131, b221, b222, b223, b231, b232,
        b233, α1, α2, α3, c02, c03, c12, c13, beta11, beta12, beta13, beta22, beta23,
        beta31, beta32, beta33, beta42, beta43, NORMAL_ONESIX_QUANTILE,
    ) = cache.tab

    m = length(W.dW)
    sq3dt = sqrt(3 * dt)
    if W.dW isa Union{SArray, Number}
        # tbd
        _dW = map(
            x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), W.dW /
                sqrt(dt)
        )
    else
        # define three-point distributed random variables
        sqrtdt = sqrt(dt)
        @.. chi1 = W.dW / sqrtdt
        calc_threepoint_random!(_dW, sq3dt, NORMAL_ONESIX_QUANTILE, chi1)
        map!(x -> (x^2 - dt) / 2, chi1, _dW)

        # define two-point distributed random variables
        if m > 1
            calc_twopoint_random!(_dZ, integrator.sqdt, W.dZ)
        end
    end

    # compute stage values
    integrator.f(k1, uprev, p, t)
    integrator.f.g(g1, uprev, p, t)

    # H_i^(0), stage 1
    # H01 = uprev
    # H_i^(0), stage 2
    if is_diagonal_noise(integrator.sol.prob)
        @.. H02 = uprev + a021 * k1 * dt + b021 * g1 * _dW
    else
        mul!(tmp1, g1, _dW)
        @.. H02 = uprev + dt * a021 * k1 + b021 * tmp1
    end

    integrator.f(k2, H02, p, t + c02 * dt)
    if is_diagonal_noise(integrator.sol.prob)
        @.. H03 = uprev + a032 * k2 * dt + a031 * k1 * dt + b031 * g1 * _dW
    else
        @.. H03 = uprev + a032 * k2 * dt + a031 * k1 * dt + b031 * tmp1
    end

    integrator.f(k3, H03, p, t + c03 * dt)

    # H_i^(k), stages
    # H11 = uprev
    for k in 1:m
        if is_diagonal_noise(integrator.sol.prob)
            fill!(tmpg, zero(eltype(integrator.u)))
            tmpg[k] = g1[k]
            @.. H12[k] = uprev + a121 * k1 * dt + b121 * tmpg * integrator.sqdt
            @.. H13[k] = uprev + a131 * k1 * dt + b131 * tmpg * integrator.sqdt
        else
            g1k = @view g1[:, k]
            @.. H12[k] = uprev + a121 * k1 * dt + b121 * g1k * integrator.sqdt
            @.. H13[k] = uprev + a131 * k1 * dt + b131 * g1k * integrator.sqdt
        end
        integrator.f.g(g2[k], H12[k], p, t + c12 * dt)
        integrator.f.g(g3[k], H13[k], p, t + c13 * dt)
    end

    # H^_i^(k), stages (rewritten)
    for k in 1:m
        if is_diagonal_noise(integrator.sol.prob)
            fill!(tmpg, zero(eltype(integrator.u)))
            tmpg[k] = b221 * g1[k] + b222 * g2[k][k] + b223 * g3[k][k]
            @.. H22[k] = uprev + tmpg * integrator.sqdt
            tmpg[k] = b231 * g1[k] + b232 * g2[k][k] + b233 * g3[k][k]
            @.. H23[k] = uprev + tmpg * integrator.sqdt
        else
            g1k = @view g1[:, k]
            g2k = @view g2[k][:, k]
            g3k = @view g3[k][:, k]
            @.. H22[k] = uprev + (b221 * g1k + b222 * g2k + b223 * g3k) * integrator.sqdt
            @.. H23[k] = uprev + (b231 * g1k + b232 * g2k + b233 * g3k) * integrator.sqdt
        end
    end

    # add stages together Eq. (3)
    @.. u = uprev + α1 * k1 * dt + α2 * k2 * dt + α3 * k3 * dt

    # add noise
    if is_diagonal_noise(integrator.sol.prob)
        @.. u = u + g1 * _dW * beta11
        for k in 1:m
            u[k] = u[k] + g2[k][k] * _dW[k] * beta12 + g3[k][k] * _dW[k] * beta13
            u[k] = u[k] + g2[k][k] * chi1[k] * beta22 / integrator.sqdt +
                g3[k][k] * chi1[k] * beta23 / integrator.sqdt
            if m > 1
                u[k] = u[k] + (m - 1) * beta31 * g1[k] * _dW[k]
                for l in 1:m
                    if l != k
                        ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, k, l)
                        integrator.f.g(tmpg, H22[l], p, t)
                        u[k] = u[k] + tmpg[k] * (_dW[k] * beta32 + ihat2 * beta42 / integrator.sqdt)
                        integrator.f.g(tmpg, H23[l], p, t)
                        u[k] = u[k] + tmpg[k] * (_dW[k] * beta33 + ihat2 * beta43 / integrator.sqdt)
                    end
                end
            end
        end
    else
        for k in 1:m
            g1k = @view g1[:, k]
            g2k = @view g2[k][:, k]
            g3k = @view g3[k][:, k]
            tmpgk = @view tmpg[:, k]
            @.. u = u + g1k * _dW[k] * (beta11 + (m - 1) * beta31)
            @.. u = u + g2k * _dW[k] * beta12 + g3k * _dW[k] * beta13
            @.. u = u + g2k * chi1[k] * beta22 / integrator.sqdt +
                g3k * chi1[k] * beta23 / integrator.sqdt
            for l in 1:m
                if l != k
                    ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, k, l)
                    integrator.f.g(tmpg, H22[l], p, t)
                    @.. u = u + tmpgk * (_dW[k] * beta32 + ihat2 * beta42 / integrator.sqdt)
                    integrator.f.g(tmpg, H23[l], p, t)
                    @.. u = u + tmpgk * (_dW[k] * beta33 + ihat2 * beta43 / integrator.sqdt)
                end
            end
        end
    end

    if integrator.opts.adaptive &&
            (W.dW isa Number || is_diagonal_noise(integrator.sol.prob) || m == 1)
        # schemes with lower convergence order
        if c03 != 0.0
            # scheme has det. conv. order 3 and we look for det. conv. order 2 scheme
            rat = c02 / c03
            δ₁ = integrator.opts.delta * (rat - 1)
            δ₂ = -integrator.opts.delta * rat
            @.. uhat = uprev + ((α1 + δ₁) * k1 + (α2 + integrator.opts.delta) * k2 + (α3 + δ₂) * k3) * dt
        else
            # check against EM
            @.. uhat = uprev + k1 * dt
        end
        if is_diagonal_noise(integrator.sol.prob)
            @.. uhat = uhat + g1 .* _dW
        else
            @.. uhat = uhat + g1 * _dW
        end
        @.. tmp = u - uhat

        calculate_residuals!(
            resids, tmp, uprev, uhat, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )

        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end
end

@muladd function perform_step!(integrator, cache::DRI1NMCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (;
        _dW, chi1, tab, g1, g2, g3, k1, k2, k3, H02, H03,
        H12, H13, tmp1, tmpg, uhat, tmp, resids,
    ) = cache
    (;
        a021, a031, a032, a121, a131, b021, b031, b121, b131, b221, b222, b223, b231,
        b232, b233, α1, α2, α3, c02, c03, c12, c13, beta11, beta12, beta13, beta22,
        beta23, beta31, beta32, beta33, beta42, beta43, NORMAL_ONESIX_QUANTILE,
    ) = tab

    m = length(W.dW)
    sq3dt = sqrt(3 * dt)
    if W.dW isa Union{SArray, Number}
        # tbd
        _dW = map(
            x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), W.dW /
                sqrt(dt)
        )
    else
        # define three-point distributed random variables
        sqrtdt = sqrt(dt)
        @.. chi1 = W.dW / sqrtdt
        calc_threepoint_random!(_dW, sq3dt, NORMAL_ONESIX_QUANTILE, chi1)
        map!(x -> (x^2 - dt) / 2, chi1, _dW)
    end

    # compute stage values
    integrator.f(k1, uprev, p, t)
    integrator.f.g(g1, uprev, p, t)

    # H_i^(0), stage 1
    # H01 = uprev
    # H_i^(0), stage 2
    if is_diagonal_noise(integrator.sol.prob)
        @.. H02 = uprev + a021 * k1 * dt + b021 * g1 * _dW
    else
        mul!(tmp1, g1, _dW)
        @.. H02 = uprev + dt * a021 * k1 + b021 * tmp1
    end

    integrator.f(k2, H02, p, t + c02 * dt)
    if is_diagonal_noise(integrator.sol.prob)
        @.. H03 = uprev + a032 * k2 * dt + a031 * k1 * dt + b031 * g1 * _dW
    else
        @.. H03 = uprev + a032 * k2 * dt + a031 * k1 * dt + b031 * tmp1
    end

    integrator.f(k3, H03, p, t + c03 * dt)

    # H_i^(k), stages
    # H11 = uprev

    if is_diagonal_noise(integrator.sol.prob)
        @.. H12 = uprev + a121 * k1 * dt + b121 * g1 * integrator.sqdt
        @.. H13 = uprev + a131 * k1 * dt + b131 * g1 * integrator.sqdt
    else
        mul!(tmp1, g1, integrator.sqdt)
        @.. H12 = uprev + a121 * k1 * dt + b121 * tmp1
        @.. H13 = uprev + a131 * k1 * dt + b131 * tmp1
    end

    # H^_i^(k), stages
    integrator.f.g(g2, H12, p, t + c12 * dt)
    integrator.f.g(g3, H13, p, t + c13 * dt)

    # add stages together Eq. (3)
    @.. u = uprev + α1 * k1 * dt + α2 * k2 * dt + α3 * k3 * dt

    # add noise
    if is_diagonal_noise(integrator.sol.prob)
        @.. u = u + (g1 * beta11 + g2 * beta12 + g3 * beta13) * _dW +
            g2 * chi1 * beta22 / integrator.sqdt + g3 * chi1 * beta23 / integrator.sqdt

    else
        @.. tmpg = g1 * beta11 + g2 * beta12 + g3 * beta13
        mul!(tmp1, tmpg, _dW)
        @.. u = u + tmp1
        @.. tmpg = g2 * beta22 / integrator.sqdt + g3 * beta23 / integrator.sqdt
        mul!(tmp1, tmpg, chi1)
        @.. u = u + tmp1
    end

    if integrator.opts.adaptive &&
            (W.dW isa Number || is_diagonal_noise(integrator.sol.prob) || m == 1)

        # schemes with lower convergence order
        if c03 != 0.0
            # scheme has det. conv. order 3 and we look for det. conv. order 2 scheme
            rat = c02 / c03
            δ₁ = integrator.opts.delta * (rat - 1)
            δ₂ = -integrator.opts.delta * rat
            @.. uhat = uprev + ((α1 + δ₁) * k1 + (α2 + integrator.opts.delta) * k2 + (α3 + δ₂) * k3) * dt
        else
            # check against EM
            @.. uhat = uprev + k1 * dt
        end
        if is_diagonal_noise(integrator.sol.prob)
            @.. uhat = uhat + g1 .* _dW
        else
            @.. uhat = uhat + g1 * _dW
        end
        @.. tmp = u - uhat

        calculate_residuals!(
            resids, tmp, uprev, uhat, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )

        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end
end

# Roessler SRK for first order weak approx
@muladd function perform_step!(integrator, cache::RDI1WMConstantCache)
    (; a021, b021, α1, α2, c02, beta11, NORMAL_ONESIX_QUANTILE) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    # define three-point distributed random variables
    dW_scaled = W.dW / sqrt(dt)
    sq3dt = sqrt(3 * dt)
    _dW = map(x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), dW_scaled)

    # compute stage values
    k1 = integrator.f(uprev, p, t)
    g1 = integrator.f.g(uprev, p, t)

    # H_i^(0), stage 1
    # H01 = uprev
    # H_i^(0), stage 2
    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        H02 = uprev + a021 * k1 * dt + b021 * g1 * _dW
    else
        H02 = uprev + a021 * k1 * dt + b021 * g1 .* _dW
    end
    k2 = integrator.f(H02, p, t + c02 * dt)

    # add stages together Eq. (3)
    u = uprev + α1 * k1 * dt + α2 * k2 * dt

    # add noise
    if W.dW isa Number
        # lines 2 and 3
        u += g1 * (_dW * beta11)
    else
        if is_diagonal_noise(integrator.sol.prob)
            u += g1 .* _dW * beta11
        else
            # non-diag noise
            for k in 1:m
                g1k = @view g1[:, k]
                @.. u = u + g1k * _dW[k] * (beta11)
            end
        end
    end

    integrator.u = u
end

@muladd function perform_step!(integrator, cache::RDI1WMCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (; _dW, chi1, tab, g1, k1, k2, H02, tmp1) = cache
    (; a021, b021, α1, α2, c02, beta11, NORMAL_ONESIX_QUANTILE) = tab

    m = length(W.dW)
    sq3dt = sqrt(3 * dt)
    if W.dW isa Union{SArray, Number}
        # tbd
        _dW = map(
            x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), W.dW /
                sqrt(dt)
        )
    else
        # define three-point distributed random variables
        @.. chi1 = W.dW / sqrt(dt)
        calc_threepoint_random!(_dW, sq3dt, NORMAL_ONESIX_QUANTILE, chi1)
    end

    # compute stage values
    integrator.f(k1, uprev, p, t)
    integrator.f.g(g1, uprev, p, t)

    # H_i^(0), stage 1
    # H01 = uprev
    # H_i^(0), stage 2
    if is_diagonal_noise(integrator.sol.prob)
        @.. H02 = uprev + a021 * k1 * dt + b021 * g1 * _dW
    else
        mul!(tmp1, g1, _dW)
        @.. H02 = uprev + dt * a021 * k1 + b021 * tmp1
    end

    integrator.f(k2, H02, p, t + c02 * dt)

    # add stages together Eq. (3)
    @.. u = uprev + α1 * k1 * dt + α2 * k2 * dt

    # add noise
    if is_diagonal_noise(integrator.sol.prob)
        @.. u = u + g1 * _dW * beta11
    else
        for k in 1:m
            g1k = @view g1[:, k]
            @.. u = u + g1k * _dW[k] * beta11
        end
    end
end

# Stratonovich sense

@muladd function perform_step!(integrator, cache::RSConstantCache)
    (;
        a021, a031, a032, a131, a141, b031, b032, b121, b131, b132, b141, b142, b143,
        b221, b231, b331, b332, b341, b342, α1, α2, α3, α4, c02, c03, c13, c14,
        beta11, beta12, beta13, beta14, beta22, beta23, NORMAL_ONESIX_QUANTILE,
    ) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    # define three-point distributed random variables
    dW_scaled = W.dW / sqrt(dt)
    sq3dt = sqrt(3 * dt)
    _dW = map(x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), dW_scaled)
    if !(W.dW isa Number)
        m = length(W.dW)
        # define two-point distributed random variables
        _dZ = map(x -> calc_twopoint_random(integrator.sqdt, x), W.dZ)
    end
    # compute stage values
    k1 = integrator.f(uprev, p, t)
    g1 = integrator.f.g(uprev, p, t)

    # H_1^(0)
    # H01 = uprev
    # H_2^(0)
    H02 = uprev + a021 * k1 * dt

    # H_1^(k)
    # H11 = uprev
    # H_2^(k), stage 2
    if W.dW isa Number
        H12 = uprev + b121 * g1 * _dW
    elseif is_diagonal_noise(integrator.sol.prob)
        H12 = Vector{typeof(uprev)}[uprev .+ b121 * g1[k] * _dW[k] for k in 1:m]
    else
        H12 = Vector{typeof(uprev)}[uprev .+ b121 * g1[:, k] * _dW[k] for k in 1:m]
    end

    if W.dW isa Number
        g2 = integrator.f.g(H12, p, t)
    else
        g2 = [integrator.f.g(H12[k], p, t) for k in 1:m]
    end

    # H_3^(k)
    if W.dW isa Number
        H13 = uprev + a131 * k1 * dt + b131 * g1 * _dW + b132 * g2 * _dW
    else
        H13 = [zero(typeof(uprev)) for k in 1:m]
        for k in 1:m
            H13[k] += uprev .+ a131 * k1 * dt
            if is_diagonal_noise(integrator.sol.prob)
                H13[k] += b131 * g1[k] * _dW[k] .+ b132 * g2[k] * _dW[k]
                for l in 1:m
                    if l != k
                        H13[k] += b331 * g1[l] * _dW[l] .+ b332 * g2[l][l] * _dW[l]
                    end
                end
            else
                H13 += b131 * g1[:, k] * _dW[k] .+ b132 * g2[k][:, k] * _dW[k]
                for l in 1:m
                    if l != k
                        H13[k] += b331 * g1[:, l] * _dW[l] .+ b332 * g2[l][:, l] * _dW[l]
                    end
                end
            end
        end
    end

    if W.dW isa Number
        g3 = integrator.f.g(H13, p, t + c13 * dt)
    else
        g3 = [integrator.f.g(H13[k], p, t + c13 * dt) for k in 1:m]
    end
    # H_3^(k)
    if W.dW isa Number
        H14 = uprev + a141 * k1 * dt + b141 * g1 * _dW + b142 * g2 * _dW + b143 * g3 * _dW
    else
        H14 = [zero(typeof(uprev)) for k in 1:m]
        for k in 1:m
            H14[k] += uprev .+ a141 * k1 * dt
            if is_diagonal_noise(integrator.sol.prob)
                H14[k] += b141 * g1[k] * _dW[k] .+ b142 * g2[k] * _dW[k] .+ b143 * g3[k] * _dW[k]
                for l in 1:m
                    if l != k
                        H14[k] += b341 * g1[l] * _dW[l] .+ b342 * g2[l][l] * _dW[l]
                    end
                end
            else
                H14 += b141 * g1[:, k] * _dW[k] .+ b142 * g2[k][:, k] * _dW[k] .+
                    b143 * g3[k][:, k] * _dW[k]
                for l in 1:m
                    if l != k
                        H14[k] += b341 * g1[:, l] * _dW[l] .+ b342 * g2[l][:, l] * _dW[l]
                    end
                end
            end
        end
    end

    if W.dW isa Number
        g4 = integrator.f.g(H14, p, t + c14 * dt)
    else
        g4 = [integrator.f.g(H14[k], p, t + c14 * dt) for k in 1:m]
    end

    # H_3^(0) (requires H_2^(k))
    k2 = integrator.f(H02, p, t + c02 * dt)
    H03 = uprev + a032 * k2 * dt + a031 * k1 * dt

    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        H03 += b031 * g1 * _dW
        if W.dW isa Number
            H03 += b032 * g2 * _dW
        else
            for k in 1:m
                H03 += b032 * g2[k][:, k] * _dW[k]
            end
        end
    else
        H03 += b031 * g1 .* _dW
        for k in 1:m
            H03 += b032 * g2[k][k] * _dW[k]
        end
    end

    k3 = integrator.f(H03, p, t + c03 * dt)

    # H_4^(0)
    # H04 = uprev; k4 = integrator.f(uprev,p,t+0*dt) = k1

    # H^_1^(k)
    # H21 = uprev
    # H^_2^(k) # H^_3^(k)

    if !(W.dW isa Number)
        H22 = [uprev for k in 1:m]
        H23 = [uprev for k in 1:m]
        # add inbounds for speed if working properly
        for k in 1:m
            for l in 1:m
                if k == l
                    continue
                end
                ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, k, l)
                if is_diagonal_noise(integrator.sol.prob)
                    @.. H22[k] += b221 * g1[l] * ihat2 / integrator.sqdt
                    @.. H23[k] += b231 * g1[l] * ihat2 / integrator.sqdt
                else
                    H22[k] += b221 * g1[:, l] * ihat2 / integrator.sqdt
                    H23[k] += b231 * g1[:, l] * ihat2 / integrator.sqdt
                end
            end
        end
    end
    # H^_4^(k)
    # H24 = uprev

    # add stages together Eq. (5.1)
    u = uprev + (α1 * k1 + α2 * k2 + α3 * k3 + α4 * k1) * dt

    # add noise
    if W.dW isa Number
        u += (g1 * beta11 + g2 * beta12 + g3 * beta13 + g4 * beta14) * _dW # beta2 terms are zero by construction
    else
        if is_diagonal_noise(integrator.sol.prob)
            u += g1 .* _dW * beta11
            for k in 1:m
                u[k] += (g2[k][k] * beta12 + g3[k][k] * beta13 + g4[k][k] * beta14) * _dW[k]
                tmpg = integrator.f.g(H22[k], p, t)
                u[k] = u[k] + tmpg[k] * beta22 * integrator.sqdt
                tmpg = integrator.f.g(H23[k], p, t)
                u[k] = u[k] + tmpg[k] * beta23 * integrator.sqdt
            end
        else
            # non-diag noise
            for k in 1:m
                g1k = @view g1[:, k]
                g2k = @view g2[k][:, k]
                g3k = @view g3[k][:, k]
                g4k = @view g4[k][:, k]
                @.. u = u + (g1k * beta11 + g2k * beta12 + g3k * beta13 + g4k * beta14) * _dW[k]
                tmpg = integrator.f.g(H22[k], p, t)
                @.. u = u + tmpg * beta22 * integrator.sqdt
                tmpg = integrator.f.g(H23[k], p, t)
                @.. u = u + tmpg * beta23 * integrator.sqdt
            end
        end
    end

    integrator.u = u
end

@muladd function perform_step!(integrator, cache::RSCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (;
        _dW, _dZ, chi1, tab, g1, g2, g3, g4, k1, k2, k3, H02,
        H03, H12, H13, H14, H22, H23, tmp1, tmpg,
    ) = cache
    (;
        a021, a031, a032, a131, a141, b031, b032, b121, b131, b132, b141, b142, b143,
        b221, b231, b331, b332, b341, b342, α1, α2, α3, α4, c02, c03, c13, c14,
        beta11, beta12, beta13, beta14, beta22, beta23, NORMAL_ONESIX_QUANTILE,
    ) = tab

    m = length(W.dW)
    sq3dt = sqrt(3 * dt)
    if W.dW isa Union{SArray, Number}
        # tbd
        _dW = map(
            x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), W.dW /
                sqrt(dt)
        )
    else
        # define three-point distributed random variables
        @.. chi1 = W.dW / sqrt(dt)
        calc_threepoint_random!(_dW, sq3dt, NORMAL_ONESIX_QUANTILE, chi1)
        map!(x -> (x^2 - dt) / 2, chi1, _dW)

        # define two-point distributed random variables
        calc_twopoint_random!(_dZ, integrator.sqdt, W.dZ)
    end

    # compute stage values
    integrator.f(k1, uprev, p, t)
    integrator.f.g(g1, uprev, p, t)

    # H_1^(0)
    # H01 = uprev
    # H_2^(0)
    @.. H02 = uprev + a021 * k1 * dt

    # H_1^(k)
    # H11 = uprev
    # H_2^(k), stage 2

    if is_diagonal_noise(integrator.sol.prob)
        for k in 1:m
            @.. H12[k] = uprev + b121 * g1[k] * _dW[k]
        end
    else
        for k in 1:m
            g1k = @view g1[:, k]
            @.. H12[k] = uprev .+ b121 * g1k * _dW[k]
        end
    end

    for k in 1:m
        integrator.f.g(g2[k], H12[k], p, t)
    end

    # H_3^(k)
    for k in 1:m
        @.. H13[k] = uprev + a131 * k1 * dt
        if is_diagonal_noise(integrator.sol.prob)
            @.. H13[k] = H13[k] + b131 * g1[k] * _dW[k] + b132 * g2[k] * _dW[k]
            for l in 1:m
                if l != k
                    @.. H13[k] = H13[k] + b331 * g1[l] * _dW[l] + b332 * g2[l] * _dW[l]
                end
            end
        else
            g1k = @view g1[:, k]
            g2k = @view g2[k][:, k]
            @.. H13[k] = H13[k] + b131 * g1k * _dW[k] + b132 * g2k * _dW[k]
            for l in 1:m
                if l != k
                    g1l = @view g1[:, l]
                    g2l = @view g2[l][:, l]
                    @.. H13[k] = H13[k] + b331 * g1l * _dW[l] + b332 * g2l * _dW[l]
                end
            end
        end
    end

    for k in 1:m
        integrator.f.g(g3[k], H13[k], p, t + c13 * dt)
    end

    # H_3^(k)
    for k in 1:m
        @.. H14[k] = uprev + a141 * k1 * dt
        if is_diagonal_noise(integrator.sol.prob)
            @.. H14[k] = H14[k] + b141 * g1[k] * _dW[k] + b142 * g2[k] * _dW[k] + b143 * g3[k] * _dW[k]
            for l in 1:m
                if l != k
                    @.. H14[k] = H14[k] + b341 * g1[l] * _dW[l] .+ b342 * g2[l] * _dW[l]
                end
            end
        else
            g1k = @view g1[:, k]
            g2k = @view g2[k][:, k]
            g3k = @view g3[k][:, k]

            @.. H14[k] = H14[k] + b141 * g1k * _dW[k] + b142 * g2k * _dW[k] + b143 * g3k * _dW[k]
            for l in 1:m
                if l != k
                    g1l = @view g1[:, l]
                    g2l = @view g2[l][:, l]
                    @.. H14[k] = H14[k] + b341 * g1l * _dW[l] + b342 * g2l * _dW[l]
                end
            end
        end
    end

    for k in 1:m
        integrator.f.g(g4[k], H14[k], p, t + c14 * dt)
    end

    # H_3^(0) (requires H_2^(k))
    integrator.f(k2, H02, p, t + c02 * dt)
    @.. H03 = uprev + a032 * k2 * dt + a031 * k1 * dt

    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        mul!(tmp1, g1, _dW)
        @.. H03 = H03 + b031 * tmp1
        for k in 1:m
            g2k = @view g2[k][:, k]
            @.. H03 = H03 + b032 * g2k * _dW[k]
        end
    else
        @.. H03 = H03 + b031 * g1 * _dW
        for k in 1:m
            @.. H03 = H03 + b032 * g2[k][k] * _dW[k]
        end
    end

    integrator.f(k3, H03, p, t + c03 * dt)

    # H_4^(0)
    # H04 = uprev; k4 = integrator.f(uprev,p,t+0*dt) = k1

    # H^_1^(k)
    # H21 = uprev
    # H^_2^(k) # H^_3^(k)

    if (!(W.dW isa Number) || (m != 1))
        for k in 1:m
            H22[k] = uprev
            H23[k] = uprev
        end
        for k in 1:m
            for l in 1:m
                if k == l
                    continue
                end
                ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, k, l)
                if is_diagonal_noise(integrator.sol.prob)
                    @.. H22[k] = H22[k] + b221 * g1[l] * ihat2 / integrator.sqdt
                    @.. H23[k] = H23[k] + b231 * g1[l] * ihat2 / integrator.sqdt
                else
                    g1l = @view g1[:, l]
                    @.. H22[k] = H22[k] + b221 * g1l * ihat2 / integrator.sqdt
                    @.. H23[k] = H23[k] + b231 * g1l * ihat2 / integrator.sqdt
                end
            end
        end
    end
    # H^_4^(k)
    # H24 = uprev

    # add stages together Eq. (5.1)
    @.. u = uprev + (α1 * k1 + α2 * k2 + α3 * k3 + α4 * k1) * dt

    # add noise

    if is_diagonal_noise(integrator.sol.prob)
        @.. u = u + g1 * _dW * beta11
        for k in 1:m
            u[k] = u[k] + (g2[k][k] * beta12 + g3[k][k] * beta13 + g4[k][k] * beta14) * _dW[k]
            if m != 1
                integrator.f.g(tmpg, H22[k], p, t)
                u[k] = u[k] + tmpg[k] * beta22 * integrator.sqdt
                integrator.f.g(tmpg, H23[k], p, t)
                u[k] = u[k] + tmpg[k] * beta23 * integrator.sqdt
            end
        end
    else
        # non-diag noise
        for k in 1:m
            g1k = @view g1[:, k]
            g2k = @view g2[k][:, k]
            g3k = @view g3[k][:, k]
            g4k = @view g4[k][:, k]
            tmpgk = @view tmpg[:, k]
            @.. u = u + (g1k * beta11 + g2k * beta12 + g3k * beta13 + g4k * beta14) * _dW[k]
            integrator.f.g(tmpg, H22[k], p, t)
            @.. u = u + tmpgk * beta22 * integrator.sqdt
            integrator.f.g(tmpg, H23[k], p, t)
            @.. u = u + tmpgk * beta23 * integrator.sqdt
        end
    end
end

# PL1WM
@muladd function perform_step!(integrator, cache::PL1WMConstantCache)
    (; NORMAL_ONESIX_QUANTILE) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    m = length(W.dW)
    sq3dt = sqrt(3 * dt)
    # define three-point distributed random variables
    dW_scaled = W.dW / integrator.sqdt
    _dW = map(x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), dW_scaled)
    chi1 = map(x -> (x^2 - dt) / 4, _dW)
    if !(W.dW isa Number)
        # define two-point distributed random variables
        _dZ = map(x -> calc_twopoint_random(integrator.sqdt, x), W.dZ)
    end
    # compute stage values
    k1 = integrator.f(uprev, p, t)
    g1 = integrator.f.g(uprev, p, t)

    # Y, Yp, Ym
    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        Y = uprev + k1 * dt + g1 * _dW
        if W.dW isa Number
            Yp = uprev + k1 * dt + g1 * integrator.sqdt
            Ym = uprev + k1 * dt - g1 * integrator.sqdt
        else
            Yp = Vector{typeof(uprev)}[
                uprev .+ k1 * dt .+ g1[:, k] * integrator.sqdt
                    for k in 1:m
            ]
            Ym = Vector{typeof(uprev)}[
                uprev .+ k1 * dt .- g1[:, k] * integrator.sqdt
                    for k in 1:m
            ]
        end
    else
        Y = uprev + k1 * dt + g1 .* _dW
        Yp = Vector{typeof(uprev)}(undef, m)
        Ym = Vector{typeof(uprev)}(undef, m)
        for k in 1:m
            Yp[k] = uprev .+ k1 * dt .+ g1[k] * integrator.sqdt
            Ym[k] = uprev .+ k1 * dt .- g1[k] * integrator.sqdt
        end
    end

    k2 = integrator.f(Y, p, t)

    # add stages together (Ch 15.1 Eq.(1.3))
    u = uprev + 1 // 2 * (k1 + k2) * dt

    # add noise
    if W.dW isa Number
        g2p = integrator.f.g(Yp, p, t)
        g2m = integrator.f.g(Ym, p, t)
        u += 1 // 4 * (g2p + g2m + 2 * g1) * _dW + (g2p - g2m) * chi1 / integrator.sqdt #(1.1)
    else
        if is_diagonal_noise(integrator.sol.prob)
            for k in 1:m
                tmpg1 = integrator.f.g(Yp[k], p, t)
                tmpg2 = integrator.f.g(Ym[k], p, t)
                @.. u += 1 // 4 * (tmpg1[k] + tmpg2[k] + 2 * g1[k]) * _dW[k]
                @.. u += (tmpg1[k] - tmpg2[k]) * chi1[k] / integrator.sqdt
                for l in 1:m
                    if l != k
                        ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, l, k)

                        Ulp = @.. uprev + g1[l] * integrator.sqdt
                        Ulm = @.. uprev - g1[l] * integrator.sqdt

                        tmpg1 = integrator.f.g(Ulp, p, t)
                        tmpg2 = integrator.f.g(Ulm, p, t)
                        @.. u += 1 // 4 * (tmpg1[k] + tmpg2[k] - 2 * g1[k]) * _dW[k]
                        @.. u += 1 // 4 * (tmpg1[k] - tmpg2[k]) * (
                            _dW[k] * _dW[l] +
                                ihat2
                        ) / integrator.sqdt
                    end
                end
            end
        else
            # non-diag noise
            for k in 1:m
                tmpg1 = integrator.f.g(Yp[k], p, t)
                tmpg2 = integrator.f.g(Ym[k], p, t)

                u += 1 // 4 * (tmpg1[:, k] + tmpg2[:, k] + 2 * g1[:, k]) * _dW[k]
                u += (tmpg1[:, k] - tmpg2[:, k]) * chi1[k] / integrator.sqdt
                for l in 1:m
                    if l != k
                        ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, l, k)

                        Ulp = uprev + g1[:, l] * integrator.sqdt
                        Ulm = uprev - g1[:, l] * integrator.sqdt

                        tmpg1 = integrator.f.g(Ulp, p, t)
                        tmpg2 = integrator.f.g(Ulm, p, t)
                        u += 1 // 4 * (tmpg1[:, k] + tmpg2[:, k] - 2 * g1[:, k]) * _dW[k]
                        u += 1 // 4 * (tmpg1[:, k] - tmpg2[:, k]) * (
                            _dW[k] * _dW[l] +
                                ihat2
                        ) / integrator.sqdt
                    end
                end
            end
        end
    end
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::PL1WMCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (; _dW, _dZ, chi1, tab, g1, k1, k2, Y, Yp, Ym, tmp1, tmpg1, tmpg2, Ulp, Ulm) = cache
    (; NORMAL_ONESIX_QUANTILE) = cache.tab

    m = length(W.dW)
    sq3dt = sqrt(3 * dt)
    # define three-point distributed random variables
    @.. chi1 = W.dW / integrator.sqdt
    calc_threepoint_random!(_dW, sq3dt, NORMAL_ONESIX_QUANTILE, chi1)
    map!(x -> (x^2 - dt) / 4, chi1, _dW)
    if !(W.dW isa Number) || m > 1
        # define two-point distributed random variables
        calc_twopoint_random!(_dZ, integrator.sqdt, W.dZ)
    end
    # compute stage values
    integrator.f(k1, uprev, p, t)
    integrator.f.g(g1, uprev, p, t)

    # Y, Yp, Ym
    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        mul!(tmp1, g1, _dW)
        @.. Y = uprev + k1 * dt + tmp1
        if W.dW isa Number
            @.. Yp = uprev + k1 * dt + g1 * integrator.sqdt
            @.. Ym = uprev + k1 * dt - g1 * integrator.sqdt
        else
            for k in 1:m
                g1k = @view g1[:, k]
                @.. Yp[k] = uprev + k1 * dt + g1k * integrator.sqdt
                @.. Ym[k] = uprev + k1 * dt - g1k * integrator.sqdt
            end
        end
    else
        @.. Y = uprev + k1 * dt + g1 * _dW
        for k in 1:m
            @.. Yp[k] = uprev + k1 * dt + g1[k] * integrator.sqdt
            @.. Ym[k] = uprev + k1 * dt - g1[k] * integrator.sqdt
        end
    end

    integrator.f(k2, Y, p, t)

    # add stages together (Ch 15.1 Eq.(1.3))
    @.. u = uprev + 1 // 2 * (k1 + k2) * dt

    # add noise
    if W.dW isa Number
        integrator.f.g(tmpg1, Yp, p, t)
        integrator.f.g(tmpg2, Ym, p, t)
        @.. u = u + 1 // 4 * (tmpg1 + tmpg2 + 2 * g1) * _dW + 1 // 4 * (tmpg1 - tmpg2) * chi1[k] / integrator.sqdt #(1.1)
    else
        if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
            # non-diag noise
            for k in 1:m
                integrator.f.g(tmpg1, Yp[k], p, t)
                integrator.f.g(tmpg2, Ym[k], p, t)
                tmpg1k = @view tmpg1[:, k]
                tmpg2k = @view tmpg2[:, k]
                g1k = @view g1[:, k]
                @.. u = u + 1 // 4 * (tmpg1k + tmpg2k + 2 * g1k) * _dW[k]
                @.. u = u + (tmpg1k - tmpg2k) * chi1[k] / integrator.sqdt
                for l in 1:m
                    if l != k
                        ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, l, k)

                        g1l = @view g1[:, l]
                        @.. Ulp = uprev + g1l * integrator.sqdt
                        @.. Ulm = uprev - g1l * integrator.sqdt

                        integrator.f.g(tmpg1, Ulp, p, t)
                        integrator.f.g(tmpg2, Ulm, p, t)
                        tmpg1k = @view tmpg1[:, k]
                        tmpg2k = @view tmpg2[:, k]
                        u += 1 // 4 * (tmpg1k + tmpg2k - 2 * g1k) * _dW[k]
                        u += 1 // 4 * (tmpg1k - tmpg2k) * (_dW[k] * _dW[l] + ihat2) / integrator.sqdt
                    end
                end
            end
        else
            for k in 1:m
                integrator.f.g(tmpg1, Yp[k], p, t)
                integrator.f.g(tmpg2, Ym[k], p, t)
                @.. u = u + 1 // 4 * (tmpg1[k] + tmpg2[k] + 2 * g1[k]) * _dW[k]
                @.. u = u + (tmpg1[k] - tmpg2[k]) * chi1[k] / integrator.sqdt
                for l in 1:m
                    if l != k
                        ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, l, k)

                        @.. Ulp = uprev + g1[l] * integrator.sqdt
                        @.. Ulm = uprev - g1[l] * integrator.sqdt

                        integrator.f.g(tmpg1, Ulp, p, t)
                        integrator.f.g(tmpg2, Ulm, p, t)
                        @.. u = u + 1 // 4 * (tmpg1[k] + tmpg2[k] - 2 * g1[k]) * _dW[k]
                        @.. u = u +
                            1 // 4 * (tmpg1[k] - tmpg2[k]) * (
                            _dW[k] * _dW[l] +
                                ihat2
                        ) / integrator.sqdt
                    end
                end
            end
        end
    end
end

# PL1WMA
@muladd function perform_step!(integrator, cache::PL1WMAConstantCache)
    (; NORMAL_ONESIX_QUANTILE) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    sq3dt = sqrt(3 * dt)
    # define three-point distributed random variables
    dW_scaled = W.dW / integrator.sqdt
    _dW = map(x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), dW_scaled)

    # compute stage values
    k1 = integrator.f(uprev, p, t)
    g1 = integrator.f.g(uprev, p, t)

    # Y
    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        tmp1 = g1 * _dW
    else
        tmp1 = g1 .* _dW
    end
    Y = uprev + k1 * dt + tmp1

    k2 = integrator.f(Y, p, t)

    # add stages together (Ch 15.1 Eq.(1.4))
    u = uprev + 1 // 2 * (k1 + k2) * dt + tmp1

    integrator.u = u
end

@muladd function perform_step!(integrator, cache::PL1WMACache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (; _dW, chi1, tab, g1, k1, k2, Y, tmp1) = cache
    (; NORMAL_ONESIX_QUANTILE) = cache.tab

    sq3dt = sqrt(3 * dt)
    # define three-point distributed random variables
    @.. chi1 = W.dW / integrator.sqdt
    calc_threepoint_random!(_dW, sq3dt, NORMAL_ONESIX_QUANTILE, chi1)

    # compute stage values
    integrator.f(k1, uprev, p, t)
    integrator.f.g(g1, uprev, p, t)

    # Y, Yp, Ym
    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        mul!(tmp1, g1, _dW)
        @.. Y = uprev + k1 * dt + tmp1

    else
        @.. tmp1 = g1 * _dW
        @.. Y = uprev + k1 * dt + tmp1
    end

    integrator.f(k2, Y, p, t)

    # add stages together (Ch 15.1 Eq.(1.4))
    @.. u = uprev + 1 // 2 * (k1 + k2) * dt + tmp1
end

# NON
@muladd function perform_step!(integrator, cache::NONConstantCache)
    (;
        c01,
        c02, c03, c04, cj1, cj2, cj3, cj4, cjl2, cjl3, clj2, clj3, a0021, a0032, a0043,
        aj021, aj041, a0j21, a0j31, a0j32, a0j41, ajj21, ajj31, ajj32, ajj41, ajj42, ajj43,
        ajl31, ajl32, ajl41, ajl42, ajljj31, aljjl21, aljjl31, NORMAL_ONESIX_QUANTILE,
    ) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    m = length(W.dW)
    # define three-point distributed random variables
    sq3dt = sqrt(3 * dt)
    dW_scaled = W.dW / integrator.sqdt
    _dW = map(x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), dW_scaled)

    if !(W.dW isa Number)
        # define two-point distributed random variables
        _dZ = map(x -> calc_twopoint_random(integrator.sqdt, x), W.dZ)
    end

    # compute stage values
    # stage 1
    ktmp = integrator.f(uprev, p, t)
    gtmp = integrator.f.g(uprev, p, t)

    Y100 = ktmp * dt
    Y1jajb = [zero(u) for ja in 1:m, jb in 1:m]
    Y2jajb = [zero(u) for ja in 1:m, jb in 1:m]
    Y3jajb = [zero(u) for ja in 1:m, jb in 1:m]
    Y4jajb = [zero(u) for ja in 1:m, jb in 1:m]
    if W.dW isa Number
        Y1jajb = gtmp * _dW
    else
        for ja in 1:m
            for jb in 1:m
                ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, jb)
                if is_diagonal_noise(integrator.sol.prob)
                    tmpu = zero(integrator.u)
                    tmpu[jb] = gtmp[jb]
                    @.. Y1jajb[ja, jb] = Ihat2 * tmpu
                    if ja != jb
                        @.. Y4jajb[ja, jb] = Ihat2 * tmpu
                    end
                else
                    gtmpjb = @view gtmp[:, jb]
                    @.. Y1jajb[ja, jb] = Ihat2 * gtmpjb
                    if ja != jb
                        @.. Y4jajb[ja, jb] = Ihat2 * gtmpjb
                    end
                end
            end
        end
    end

    # stage 2
    Y200 = uprev + a0021 * Y100

    if W.dW isa Number
        Y200 += a0j21 * Y1jajb
        Y2jajb = integrator.f.g(uprev + aj021 * Y100 + ajj21 * Y1jajb[1], p, t) * _dW
    else
        if !is_diagonal_noise(integrator.sol.prob)
            for ja in 1:m
                Y200 += a0j21 * Y1jajb[ja, ja]
                for jb in 1:m
                    if jb != ja
                        if jb < ja
                            tmpu = uprev + aljjl21 * Y1jajb[jb, ja]
                        else
                            tmpu = copy(uprev)
                        end
                    else
                        tmpu = uprev + aj021 * Y100 + ajj21 * Y1jajb[ja, ja]
                    end
                    gtmp = integrator.f.g(tmpu, p, t)
                    tmpjb = @view gtmp[:, jb]
                    ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, jb)
                    @.. Y2jajb[ja, jb] = Ihat2 * tmpjb
                end
            end
        else
            for ja in 1:m
                Y200 += a0j21 * Y1jajb[ja, ja]
                for jb in 1:m
                    if jb != ja
                        if jb < ja
                            tmpu = uprev + aljjl21 * Y1jajb[jb, ja]
                        else
                            tmpu = copy(uprev)
                        end
                    else
                        tmpu = uprev + aj021 * Y100 + ajj21 * Y1jajb[ja, ja]
                    end
                    gtmp = integrator.f.g(tmpu, p, t)
                    tmpu = zero(integrator.u)
                    tmpu[jb] = gtmp[jb]
                    ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, jb)
                    @.. Y2jajb[ja, jb] = Ihat2 * tmpu
                end
            end
        end
    end
    ktmp = integrator.f(Y200, p, t)
    Y200 = ktmp * dt

    # stage 3
    Y300 = uprev + a0032 * Y200
    if W.dW isa Number
        Y300 += a0j31 * Y1jajb + a0j32 * Y2jajb
        Y3jajb = integrator.f.g(uprev + ajj31 * Y1jajb[1] + ajj32 * Y2jajb[1], p, t) * _dW
    else
        if !is_diagonal_noise(integrator.sol.prob)
            for ja in 1:m
                Y300 += a0j31 * Y1jajb[ja, ja] + a0j32 * Y2jajb[ja, ja]
                for jb in 1:m
                    if jb != ja
                        if jb < ja
                            tmpu = uprev + aljjl31 * Y1jajb[jb, ja]
                        else
                            tmpu = uprev + ajljj31 * Y1jajb[ja, ja]
                        end
                    else
                        tmpu = uprev + ajj31 * Y1jajb[ja, ja] + ajj32 * Y2jajb[ja, ja]
                        for l in 1:m
                            if l != ja
                                tmpu += ajl31 * Y1jajb[l, l] + ajl32 * Y2jajb[l, l]
                            end
                        end
                    end
                    gtmp = integrator.f.g(tmpu, p, t)
                    tmpjb = @view gtmp[:, jb]
                    ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, jb)
                    @.. Y3jajb[ja, jb] = ihat2 * tmpjb
                end
            end
        else
            for ja in 1:m
                Y300 += a0j31 * Y1jajb[ja, ja] + a0j32 * Y2jajb[ja, ja]
                for jb in 1:m
                    if jb != ja
                        if jb < ja
                            tmpu = uprev + aljjl31 * Y1jajb[jb, ja]
                        else
                            tmpu = uprev + ajljj31 * Y1jajb[ja, ja]
                        end
                    else
                        tmpu = uprev + ajj31 * Y1jajb[ja, ja] + ajj32 * Y2jajb[ja, ja]
                        for l in 1:m
                            if l != ja
                                tmpu += ajl31 * Y1jajb[l, l] + ajl32 * Y2jajb[l, l]
                            end
                        end
                    end
                    gtmp = integrator.f.g(tmpu, p, t)
                    tmpu = zero(integrator.u)
                    tmpu[jb] = gtmp[jb]
                    ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, jb)
                    @.. Y3jajb[ja, jb] = ihat2 * tmpu
                end
            end
        end
    end
    ktmp = integrator.f(Y300, p, t)
    Y300 = ktmp * dt

    # stage 4
    Y400 = uprev + a0043 * Y300
    if W.dW isa Number
        Y400 += a0j41 * Y1jajb
        Y4jajb = integrator.f.g(
            uprev + ajj41 * Y1jajb[1] + ajj42 * Y2jajb[1] + ajj43 * Y3jajb[1] + aj041 * Y100, p, t
        ) * _dW
    else
        if !is_diagonal_noise(integrator.sol.prob)
            for ja in 1:m
                Y400 += a0j41 * Y1jajb[ja, ja]
                tmpu = uprev + ajj41 * Y1jajb[ja, ja] + ajj42 * Y2jajb[ja, ja] +
                    ajj43 * Y3jajb[ja, ja] + aj041 * Y100
                for l in 1:m
                    if l != ja
                        tmpu += ajl41 * Y1jajb[l, l] + ajl42 * Y2jajb[l, l]
                    end
                end
                gtmp = integrator.f.g(tmpu, p, t)
                tmpjb = @view gtmp[:, ja]
                ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, ja)
                @.. Y4jajb[ja, ja] = ihat2 * tmpjb
            end
        else
            for ja in 1:m
                Y400 += a0j41 * Y1jajb[ja, ja]

                tmpu = uprev + ajj41 * Y1jajb[ja, ja] + ajj42 * Y2jajb[ja, ja] +
                    ajj43 * Y3jajb[ja, ja] + aj041 * Y100
                for l in 1:m
                    if l != ja
                        tmpu += ajl41 * Y1jajb[l, l] + ajl42 * Y2jajb[l, l]
                    end
                end
                gtmp = integrator.f.g(tmpu, p, t)
                tmpu = zero(integrator.u)
                tmpu[ja] = gtmp[ja]
                ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, ja)
                @.. Y4jajb[ja, ja] = ihat2 * tmpu
            end
        end
    end

    ktmp = integrator.f(Y400, p, t)
    Y400 = ktmp * dt

    # add stages together
    u = uprev + c01 * Y100 + c02 * Y200 + c03 * Y300 + c04 * Y400
    if W.dW isa Number
        # to be checked
        u += cj1 * Y1jajb + cj2 * Y2jajb + cj3 * Y3jajb + cj4 * Y4jajb
    else
        if is_diagonal_noise(integrator.sol.prob)
            for ja in 1:m
                u += cj1 * Y1jajb[ja, ja] + cj2 * Y2jajb[ja, ja] + cj3 * Y3jajb[ja, ja] +
                    cj4 * Y4jajb[ja, ja]
                for jb in 1:m
                    if jb != ja
                        if ja > jb
                            u += clj2 * Y2jajb[ja, jb] + clj3 * Y3jajb[ja, jb]
                        else
                            u += cjl2 * Y2jajb[ja, jb] + cjl3 * Y3jajb[ja, jb]
                        end
                    end
                end
            end
        else
            for ja in 1:m
                u += cj1 * Y1jajb[ja, ja] + cj2 * Y2jajb[ja, ja] + cj3 * Y3jajb[ja, ja] +
                    cj4 * Y4jajb[ja, ja]
                for jb in 1:m
                    if jb != ja
                        if ja > jb
                            u += clj2 * Y2jajb[ja, jb] + clj3 * Y3jajb[ja, jb]
                        else
                            u += cjl2 * Y2jajb[ja, jb] + cjl3 * Y3jajb[ja, jb]
                        end
                    end
                end
            end
        end
    end
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::NONCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (;
        _dW, _dZ, chi1, tab, gtmp, ktmp, Y100, Y200, Y300,
        Y400, Y1jajb, Y2jajb, Y3jajb, Y4jajb, tmpu,
    ) = cache
    (;
        c01,
        c02, c03, c04, cj1, cj2, cj3, cj4, cjl2, cjl3, clj2, clj3, a0021, a0032, a0043, aj021,
        aj041, a0j21, a0j31, a0j32, a0j41, ajj21, ajj31, ajj32, ajj41, ajj42, ajj43, ajl31,
        ajl32, ajl41, ajl42, ajljj31, aljjl21, aljjl31, NORMAL_ONESIX_QUANTILE,
    ) = cache.tab

    m = length(W.dW)
    # define three-point distributed random variables
    @.. chi1 = W.dW / integrator.sqdt
    sq3dt = sqrt(3 * dt)
    calc_threepoint_random!(_dW, sq3dt, NORMAL_ONESIX_QUANTILE, chi1)

    if !(W.dW isa Number)
        # define two-point distributed random variables
        calc_twopoint_random!(_dZ, integrator.sqdt, W.dZ)
    end

    # compute stage values
    # stage 1
    integrator.f(ktmp, uprev, p, t)
    integrator.f.g(gtmp, uprev, p, t)

    @.. Y100 = ktmp * dt
    for ja in 1:m
        for jb in 1:m
            ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, jb)
            if is_diagonal_noise(integrator.sol.prob)
                fill!(tmpu, zero(eltype(integrator.u)))
                tmpu[jb] = gtmp[jb]
                @.. Y1jajb[ja, jb] = ihat2 * tmpu
                if ja != jb
                    @.. Y4jajb[ja, jb] = ihat2 * tmpu
                end
            else
                gtmpjb = @view gtmp[:, jb]
                @.. Y1jajb[ja, jb] = ihat2 * gtmpjb
                if ja != jb
                    @.. Y4jajb[ja, jb] = ihat2 * gtmpjb
                end
            end
        end
    end

    # stage 2
    @.. Y200 = uprev + a0021 * Y100

    if !is_diagonal_noise(integrator.sol.prob)
        for ja in 1:m
            @.. Y200 = Y200 + a0j21 * Y1jajb[ja, ja]
            for jb in 1:m
                if jb != ja
                    if jb < ja
                        @.. tmpu = uprev + aljjl21 * Y1jajb[jb, ja]
                    else
                        @.. tmpu = uprev
                    end
                else
                    @.. tmpu = uprev + aj021 * Y100 + ajj21 * Y1jajb[ja, ja]
                end
                integrator.f.g(gtmp, tmpu, p, t)
                tmpjb = @view gtmp[:, jb]
                ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, jb)
                @.. Y2jajb[ja, jb] = ihat2 * tmpjb
            end
        end
    else
        for ja in 1:m
            @.. Y200 = Y200 + a0j21 * Y1jajb[ja, ja]
            for jb in 1:m
                if jb != ja
                    if jb < ja
                        @.. tmpu = uprev + aljjl21 * Y1jajb[jb, ja]
                    else
                        @.. tmpu = uprev
                    end
                else
                    @.. tmpu = uprev + aj021 * Y100 + ajj21 * Y1jajb[ja, ja]
                end
                integrator.f.g(gtmp, tmpu, p, t)
                fill!(tmpu, zero(eltype(integrator.u)))
                tmpu[jb] = gtmp[jb]
                ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, jb)
                @.. Y2jajb[ja, jb] = ihat2 * tmpu
            end
        end
    end
    integrator.f(ktmp, Y200, p, t)
    @.. Y200 = ktmp * dt

    # stage 3
    @.. Y300 = uprev + a0032 * Y200

    if !is_diagonal_noise(integrator.sol.prob)
        for ja in 1:m
            @.. Y300 = Y300 + a0j31 * Y1jajb[ja, ja] + a0j32 * Y2jajb[ja, ja]
            for jb in 1:m
                if jb != ja
                    if jb < ja
                        @.. tmpu = uprev + aljjl31 * Y1jajb[jb, ja]
                    else
                        @.. tmpu = uprev + ajljj31 * Y1jajb[ja, ja]
                    end
                else
                    @.. tmpu = uprev + ajj31 * Y1jajb[ja, ja] + ajj32 * Y2jajb[ja, ja]
                    for l in 1:m
                        if l != ja
                            @.. tmpu = tmpu + ajl31 * Y1jajb[l, l] + ajl32 * Y2jajb[l, l]
                        end
                    end
                end
                integrator.f.g(gtmp, tmpu, p, t)
                tmpjb = @view gtmp[:, jb]
                ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, jb)
                @.. Y3jajb[ja, jb] = ihat2 * tmpjb
            end
        end
    else
        for ja in 1:m
            @.. Y300 = Y300 + a0j31 * Y1jajb[ja, ja] + a0j32 * Y2jajb[ja, ja]
            for jb in 1:m
                if jb != ja
                    if jb < ja
                        @.. tmpu = uprev + aljjl31 * Y1jajb[jb, ja]
                    else
                        @.. tmpu = uprev + ajljj31 * Y1jajb[ja, ja]
                    end
                else
                    @.. tmpu = uprev + ajj31 * Y1jajb[ja, ja] + ajj32 * Y2jajb[ja, ja]
                    for l in 1:m
                        if l != ja
                            @.. tmpu = tmpu + ajl31 * Y1jajb[l, l] + ajl32 * Y2jajb[l, l]
                        end
                    end
                end
                integrator.f.g(gtmp, tmpu, p, t)
                fill!(tmpu, zero(eltype(integrator.u)))
                tmpu[jb] = gtmp[jb]
                ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, jb)
                @.. Y3jajb[ja, jb] = ihat2 * tmpu
            end
        end
    end

    integrator.f(ktmp, Y300, p, t)
    @.. Y300 = ktmp * dt

    # stage 4
    @.. Y400 = uprev + a0043 * Y300

    if !is_diagonal_noise(integrator.sol.prob)
        for ja in 1:m
            @.. Y400 = Y400 + a0j41 * Y1jajb[ja, ja]

            @.. tmpu = uprev + ajj41 * Y1jajb[ja, ja] + ajj42 * Y2jajb[ja, ja] +
                ajj43 * Y3jajb[ja, ja] + aj041 * Y100
            for l in 1:m
                if l != ja
                    @.. tmpu = tmpu + ajl41 * Y1jajb[l, l] + ajl42 * Y2jajb[l, l]
                end
            end
            integrator.f.g(gtmp, tmpu, p, t)
            tmpjb = @view gtmp[:, ja]
            ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, ja)
            @.. Y4jajb[ja, ja] = ihat2 * tmpjb
        end
    else
        for ja in 1:m
            @.. Y400 = Y400 + a0j41 * Y1jajb[ja, ja]

            @.. tmpu = uprev + ajj41 * Y1jajb[ja, ja] + ajj42 * Y2jajb[ja, ja] +
                ajj43 * Y3jajb[ja, ja] + aj041 * Y100
            for l in 1:m
                if l != ja
                    @.. tmpu = tmpu + ajl41 * Y1jajb[l, l] + ajl42 * Y2jajb[l, l]
                end
            end
            integrator.f.g(gtmp, tmpu, p, t)
            fill!(tmpu, zero(eltype(integrator.u)))
            tmpu[ja] = gtmp[ja]
            ihat2 = Ihat2(cache, _dW, _dZ, integrator.sqdt, ja, ja)
            @.. Y4jajb[ja, ja] = ihat2 * tmpu
        end
    end

    integrator.f(ktmp, Y400, p, t)
    @.. Y400 = ktmp * dt

    # add stages together
    @.. u = uprev + c01 * Y100 + c02 * Y200 + c03 * Y300 + c04 * Y400
    if W.dW isa Number
        @.. u = u + cj1 * Y1jj + cj2 * Y2jj + cj3 * Y3jj + cj4 * Y4jj
    else
        if is_diagonal_noise(integrator.sol.prob)
            for ja in 1:m
                @.. u = u + cj1 * Y1jajb[ja, ja] + cj2 * Y2jajb[ja, ja] + cj3 * Y3jajb[ja, ja] +
                    cj4 * Y4jajb[ja, ja]
                for jb in 1:m
                    if jb != ja
                        if ja > jb
                            @.. u = u + clj2 * Y2jajb[ja, jb] + clj3 * Y3jajb[ja, jb]
                        else
                            @.. u = u + cjl2 * Y2jajb[ja, jb] + cjl3 * Y3jajb[ja, jb]
                        end
                    end
                end
            end
        else
            for ja in 1:m
                @.. u = u + cj1 * Y1jajb[ja, ja] + cj2 * Y2jajb[ja, ja] + cj3 * Y3jajb[ja, ja] +
                    cj4 * Y4jajb[ja, ja]
                for jb in 1:m
                    if jb != ja
                        if ja > jb
                            @.. u = u + clj2 * Y2jajb[ja, jb] + clj3 * Y3jajb[ja, jb]
                        else
                            @.. u = u + cjl2 * Y2jajb[ja, jb] + cjl3 * Y3jajb[ja, jb]
                        end
                    end
                end
            end
        end
    end
end

# COM
@muladd function perform_step!(integrator, cache::COMConstantCache)
    (;
        c01, c02, c03, c04, cj1, cj2, cj3, cj4, a0021, a0032, a0043, aj021,
        aj041, a0j21, a0j31, a0j32, a0j41, ajj21, ajj31, ajj32, ajj41, ajj42,
        ajj43, ajl31, ajl32, ajl41, ajl42, NORMAL_ONESIX_QUANTILE,
    ) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    m = length(W.dW)
    _dW = W.dW

    # define three-point distributed random variables
    #sq3dt = sqrt(3*dt)
    #dW_scaled = W.dW / integrator.sqdt
    #_dW = map(x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), dW_scaled)

    # compute stage values
    # stage 1
    ktmp = integrator.f(uprev, p, t)
    gtmp = integrator.f.g(uprev, p, t)

    Y10 = ktmp * dt

    if W.dW isa Number
        Y1j = gtmp * _dW
    else
        if is_diagonal_noise(integrator.sol.prob)
            Y1j = gtmp .* _dW
        else
            Y1j = gtmp .* _dW'
        end
    end

    # stage 2
    Y20 = uprev + a0021 * Y10

    if W.dW isa Number
        Y20 += a0j21 * Y1j
        Y2j = integrator.f.g(uprev + aj021 * Y10 + ajj21 * Y1j, p, t) * _dW
    else
        if !is_diagonal_noise(integrator.sol.prob)
            Y2j = similar(integrator.sol.prob.noise_rate_prototype)
            for j in 1:m
                Y20 += a0j21 * Y1j[:, j]
                tmpu = uprev + aj021 * Y10 + ajj21 * Y1j[:, j]
                Y2j[:, j] = integrator.f.g(tmpu, p, t)[:, j] * _dW[j]
            end
        else
            Y20 += a0j21 * Y1j
            Y2j = similar(uprev)
            for j in 1:m
                tmpu = uprev + aj021 * Y10
                tmpu[j] += ajj21 * Y1j[j]
                Y2j[j] = integrator.f.g(tmpu, p, t)[j] * _dW[j]
            end
        end
    end
    ktmp = integrator.f(Y20, p, t)
    Y20 = ktmp * dt

    # stage 3
    Y30 = uprev + a0032 * Y20
    if W.dW isa Number
        Y30 += a0j31 * Y1j + a0j32 * Y2j
        Y3j = integrator.f.g(uprev + ajj31 * Y1j + ajj32 * Y2j, p, t) * _dW
    else
        if !is_diagonal_noise(integrator.sol.prob)
            Y3j = similar(integrator.sol.prob.noise_rate_prototype)
            for j in 1:m
                tmpu = uprev + ajj31 * Y1j[:, j] + ajj32 * Y2j[:, j]
                Y30 += a0j31 * Y1j[:, j] + a0j32 * Y2j[:, j]
                for l in 1:m
                    if l != j
                        tmpu += (ajl31 * Y1j[:, l] + ajl32 * Y2j[:, l])
                    end
                end
                Y3j[:, j] = integrator.f.g(tmpu, p, t)[:, j] * _dW[j]
            end
        else
            Y30 += a0j31 * Y1j + a0j32 * Y2j
            Y3j = similar(uprev)
            tmpu2 = uprev + ajl31 * Y1j + ajl32 * Y2j
            for j in 1:m
                tmpu = copy(tmpu2)
                tmpu[j] += ajj31 * Y1j[j] + ajj32 * Y2j[j] - (ajl31 * Y1j[j] + ajl32 * Y2j[j])
                Y3j[j] = integrator.f.g(tmpu, p, t)[j] * _dW[j]
            end
        end
    end
    ktmp = integrator.f(Y30, p, t)
    Y30 = ktmp * dt

    # stage 4
    Y40 = uprev + a0043 * Y30
    if W.dW isa Number
        Y40 += a0j41 * Y1j
        Y4j = integrator.f.g(uprev + ajj41 * Y1j + ajj42 * Y2j + ajj43 * Y3j + aj041 * Y10, p, t) * _dW
    else
        if !is_diagonal_noise(integrator.sol.prob)
            Y4j = similar(integrator.sol.prob.noise_rate_prototype)
            for j in 1:m
                tmpu = uprev + ajj41 * Y1j[:, j] + ajj42 * Y2j[:, j] + ajj43 * Y3j[:, j] +
                    aj041 * Y10
                Y40 += a0j41 * Y1j[:, j]
                for l in 1:m
                    if l != j
                        tmpu += (ajl41 * Y1j[:, l] + ajl42 * Y2j[:, l])
                    end
                end
                Y4j[:, j] = integrator.f.g(tmpu, p, t)[:, j] * _dW[j]
            end
        else
            Y40 += a0j41 * Y1j
            Y4j = similar(uprev)
            tmpu2 = uprev + ajl41 * Y1j + ajl42 * Y2j + aj041 * Y10
            for j in 1:m
                tmpu = copy(tmpu2)
                tmpu[j] += ajj41 * Y1j[j] + ajj42 * Y2j[j] + ajj43 * Y3j[j] -
                    (ajl41 * Y1j[j] + ajl42 * Y2j[j])
                Y4j[j] = integrator.f.g(tmpu, p, t)[j] * _dW[j]
            end
        end
    end
    ktmp = integrator.f(Y40, p, t)
    Y40 = ktmp * dt

    # add stages together
    u = uprev + c01 * Y10 + c02 * Y20 + c03 * Y30 + c04 * Y40

    if W.dW isa Number
        u += cj1 * Y1j + cj2 * Y2j + cj3 * Y3j + cj4 * Y4j
    else
        if is_diagonal_noise(integrator.sol.prob)
            u += @. cj1 * Y1j + cj2 * Y2j + cj3 * Y3j + cj4 * Y4j
        else
            for j in 1:m
                u += @. cj1 * Y1j[:, j] + cj2 * Y2j[:, j] + cj3 * Y3j[:, j] + cj4 * Y4j[:, j]
            end
        end
    end
    integrator.u = u
end

# COM
@muladd function perform_step!(integrator, cache::COMCache)
    (;
        _dW, tab, gtmp, ktmp, Y10, Y20, Y30, Y40, Y1j, Y2j, Y3j, Y4j, tmpu,
        tmpu2,
    ) = cache
    (;
        c01, c02, c03, c04, cj1, cj2, cj3, cj4, a0021, a0032, a0043, aj021,
        aj041, a0j21, a0j31, a0j32, a0j41, ajj21, ajj31, ajj32, ajj41, ajj42,
        ajj43, ajl31, ajl32, ajl41, ajl42, NORMAL_ONESIX_QUANTILE,
    ) = cache.tab
    (; t, dt, uprev, u, W, p, f) = integrator

    m = length(W.dW)
    @.. _dW = W.dW

    # define three-point distributed random variables
    #sq3dt = sqrt(3*dt)
    #dW_scaled = W.dW / integrator.sqdt
    #_dW = map(x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), dW_scaled)

    # compute stage values
    # stage 1
    integrator.f(ktmp, uprev, p, t)
    integrator.f.g(gtmp, uprev, p, t)

    @.. Y10 = ktmp * dt

    if is_diagonal_noise(integrator.sol.prob)
        @.. Y1j = gtmp * _dW
    else
        for j in 1:m
            Y1jj = @view Y1j[:, j]
            gtmpj = @view gtmp[:, j]
            @.. Y1jj = gtmpj * _dW[j]
        end
    end

    # stage 2
    @.. Y20 = uprev + a0021 * Y10

    if !is_diagonal_noise(integrator.sol.prob)
        fill!(Y2j, zero(eltype(integrator.sol.prob.noise_rate_prototype)))
        for j in 1:m
            Y1jj = @view Y1j[:, j]
            Y2jj = @view Y2j[:, j]
            @.. Y20 = Y20 + a0j21 * Y1jj
            @.. tmpu = uprev + aj021 * Y10 + ajj21 * Y1jj
            integrator.f.g(gtmp, tmpu, p, t)
            gtmpj = @view gtmp[:, j]
            @.. Y2jj = gtmpj * _dW[j]
        end
    else
        fill!(Y2j, zero(eltype(integrator.u)))
        @.. Y20 = Y20 + a0j21 * Y1j
        @.. tmpu = uprev + aj021 * Y10
        for j in 1:m
            fill!(tmpu2, zero(eltype(integrator.u)))
            tmpu2[j] = ajj21 * Y1j[j]
            @.. tmpu2 = tmpu + tmpu2
            integrator.f.g(gtmp, tmpu2, p, t)
            Y2j[j] = gtmp[j] * _dW[j]
        end
    end
    integrator.f(ktmp, Y20, p, t)
    @.. Y20 = ktmp * dt

    # stage 3
    @.. Y30 = uprev + a0032 * Y20

    if !is_diagonal_noise(integrator.sol.prob)
        fill!(Y3j, zero(eltype(integrator.sol.prob.noise_rate_prototype)))
        for j in 1:m
            Y1jj = @view Y1j[:, j]
            Y2jj = @view Y2j[:, j]
            Y3jj = @view Y3j[:, j]
            @.. tmpu = uprev + ajj31 * Y1jj + ajj32 * Y2jj
            @.. Y30 = Y30 + a0j31 * Y1jj + a0j32 * Y2jj
            for l in 1:m
                if l != j
                    Y1jl = @view Y1j[:, l]
                    Y2jl = @view Y2j[:, l]
                    @.. tmpu = tmpu + (ajl31 * Y1jl + ajl32 * Y2jl)
                end
            end
            integrator.f.g(gtmp, tmpu, p, t)
            gtmpj = @view gtmp[:, j]
            @.. Y3jj = gtmpj * _dW[j]
        end
    else
        @.. Y30 = Y30 + a0j31 * Y1j + a0j32 * Y2j
        fill!(Y3j, zero(eltype(integrator.u)))
        @.. tmpu2 = uprev + ajl31 * Y1j + ajl32 * Y2j
        for j in 1:m
            @.. tmpu = tmpu2
            tmpu[j] += ajj31 * Y1j[j] + ajj32 * Y2j[j] - (ajl31 * Y1j[j] + ajl32 * Y2j[j])
            integrator.f.g(gtmp, tmpu, p, t)
            Y3j[j] = gtmp[j] * _dW[j]
        end
    end
    integrator.f(ktmp, Y30, p, t)
    @.. Y30 = ktmp * dt

    # stage 4
    @.. Y40 = uprev + a0043 * Y30

    if !is_diagonal_noise(integrator.sol.prob)
        fill!(Y4j, zero(eltype(integrator.sol.prob.noise_rate_prototype)))
        for j in 1:m
            Y1jj = @view Y1j[:, j]
            Y2jj = @view Y2j[:, j]
            Y3jj = @view Y3j[:, j]
            Y4jj = @view Y4j[:, j]
            @.. tmpu = uprev + ajj41 * Y1jj + ajj42 * Y2jj + ajj43 * Y3jj + aj041 * Y10
            @.. Y40 = Y40 + a0j41 * Y1jj
            for l in 1:m
                if l != j
                    Y1jl = @view Y1j[:, l]
                    Y2jl = @view Y2j[:, l]
                    @.. tmpu = tmpu + (ajl41 * Y1jl + ajl42 * Y2jl)
                end
            end
            integrator.f.g(gtmp, tmpu, p, t)
            gtmpj = @view gtmp[:, j]
            @.. Y4jj = gtmpj * _dW[j]
        end
    else
        @.. Y40 = Y40 + a0j41 * Y1j
        fill!(Y4j, zero(eltype(integrator.u)))
        @.. tmpu2 = uprev + ajl41 * Y1j + ajl42 * Y2j + aj041 * Y10
        for j in 1:m
            @.. tmpu = tmpu2
            tmpu[j] += ajj41 * Y1j[j] + ajj42 * Y2j[j] + ajj43 * Y3j[j] -
                (ajl41 * Y1j[j] + ajl42 * Y2j[j])
            integrator.f.g(gtmp, tmpu, p, t)
            Y4j[j] = gtmp[j] * _dW[j]
        end
    end
    integrator.f(ktmp, Y40, p, t)
    @.. Y40 = ktmp * dt

    # add stages together
    @.. u = uprev + c01 * Y10 + c02 * Y20 + c03 * Y30 + c04 * Y40

    if is_diagonal_noise(integrator.sol.prob)
        @. u = u + cj1 * Y1j + cj2 * Y2j + cj3 * Y3j + cj4 * Y4j
    else
        for j in 1:m
            Y1jj = @view Y1j[:, j]
            Y2jj = @view Y2j[:, j]
            Y3jj = @view Y3j[:, j]
            Y4jj = @view Y4j[:, j]
            @.. u = u + cj1 * Y1jj + cj2 * Y2jj + cj3 * Y3jj + cj4 * Y4jj
        end
    end
end

# NON2
@muladd function perform_step!(integrator, cache::NON2ConstantCache)
    (;
        c01, c02, c03, c04, cj1, cj2, cj3, cj4, a0021, a0032, a0043, aj021,
        aj041, a0j21, a0j31, a0j32, a0j41, ajj21, ajj31, ajj32, ajj41, ajj42,
        ajj43, ajl31, ajl32, ajl41, ajl42, γ, NORMAL_ONESIX_QUANTILE,
    ) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    m = length(W.dW)
    #_dW = W.dW

    # define three-point distributed random variables
    sq3dt = sqrt(3 * dt)
    chi1 = W.dW / integrator.sqdt
    _dW = map(x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), chi1)

    if !(W.dW isa Number)
        # define two-point distributed random variables
        _dZ = map(x -> calc_twopoint_random(integrator.sqdt, x), W.dZ)
        ihat2 = zeros(eltype(W.dZ), m, m) # I^_(k,l)
        for j in 1:m
            for l in 1:(j - 1)
                Ihat2[j, l] = -_dZ[j] * _dW[l] / integrator.sqdt
                Ihat2[l, j] = _dW[l] * _dZ[j] / integrator.sqdt
            end
        end
    end
    # compute stage values
    # stage 1
    ktmp = integrator.f(uprev, p, t)
    gtmp = integrator.f.g(uprev, p, t)

    # store gtmp for stage values Y^(k(j)j)
    gtmp1 = copy(gtmp)

    Y10 = ktmp * dt

    if W.dW isa Number
        Y1j = gtmp * _dW
    else
        if is_diagonal_noise(integrator.sol.prob)
            Y1j = gtmp .* _dW
        else
            Y1j = gtmp .* _dW'
        end
    end

    # stage 2
    Y20 = uprev + a0021 * Y10

    if W.dW isa Number
        Y20 += a0j21 * Y1j
        Y2j = integrator.f.g(uprev + aj021 * Y10 + ajj21 * Y1j, p, t) * _dW
    else
        if !is_diagonal_noise(integrator.sol.prob)
            Y2j = similar(integrator.sol.prob.noise_rate_prototype)
            for j in 1:m
                Y20 += a0j21 * Y1j[:, j]
                tmpu = uprev + aj021 * Y10 + ajj21 * Y1j[:, j]
                Y2j[:, j] = integrator.f.g(tmpu, p, t)[:, j] * _dW[j]
            end
        else
            Y20 += a0j21 * Y1j
            Y2j = similar(uprev)
            for j in 1:m
                tmpu = uprev + aj021 * Y10
                tmpu[j] += ajj21 * Y1j[j]
                Y2j[j] = integrator.f.g(tmpu, p, t)[j] * _dW[j]
            end
        end
    end
    ktmp = integrator.f(Y20, p, t)
    Y20 = ktmp * dt

    # stage 3
    Y30 = uprev + a0032 * Y20
    if W.dW isa Number
        Y30 += a0j31 * Y1j + a0j32 * Y2j
        Y3j = integrator.f.g(uprev + ajj31 * Y1j + ajj32 * Y2j, p, t) * _dW
    else
        if !is_diagonal_noise(integrator.sol.prob)
            Y3j = similar(integrator.sol.prob.noise_rate_prototype)
            for j in 1:m
                tmpu = uprev + ajj31 * Y1j[:, j] + ajj32 * Y2j[:, j]
                Y30 += a0j31 * Y1j[:, j] + a0j32 * Y2j[:, j]
                for l in 1:m
                    if l != j
                        tmpu += (ajl31 * Y1j[:, l] + ajl32 * Y2j[:, l])
                    end
                end
                Y3j[:, j] = integrator.f.g(tmpu, p, t)[:, j] * _dW[j]
            end
        else
            Y30 += a0j31 * Y1j + a0j32 * Y2j
            Y3j = similar(uprev)
            tmpu2 = uprev + ajl31 * Y1j + ajl32 * Y2j
            for j in 1:m
                tmpu = copy(tmpu2)
                tmpu[j] += ajj31 * Y1j[j] + ajj32 * Y2j[j] - (ajl31 * Y1j[j] + ajl32 * Y2j[j])
                Y3j[j] = integrator.f.g(tmpu, p, t)[j] * _dW[j]
            end
        end
    end
    ktmp = integrator.f(Y30, p, t)
    Y30 = ktmp * dt

    # stage 4
    Y40 = uprev + a0043 * Y30
    if W.dW isa Number
        Y40 += a0j41 * Y1j
        Y4j = integrator.f.g(uprev + ajj41 * Y1j + ajj42 * Y2j + ajj43 * Y3j + aj041 * Y10, p, t) * _dW
    else
        if !is_diagonal_noise(integrator.sol.prob)
            Y4j = similar(integrator.sol.prob.noise_rate_prototype)
            for j in 1:m
                tmpu = uprev + ajj41 * Y1j[:, j] + ajj42 * Y2j[:, j] + ajj43 * Y3j[:, j] +
                    aj041 * Y10
                Y40 += a0j41 * Y1j[:, j]
                for l in 1:m
                    if l != j
                        tmpu += (ajl41 * Y1j[:, l] + ajl42 * Y2j[:, l])
                    end
                end
                Y4j[:, j] = integrator.f.g(tmpu, p, t)[:, j] * _dW[j]
            end
        else
            Y40 += a0j41 * Y1j
            Y4j = similar(uprev)
            tmpu2 = uprev + ajl41 * Y1j + ajl42 * Y2j + aj041 * Y10
            for j in 1:m
                tmpu = copy(tmpu2)
                tmpu[j] += ajj41 * Y1j[j] + ajj42 * Y2j[j] + ajj43 * Y3j[j] -
                    (ajl41 * Y1j[j] + ajl42 * Y2j[j])
                Y4j[j] = integrator.f.g(tmpu, p, t)[j] * _dW[j]
            end
        end
    end
    ktmp = integrator.f(Y40, p, t)
    Y40 = ktmp * dt

    # add stages together
    u = uprev + c01 * Y10 + c02 * Y20 + c03 * Y30 + c04 * Y40

    if W.dW isa Number
        u += cj1 * Y1j + cj2 * Y2j + cj3 * Y3j + cj4 * Y4j
    else
        if is_diagonal_noise(integrator.sol.prob)
            u += @. cj1 * Y1j + cj2 * Y2j + cj3 * Y3j + cj4 * Y4j
        else
            for j in 1:m
                u += @. cj1 * Y1j[:, j] + cj2 * Y2j[:, j] + cj3 * Y3j[:, j] + cj4 * Y4j[:, j]
                #add stage values for non-commutative processes, Y3^(k(j)j) and Y4^(k(j)j)
                for k in 1:m
                    η2 = @view Ihat2[k, :]
                    tmp = gtmp1 * η2 / (4 * γ)
                    Y3kj = integrator.sqdt * integrator.f.g(uprev + tmp, p, t)
                    Y4kj = integrator.sqdt * integrator.f.g(uprev - tmp, p, t)
                    u += @. γ * Y3kj[:, k] - γ * Y4kj[:, k]
                end
            end
        end
    end
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::NON2Cache)
    (;
        _dW, _dZ, chi1, Ihat2, tab, gtmp, gtmp1, ktmp, Y10, Y20,
        Y30, Y40, Y1j, Y2j, Y3j, Y4j, tmpu, tmpu2,
    ) = cache
    (;
        c01, c02, c03, c04, cj1, cj2, cj3, cj4, a0021, a0032, a0043, aj021, aj041,
        a0j21, a0j31, a0j32, a0j41, ajj21, ajj31, ajj32, ajj41, ajj42, ajj43,
        ajl31, ajl32, ajl41, ajl42, γ, NORMAL_ONESIX_QUANTILE,
    ) = cache.tab
    (; t, dt, uprev, u, W, p, f) = integrator

    m = length(W.dW)
    @.. _dW = W.dW

    # define three-point distributed random variables
    @.. chi1 = W.dW / integrator.sqdt
    sq3dt = sqrt(3 * dt)
    calc_threepoint_random!(_dW, sq3dt, NORMAL_ONESIX_QUANTILE, chi1)

    if !(W.dW isa Number)
        # define two-point distributed random variables
        calc_twopoint_random!(_dZ, integrator.sqdt, W.dZ)
        for j in 1:m
            for l in 1:(j - 1)
                Ihat2[j, l] = -_dZ[j] * _dW[l] / integrator.sqdt
                Ihat2[l, j] = _dW[l] * _dZ[j] / integrator.sqdt
            end
        end
    end

    # compute stage values
    # stage 1
    integrator.f(ktmp, uprev, p, t)
    integrator.f.g(gtmp, uprev, p, t)

    copyto!(gtmp1, gtmp)

    @.. Y10 = ktmp * dt

    if is_diagonal_noise(integrator.sol.prob)
        @.. Y1j = gtmp * _dW
    else
        for j in 1:m
            Y1jj = @view Y1j[:, j]
            gtmpj = @view gtmp[:, j]
            @.. Y1jj = gtmpj * _dW[j]
        end
    end

    # stage 2
    @.. Y20 = uprev + a0021 * Y10

    if !is_diagonal_noise(integrator.sol.prob)
        fill!(Y2j, zero(eltype(integrator.sol.prob.noise_rate_prototype)))
        for j in 1:m
            Y1jj = @view Y1j[:, j]
            Y2jj = @view Y2j[:, j]
            @.. Y20 = Y20 + a0j21 * Y1jj
            @.. tmpu = uprev + aj021 * Y10 + ajj21 * Y1jj
            integrator.f.g(gtmp, tmpu, p, t)
            gtmpj = @view gtmp[:, j]
            @.. Y2jj = gtmpj * _dW[j]
        end
    else
        fill!(Y2j, zero(eltype(integrator.u)))
        @.. Y20 = Y20 + a0j21 * Y1j
        @.. tmpu = uprev + aj021 * Y10
        for j in 1:m
            fill!(tmpu2, zero(eltype(integrator.u)))
            tmpu2[j] = ajj21 * Y1j[j]
            @.. tmpu2 = tmpu + tmpu2
            integrator.f.g(gtmp, tmpu2, p, t)
            Y2j[j] = gtmp[j] * _dW[j]
        end
    end
    integrator.f(ktmp, Y20, p, t)
    @.. Y20 = ktmp * dt

    # stage 3
    @.. Y30 = uprev + a0032 * Y20

    if !is_diagonal_noise(integrator.sol.prob)
        fill!(Y3j, zero(eltype(integrator.sol.prob.noise_rate_prototype)))
        for j in 1:m
            Y1jj = @view Y1j[:, j]
            Y2jj = @view Y2j[:, j]
            Y3jj = @view Y3j[:, j]
            @.. tmpu = uprev + ajj31 * Y1jj + ajj32 * Y2jj
            @.. Y30 = Y30 + a0j31 * Y1jj + a0j32 * Y2jj
            for l in 1:m
                if l != j
                    Y1jl = @view Y1j[:, l]
                    Y2jl = @view Y2j[:, l]
                    @.. tmpu = tmpu + (ajl31 * Y1jl + ajl32 * Y2jl)
                end
            end
            integrator.f.g(gtmp, tmpu, p, t)
            gtmpj = @view gtmp[:, j]
            @.. Y3jj = gtmpj * _dW[j]
        end
    else
        @.. Y30 = Y30 + a0j31 * Y1j + a0j32 * Y2j
        fill!(Y3j, zero(eltype(integrator.u)))
        @.. tmpu2 = uprev + ajl31 * Y1j + ajl32 * Y2j
        for j in 1:m
            @.. tmpu = tmpu2
            tmpu[j] += ajj31 * Y1j[j] + ajj32 * Y2j[j] - (ajl31 * Y1j[j] + ajl32 * Y2j[j])
            integrator.f.g(gtmp, tmpu, p, t)
            Y3j[j] = gtmp[j] * _dW[j]
        end
    end
    integrator.f(ktmp, Y30, p, t)
    @.. Y30 = ktmp * dt

    # stage 4
    @.. Y40 = uprev + a0043 * Y30

    if !is_diagonal_noise(integrator.sol.prob)
        fill!(Y4j, zero(eltype(integrator.sol.prob.noise_rate_prototype)))
        for j in 1:m
            Y1jj = @view Y1j[:, j]
            Y2jj = @view Y2j[:, j]
            Y3jj = @view Y3j[:, j]
            Y4jj = @view Y4j[:, j]
            @.. tmpu = uprev + ajj41 * Y1jj + ajj42 * Y2jj + ajj43 * Y3jj + aj041 * Y10
            @.. Y40 = Y40 + a0j41 * Y1jj
            for l in 1:m
                if l != j
                    Y1jl = @view Y1j[:, l]
                    Y2jl = @view Y2j[:, l]
                    @.. tmpu = tmpu + (ajl41 * Y1jl + ajl42 * Y2jl)
                end
            end
            integrator.f.g(gtmp, tmpu, p, t)
            gtmpj = @view gtmp[:, j]
            @.. Y4jj = gtmpj * _dW[j]
        end
    else
        @.. Y40 = Y40 + a0j41 * Y1j
        fill!(Y4j, zero(eltype(integrator.u)))
        @.. tmpu2 = uprev + ajl41 * Y1j + ajl42 * Y2j + aj041 * Y10
        for j in 1:m
            @.. tmpu = tmpu2
            tmpu[j] += ajj41 * Y1j[j] + ajj42 * Y2j[j] + ajj43 * Y3j[j] -
                (ajl41 * Y1j[j] + ajl42 * Y2j[j])
            integrator.f.g(gtmp, tmpu, p, t)
            Y4j[j] = gtmp[j] * _dW[j]
        end
    end
    integrator.f(ktmp, Y40, p, t)
    @.. Y40 = ktmp * dt

    # add stages together
    @.. u = uprev + c01 * Y10 + c02 * Y20 + c03 * Y30 + c04 * Y40

    if is_diagonal_noise(integrator.sol.prob)
        @. u = u + cj1 * Y1j + cj2 * Y2j + cj3 * Y3j + cj4 * Y4j
    else
        for j in 1:m
            Y1jj = @view Y1j[:, j]
            Y2jj = @view Y2j[:, j]
            Y3jj = @view Y3j[:, j]
            Y4jj = @view Y4j[:, j]
            @.. u = u + cj1 * Y1jj + cj2 * Y2jj + cj3 * Y3jj + cj4 * Y4jj

            #add stage values for non-commutative processes
            for k in 1:m
                η2 = @view Ihat2[k, :]
                gtmpk = @view gtmp[:, k]
                mul!(tmpu2, gtmp1, η2)
                @.. tmpu2 = tmpu2 / (4 * γ)
                @.. tmpu = uprev + tmpu2
                integrator.f.g(gtmp, tmpu, p, t)
                @.. u = u + γ * integrator.sqdt * gtmpk
                @.. tmpu = uprev - tmpu2
                integrator.f.g(gtmp, tmpu, p, t)
                @.. u = u - @. γ * integrator.sqdt * gtmpk
            end
        end
    end
end

# SIE / SME
@muladd function perform_step!(integrator, cache::SIESMEConstantCache)
    (;
        α1, α2, γ1, λ1, λ2, λ3, µ1, µ2, µ3, µ0, µbar0, λ0, λbar0, ν1, ν2, β2, β3, δ2,
        δ3,
    ) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    W2 = @. (W.dW)^2 / integrator.sqdt
    W3 = @. ν2 * (W.dW)^3 / dt

    # compute stage values
    k0 = integrator.f(uprev, p, t)
    g0 = integrator.f.g(uprev, p, t)

    # k1, g1, g2
    if is_diagonal_noise(integrator.sol.prob)
        k1 = integrator.f(uprev + λ0 * k0 * dt + ν1 * g0 .* W.dW + g0 .* W3, p, t + µ0 * dt)
        g1 = integrator.f.g(
            uprev + λbar0 * k0 * dt + β2 * g0 * integrator.sqdt + β3 * g0 .* W2, p, t +
                µbar0 * dt
        )
        g2 = integrator.f.g(
            uprev + λbar0 * k0 * dt + δ2 * g0 * integrator.sqdt + δ3 * g0 .* W2, p, t +
                µbar0 * dt
        )

    else
        # W.dW isa Number
        k1 = integrator.f(uprev + λ0 * k0 * dt + ν1 * g0 * W.dW + g0 * W3, p, t + µ0 * dt)
        g1 = integrator.f.g(
            uprev + λbar0 * k0 * dt + β2 * g0 * integrator.sqdt + β3 * g0 * W2, p, t +
                µbar0 * dt
        )
        g2 = integrator.f.g(
            uprev + λbar0 * k0 * dt + δ2 * g0 * integrator.sqdt + δ3 * g0 * W2, p, t +
                µbar0 * dt
        )
    end

    # add stages together
    u = uprev + (α1 * k0 + α2 * k1) * dt

    # add noise
    if W.dW isa Number
        u += γ1 * g0 * W.dW + (λ1 * W.dW + λ2 * integrator.sqdt + λ3 * W2) * g1 +
            (µ1 * W.dW + µ2 * integrator.sqdt + µ3 * W2) * g2
    else
        u += @. γ1 * g0 * W.dW + (λ1 * W.dW + λ2 * integrator.sqdt + λ3 * W2) * g1 +
            (µ1 * W.dW + µ2 * integrator.sqdt + µ3 * W2) * g2
    end
    integrator.u = u
end

# SIE / SME
@muladd function perform_step!(integrator, cache::SIESMECache)
    (; W2, W3, tab, k0, k1, g0, g1, g2, tmpu) = cache
    (;
        α1, α2, γ1, λ1, λ2, λ3, µ1, µ2, µ3, µ0, µbar0,
        λ0, λbar0, ν1, ν2, β2, β3, δ2, δ3,
    ) = cache.tab
    (; t, dt, uprev, u, W, p, f) = integrator

    @. W2 = (W.dW)^2 / integrator.sqdt
    @. W3 = ν2 * (W.dW)^3 / dt

    # compute stage values
    integrator.f(k0, uprev, p, t)
    integrator.f.g(g0, uprev, p, t)

    # k1, g1, g2
    if is_diagonal_noise(integrator.sol.prob)
        @.. tmpu = uprev + λ0 * k0 * dt + ν1 * g0 * W.dW + g0 * W3
        integrator.f(k1, tmpu, p, t + µ0 * dt)
        @.. tmpu = uprev + λbar0 * k0 * dt + β2 * g0 * integrator.sqdt + β3 * g0 * W2
        integrator.f.g(g1, tmpu, p, t + µbar0 * dt)
        @.. tmpu = uprev + λbar0 * k0 * dt + δ2 * g0 * integrator.sqdt + δ3 * g0 * W2
        integrator.f.g(g2, tmpu, p, t + µbar0 * dt)
    end

    # add stages together
    @.. u = uprev + (α1 * k0 + α2 * k1) * dt

    # add noise
    if is_diagonal_noise(integrator.sol.prob)
        @. u = u + γ1 * g0 * W.dW + (λ1 * W.dW + λ2 * integrator.sqdt + λ3 * W2) * g1 +
            (µ1 * W.dW + µ2 * integrator.sqdt + µ3 * W2) * g2
    end
end

# W2Ito1 due to Tang and Xiao

function W2Ito_I2(_dW, xi, eta2, k, l)
    if k < l
        return 1 // 2 * (_dW[l] - eta2 * _dW[l])
    elseif k > l
        return 1 // 2 * (_dW[l] + eta2 * _dW[l])
    else
        return 1 // 2 * (_dW[k]^2 / xi - xi)
    end
end

@muladd function perform_step!(integrator, cache::W2Ito1ConstantCache)
    (;
        a021, a031, a032, a121, a131, b021, b031, b121, b131, b221, α1, α2, α3,
        beta01, beta02, beta03, beta11, beta13, NORMAL_ONESIX_QUANTILE,
    ) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    # define three-point distributed random variables
    dW_scaled = W.dW / sqrt(dt)
    sq3dt = sqrt(3 * dt)
    _dW = map(x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), dW_scaled)
    # define two-point distributed random variables
    _dZ = map(x -> calc_twopoint_random(one(integrator.dt), x), W.dZ)
    xi = integrator.sqdt * _dZ[1]

    m = length(W.dW)

    chi1 = map(x -> (x^2 / xi - xi) / 2, _dW) # diagonal of Ihat2

    # compute stage values
    k1 = integrator.f(uprev, p, t)
    g1 = integrator.f.g(uprev, p, t)

    # H_1^(0) (stage 1)
    # H01 = uprev
    # H_2^(0) (stage 2)
    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        H02 = uprev + a021 * k1 * dt + b021 * g1 * _dW
    else
        H02 = uprev + a021 * k1 * dt + b021 * g1 .* _dW
    end

    # H_3^(0) (stage 3)
    k2 = integrator.f(H02, p, t)
    H03 = uprev + a032 * k2 * dt + a031 * k1 * dt

    if !is_diagonal_noise(integrator.sol.prob) || W.dW isa Number
        H03 += b031 * g1 * _dW
    else
        H03 += b031 * g1 .* _dW
    end

    k3 = integrator.f(H03, p, t)

    # H_1^(k), (stage 1)
    # H11 = uprev
    # H_i^(k) (stage 2 and 3)
    if W.dW isa Number
        H12 = uprev + a121 * k1 * dt + b121 * g1 * xi
        H13 = uprev + a131 * k1 * dt + b131 * g1 * xi
    else
        H12 = [uprev .+ a121 * k1 * dt for k in 1:m]
        H13 = [uprev .+ a131 * k1 * dt for k in 1:m]
        for k in 1:m
            if is_diagonal_noise(integrator.sol.prob)
                tmp = zero(integrator.u)
                tmp[k] = g1[k]
                H12[k] += b121 * tmp * xi
                H13[k] += b131 * tmp * xi
                for l in 1:m
                    if l != k
                        tmp = zero(integrator.u)
                        tmp[l] = g1[l]
                        H12[k] += b221 * tmp * W2Ito_I2(_dW, xi, _dZ[2], k, l)
                    end
                end

            else
                H12[k] += b121 * g1[:, k] * xi
                H13[k] += b131 * g1[:, k] * xi

                for l in 1:m
                    if l != k
                        H12[k] += b221 * g1[:, l] * W2Ito_I2(_dW, xi, _dZ[2], k, l)
                    end
                end
            end
        end
    end

    if W.dW isa Number
        g2 = integrator.f.g(H12, p, t)
        g3 = integrator.f.g(H13, p, t)
    else
        if is_diagonal_noise(integrator.sol.prob)
            g2 = [integrator.f.g(H12[k], p, t)[k] for k in 1:m]
            g3 = [integrator.f.g(H13[k], p, t)[k] for k in 1:m]
        else
            g2 = hcat([integrator.f.g(H12[k], p, t)[:, k] for k in 1:m] ...)
            g3 = hcat([integrator.f.g(H13[k], p, t)[:, k] for k in 1:m] ...)
        end
    end

    # add stages together Eq. (3)
    u = uprev + α1 * k1 * dt + α2 * k2 * dt + α3 * k3 * dt

    # add noise
    if W.dW isa Number
        u += g1 * (_dW * beta01 + chi1 * beta11) + g2 * (_dW * beta02) +
            g3 * (_dW * beta03 + chi1 * beta13)
    else
        if is_diagonal_noise(integrator.sol.prob)
            u += g1 .* (_dW * beta01 + chi1 * beta11) + g2 .* (_dW * beta02) +
                g3 .* (_dW * beta03 + chi1 * beta13)
        else
            # non-diag noise
            u += g1 * (_dW * beta01 + chi1 * beta11) + g2 * (_dW * beta02) +
                g3 * (_dW * beta03 + chi1 * beta13)
        end
    end

    if integrator.opts.adaptive

        # schemes with lower convergence order
        # check against EM
        uhat = uprev + k1 * dt

        if is_diagonal_noise(integrator.sol.prob)
            uhat += g1 .* _dW
        else
            uhat += g1 * _dW
        end

        resids = calculate_residuals(
            u - uhat, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end

    integrator.u = u
end

@muladd function perform_step!(integrator, cache::W2Ito1Cache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (;
        _dW, _dZ, chi1, tab, g1, g2, g3, k1, k2, k3, H02, H03,
        H12, H13, tmp1, tmpg, uhat, tmp, resids,
    ) = cache
    (;
        a021, a031, a032, a121, a131, b021, b031, b121, b131, b221, α1, α2, α3, beta01,
        beta02, beta03, beta11, beta13, NORMAL_ONESIX_QUANTILE,
    ) = cache.tab

    m = length(W.dW)
    sq3dt = sqrt(3 * dt)

    if W.dW isa Union{SArray, Number}
        # define three-point distributed random variables
        _dW = map(
            x -> calc_threepoint_random(sq3dt, NORMAL_ONESIX_QUANTILE, x), W.dW /
                sqrt(dt)
        )
        # define two-point distributed random variables
        _dZ = map(x -> calc_twopoint_random(one(integrator.dt), x), W.dZ)
        xi = integrator.sqdt * _dZ[1]
        chi1 = map(x -> (x^2 / xi - xi) / 2, _dW) # diagonal of Ihat2
    else
        # define three-point distributed random variables
        sqrtdt = sqrt(dt)
        @.. chi1 = W.dW / sqrtdt
        calc_threepoint_random!(_dW, sq3dt, NORMAL_ONESIX_QUANTILE, chi1)
        calc_twopoint_random!(_dZ, one(integrator.sqdt), W.dZ)
        xi = integrator.sqdt * _dZ[1]
        map!(x -> (x^2 / xi - xi) / 2, chi1, _dW)
    end

    # compute stage values
    integrator.f(k1, uprev, p, t)
    integrator.f.g(g1, uprev, p, t)

    # H_i^(0), stage 1
    # H01 = uprev
    # H_i^(0), stage 2
    if is_diagonal_noise(integrator.sol.prob)
        @.. H02 = uprev + a021 * k1 * dt + b021 * g1 * _dW
    else
        mul!(tmp1, g1, _dW)
        @.. H02 = uprev + dt * a021 * k1 + b021 * tmp1
    end

    integrator.f(k2, H02, p, t)
    if is_diagonal_noise(integrator.sol.prob)
        @.. H03 = uprev + a032 * k2 * dt + a031 * k1 * dt + b031 * g1 * _dW
    else
        @.. H03 = uprev + a032 * k2 * dt + a031 * k1 * dt + b031 * tmp1
    end

    integrator.f(k3, H03, p, t)

    # H_i^(k), stages
    # H11 = uprev
    for k in 1:m
        if is_diagonal_noise(integrator.sol.prob)
            fill!(tmpg, zero(eltype(integrator.u)))
            tmpg[k] = g1[k]
            @.. H12[k] = uprev + a121 * k1 * dt + b121 * tmpg * xi
            @.. H13[k] = uprev + a131 * k1 * dt + b131 * tmpg * xi
            for l in 1:m
                if l != k
                    fill!(tmpg, zero(eltype(integrator.u)))
                    tmpg[l] = g1[l]
                    WikJ = W2Ito_I2(_dW, xi, _dZ[2], k, l)
                    @.. H12[k] = H12[k] + b221 * tmpg * WikJ
                end
            end
            integrator.f.g(tmpg, H12[k], p, t)
            g2[k] = tmpg[k]
            integrator.f.g(tmpg, H13[k], p, t)
            g3[k] = tmpg[k]
        else
            g1k = @view g1[:, k]
            @.. H12[k] = uprev + a121 * k1 * dt + b121 * g1k * xi
            @.. H13[k] = uprev + a131 * k1 * dt + b131 * g1k * xi
            for l in 1:m
                if l != k
                    WikJ = W2Ito_I2(_dW, xi, _dZ[2], k, l)
                    g1l = @view g1[:, l]
                    @.. H12[k] = H12[k] + b221 * g1l * WikJ
                end
            end
            integrator.f.g(tmpg, H12[k], p, t)
            tmpgk = @view tmpg[:, k]
            g2k = @view g2[:, k]
            copyto!(g2k, tmpgk)
            integrator.f.g(tmpg, H13[k], p, t)
            tmpgk = @view tmpg[:, k]
            g3k = @view g3[:, k]
            copyto!(g3k, tmpgk)
        end
    end

    # add stages together Eq. (3)
    @.. u = uprev + α1 * k1 * dt + α2 * k2 * dt + α3 * k3 * dt

    # add noise
    if W.dW isa Number || is_diagonal_noise(integrator.sol.prob)
        @.. u = u + g1 * (_dW * beta01 + chi1 * beta11) + g2 * (_dW * beta02) +
            g3 * (_dW * beta03 + chi1 * beta13)
    else
        # non-diag noise
        mul!(tmp1, g1, (_dW * beta01 + chi1 * beta11))
        @.. u = u + tmp1
        mul!(tmp1, g2, (_dW * beta02))
        @.. u = u + tmp1
        mul!(tmp1, g3, (_dW * beta03 + chi1 * beta13))
        @.. u = u + tmp1
    end

    if integrator.opts.adaptive

        # check against EM
        @.. uhat = uprev + k1 * dt

        if is_diagonal_noise(integrator.sol.prob)
            @.. uhat = uhat + g1 .* _dW
        else
            mul!(tmp1, g1, _dW)
            @.. uhat = uhat + tmp1
        end
        @.. tmp = u - uhat

        calculate_residuals!(
            resids, tmp, uprev, uhat, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.internalnorm, t
        )

        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end
end

"""
 Tests for IRI1 (Implicit Rößler 1) drift-implicit weak order 2 SRK method.
 Based on test problems from https://arxiv.org/abs/1303.5103
"""

using StochasticDiffEqWeak, DiffEqDevTools, Test
using Random

seed = 103478
function prob_func(prob, i, repeat)
    return remake(prob, seed = seeds[i])
end

@info "IRI1: Scalar oop weak convergence test"

# Test problem from the paper (scalar, oop)
numtraj = Int(2.0e6)
u₀ = 0.0
f(u, p, t) = 1 // 2 * u + sqrt(u^2 + 1)
g(u, p, t) = sqrt(u^2 + 1)
# Use dt values [1/16, 1/8, 1/4] - coarser values that show convergence
# Note: dt=1/2 causes nlsolver convergence failure for this nonlinear problem with theta=1
dts = 1 .// 2 .^ (4:-1:2)
tspan = (0.0, 2.0)

h1(z) = z^3 - 6 * z^2 + 8 * z
# analytical_sol(t) = E(h1(arsinh(X(t)))) = t^3-3*t^2+2*t
# analytical_sol(2) = 0

Random.seed!(seed)
seeds = rand(UInt, numtraj)

prob = SDEProblem(f, g, u₀, tspan)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h1(asinh(sol.u[end])), false),
    prob_func = prob_func
)

println("IRI1 weak convergence test")
sim = test_convergence(
    dts, ensemble_prob, IRI1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@show sim.𝒪est[:weak_final]
# IRI1 has weak order 2
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35
println("IRI1:", sim.𝒪est[:weak_final])

"""
 Tests for https://arxiv.org/abs/1303.5103 with test problems as in the paper.
 DRI1, RI1, RI3, RI5, RI6, RDI1WM, RDI2WM, RDI3WM, RDI4WM
"""

import Statistics # for mean values of trajectories
import LinearAlgebra # for the normn
using StochasticDiffEqWeak
using Test
using Random
using DiffEqDevTools
#using DiffEqGPU
seed = 103473
function prob_func(prob, i, repeat)
    return remake(prob, seed = seeds[i])
end

"""
 Test Scalar SDEs (oop)
"""

@info "Scalar oop noise"

numtraj = Int(1.0e7) # in the paper they use 1e9
u₀ = 0.0
f(u, p, t) = 1 // 2 * u + sqrt(u^2 + 1)
g(u, p, t) = sqrt(u^2 + 1)
dts = 1 .// 2 .^ (4:-1:1)
tspan = (0.0, 2.0) # 2.0 in paper

h1(z) = z^3 - 6 * z^2 + 8 * z
#analytical_sol(t) = E(f(X(t))) = E(h1(arsinh(X(t))) = t^3-3*t^2+2*t
#analytical_sol(2) = 0 and analytical_sol(1)=0

Random.seed!(seed)
seeds = rand(UInt, numtraj)

prob = SDEProblem(f, g, u₀, tspan)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h1(asinh(sol.u[end])), false),
    prob_func = prob_func
)

sim = test_convergence(
    dts, ensemble_prob, DRI1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("DRI1:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e7)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RI1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RI1:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e7)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RI3(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RI3:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e7)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RI5(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RI5:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e7)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RI6(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RI6:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e6)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RDI1WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.3
println("RDI1WM:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e7)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RDI2WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RDI2WM:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, RDI3WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RDI3WM:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, RDI4WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.5 # order is 2.568 with 3e5 trajectories
println("RDI4WM:", sim.𝒪est[:weak_final])

"""
 Test Scalar SDEs (iip)
"""

@info "Scalar iip noise"

u₀ = [0.0]
f1!(du, u, p, t) = @.(du = 1 // 2 * u + sqrt(u^2 + 1))
g1!(du, u, p, t) = @.(du = sqrt(u^2 + 1))
dts = 1 .// 2 .^ (4:-1:1)
tspan = (0.0, 2.0)

h1(z) = z^3 - 6 * z^2 + 8 * z

prob = SDEProblem(f1!, g1!, u₀, tspan)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h1(asinh(sol.u[end][1])), false),
    prob_func = prob_func
)

numtraj = Int(6.0e6)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, DRI1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("DRI1:", sim.𝒪est[:weak_final])

numtraj = Int(8.0e6)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, DRI1NM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("DRI1NM:", sim.𝒪est[:weak_final])

numtraj = Int(9.0e6)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RI1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.4
println("RI1:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e7)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RI3(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RI3:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e7)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RI5(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RI5:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e7)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RI6(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RI6:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e6)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RDI1WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.3
println("RDI1WM:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e7)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RDI2WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35
println("RDI2WM:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, RDI3WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RDI3WM:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, RDI4WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test -(sim.𝒪est[:weak_final] - 2) < 0.3
println("RDI4WM:", sim.𝒪est[:weak_final])

## alg_order

alg_order(alg::DRI1) = 1 // 1
alg_order(alg::DRI1NM) = 1 // 1
alg_order(alg::RI1) = 1 // 1
alg_order(alg::RI3) = 1 // 1
alg_order(alg::RI5) = 1 // 1
alg_order(alg::RI6) = 1 // 1
alg_order(alg::RDI1WM) = 1 // 1
alg_order(alg::RDI2WM) = 1 // 1
alg_order(alg::RDI3WM) = 1 // 1
alg_order(alg::RDI4WM) = 1 // 1
alg_order(alg::W2Ito1) = 1 // 1

alg_order(alg::RS1) = 1 // 1
alg_order(alg::RS2) = 1 // 1

alg_order(alg::PL1WM) = 1 // 1
alg_order(alg::PL1WMA) = 1 // 1

alg_order(alg::NON) = 1 // 1
alg_order(alg::COM) = 1 // 1
alg_order(alg::NON2) = 1 // 1

alg_order(alg::SIEA) = 1 // 1
alg_order(alg::SMEA) = 1 // 1
alg_order(alg::SIEB) = 1 // 1
alg_order(alg::SMEB) = 1 // 1

alg_order(alg::IRI1) = 1 // 1  # Strong order, weak order is 2

## alg_interpretation (Stratonovich methods)

SciMLBase.alg_interpretation(alg::RS1) = SciMLBase.AlgorithmInterpretation.Stratonovich
SciMLBase.alg_interpretation(alg::RS2) = SciMLBase.AlgorithmInterpretation.Stratonovich

SciMLBase.alg_interpretation(alg::NON) = SciMLBase.AlgorithmInterpretation.Stratonovich
SciMLBase.alg_interpretation(alg::COM) = SciMLBase.AlgorithmInterpretation.Stratonovich
SciMLBase.alg_interpretation(alg::NON2) = SciMLBase.AlgorithmInterpretation.Stratonovich

## alg_compatible

alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::DRI1) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::DRI1NM) = is_diagonal_noise(prob)
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::RI1) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::RI3) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::RI5) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::RI6) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::RDI1WM) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::RDI2WM) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::RDI3WM) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::RDI4WM) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::W2Ito1) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::RS1) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::RS2) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::PL1WM) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::PL1WMA) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::NON) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::COM) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::NON2) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SIEA) = is_diagonal_noise(prob)
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SMEA) = is_diagonal_noise(prob)
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SIEB) = is_diagonal_noise(prob)
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SMEB) = is_diagonal_noise(prob)
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::IRI1) = true

## alg_needs_extra_process

alg_needs_extra_process(alg::IRI1) = true
alg_needs_extra_process(alg::DRI1) = true
alg_needs_extra_process(alg::RI1) = true
alg_needs_extra_process(alg::RI3) = true
alg_needs_extra_process(alg::RI5) = true
alg_needs_extra_process(alg::RI6) = true
alg_needs_extra_process(alg::RDI1WM) = true
alg_needs_extra_process(alg::RDI2WM) = true
alg_needs_extra_process(alg::RDI3WM) = true
alg_needs_extra_process(alg::RDI4WM) = true
alg_needs_extra_process(alg::W2Ito1) = true
alg_needs_extra_process(alg::RS1) = true
alg_needs_extra_process(alg::RS2) = true
alg_needs_extra_process(alg::PL1WM) = true
alg_needs_extra_process(alg::NON) = true
alg_needs_extra_process(alg::NON2) = true

## _z_prototype overrides (Z process sizing for algorithms with extra noise)

# PL1WM needs m*(m-1)/2 auxiliary random variables for iterated integrals
function _z_prototype(alg::PL1WM, rand_prototype, iip::Bool)
    if !iip && rand_prototype isa Number
        return nothing
    end
    m = length(rand_prototype)
    rp2 = similar(rand_prototype, Int(m * (m - 1) / 2))
    rp2 .= false
    return rp2
end

# W2Ito1 always needs exactly 2 auxiliary random variables
function _z_prototype(alg::W2Ito1, rand_prototype, iip::Bool)
    return zeros(eltype(rand_prototype), 2)
end

"""
 Tests for https://arxiv.org/abs/1303.5103 with test problems as in the paper.
 DRI1, RI1, RI3, RI5, RI6, RDI1WM, RDI2WM, RDI3WM, RDI4WM
"""

import Statistics # for mean values of trajectories
import LinearAlgebra # for the normn
using StochasticDiffEqWeak
using Test
using Random
using DiffEqDevTools
#using DiffEqGPU
seed = 103473
function prob_func(prob, i, repeat)
    return remake(prob, seed = seeds[i])
end

"""
 Test Diagonal noise SDEs (iip), SIAM Journal on Numerical Analysis, 47 (2009), pp. 1713–1738
"""

@info "Diagonal noise"

u₀ = [0.1, 0.1]
function f3!(du, u, p, t)
    du[1] = 3 // 2 * u[1]
    return du[2] = 3 // 2 * u[2]
end
function g3!(du, u, p, t)
    du[1] = 1 // 10 * u[1]
    return du[2] = 1 // 10 * u[2]
end
dts = 1 .// 2 .^ (3:-1:0)
tspan = (0.0, 1.0)

h3(z) = z^2 # == 1//10**exp(3//2*t) if h3(z) = z and  == 1//100**exp(301//100*t) if h3(z) = z^2 )

prob = SDEProblem(f3!, g3!, u₀, tspan)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h3(sol.u[end][1]), false),
    prob_func = prob_func
)

numtraj = Int(5.0e6)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, DRI1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test -(sim.𝒪est[:weak_final] - 2) < 0.3 # order is 2.91
println("DRI1:", sim.𝒪est[:weak_final])

numtraj = Int(8.0e6)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, DRI1NM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.4 # order is 2.91
println("DRI1NM:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, RI1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test -(sim.𝒪est[:weak_final] - 2) < 0.3 # order is 3.05
println("RI1:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, RI3(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test -(sim.𝒪est[:weak_final] - 2) < 0.3 # order is 2.77
println("RI3:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, RI5(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.45
println("RI5:", sim.𝒪est[:weak_final])

numtraj = Int(3.0e7)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RI6(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 1.5) < 0.5 # order is 1.55
println("R6:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e7)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RDI1WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 1) < 0.5 # order is 1.44
println("RDI1WM:", sim.𝒪est[:weak_final])

numtraj = Int(3.0e7)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RDI2WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 1.5) < 0.5 # order is 1.55
println("RDI2WM:", sim.𝒪est[:weak_final])

numtraj = Int(5.0e4)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RDI3WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test -(sim.𝒪est[:weak_final] - 2) < 0.3 # order is 2.84
println("RDI3WM:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, RDI4WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test -(sim.𝒪est[:weak_final] - 2) < 0.3 # order is 2.91
println("RDI4WM:", sim.𝒪est[:weak_final])

module StochasticDiffEqWeak

using Reexport
@reexport using StochasticDiffEqCore

import OrdinaryDiffEqCore
import OrdinaryDiffEqCore: perform_step!, initialize!, issplit

import StochasticDiffEqCore: alg_cache, alg_order, alg_compatible,
    alg_needs_extra_process, is_split_step, Ihat2, _z_prototype,
    StochasticDiffEqAlgorithm, StochasticDiffEqAdaptiveAlgorithm,
    StochasticDiffEqNewtonAdaptiveAlgorithm, StochasticDiffEqNewtonAlgorithm,
    StochasticDiffEqCache, StochasticDiffEqConstantCache, StochasticDiffEqMutableCache,
    StochasticDiffEqCompositeAlgorithm,
    unwrap_alg,
    calc_twopoint_random!, calc_twopoint_random,
    calc_threepoint_random!, calc_threepoint_random,
    @cache

import DiffEqBase: is_diagonal_noise, @..
import DiffEqBase: calculate_residuals, calculate_residuals!
import DiffEqBase: full_cache, rand_cache, ratenoise_cache
import DiffEqBase: Tableau

import MuladdMacro: @muladd
import SciMLBase

using OrdinaryDiffEqCore: _vec, _reshape, set_new_W!, get_W
using OrdinaryDiffEqNonlinearSolve: NLSolver, nlsolvefail, nlsolve!, build_nlsolver,
    markfirststage!, NLNewton

import OrdinaryDiffEqNonlinearSolve

using LinearAlgebra
using StaticArrays
using RecursiveArrayTools
using ForwardDiff, FiniteDiff
import ADTypes

include("tableaus.jl")
include("algorithms.jl")
include("alg_utils.jl")

include("caches/srk_weak_caches.jl")
include("caches/implicit_weak_caches.jl")

include("weak_utils.jl")

include("perform_step/srk_weak.jl")
include("perform_step/implicit_weak.jl")

export DRI1, DRI1NM, RI1, RI3, RI5, RI6,
    RDI1WM, RDI2WM, RDI3WM, RDI4WM,
    W2Ito1, RS1, RS2, PL1WM, PL1WMA,
    NON, NON2, COM,
    SIEA, SIEB, SMEA, SMEB,
    IRI1

# Tableau types and constructors
export RoesslerRI, RoesslerRS, KomoriNON, KomoriNON2,
    constructDRI1, constructRI1, constructRI3, constructRI5, constructRI6,
    constructRDI1WM, constructRDI2WM, constructRDI3WM, constructRDI4WM,
    constructRS1, constructRS2,
    constructNON, constructNON2,
    checkRIOrder, checkRSOrder, checkNONOrder

end # module

"""
 Tests for  https://link.springer.com/article/10.1007/s10543-007-0130-3 with test problems as in the paper.
 RS1, RS2
 and for https://www.sciencedirect.com/science/article/pii/S0377042706003906
 NON, COM, NON2
"""

import Statistics # for mean values of trajectories
import LinearAlgebra # for the normn
using StochasticDiffEqWeak
using Test
using Random
using DiffEqDevTools
#using DiffEqGPU

function prob_func(prob, i, repeat)
    return remake(prob, seed = seeds[i])
end

"""
 Test Scalar SDEs (oop)
"""

@info "Scalar oop noise"

numtraj = Int(8.0e6) # in the paper they use 1e9
u₀ = 0.1
p = [1.5, 0.1]
f(u, p, t) = p[1] * u
g(u, p, t) = p[2] * u
dts = 1 .// 2 .^ (5:-1:0)
tspan = (0.0, 1.0)

h1(z) = z

seed = 250
Random.seed!(seed)
seeds = rand(UInt, numtraj)

prob = SDEProblem(f, g, u₀, tspan, p)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h1(sol.u[end]), false),
    prob_func = prob_func
)

sim = test_convergence(
    dts, ensemble_prob, RS1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ * exp(1.0 * (p[1] + 0.5 * p[2]^2))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35
println("RS1:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, RS2(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ * exp(1.0 * (p[1] + 0.5 * p[2]^2))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.39 #order is 2.36
println("RS2:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, NON(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ * exp(1.0 * (p[1] + 0.5 * p[2]^2))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.5
println("NON:", sim.𝒪est[:weak_final])

numtraj = Int(5.0e6)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)
sim = test_convergence(
    dts, ensemble_prob, NON2(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ * exp(1.0 * (p[1] + 0.5 * p[2]^2))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("NON2:", sim.𝒪est[:weak_final])

dts = 1 .// 2 .^ (4:-1:0)
numtraj = Int(1.0e6)
seed = 10
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, COM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ * exp(1.0 * (p[1] + 0.5 * p[2]^2))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35
println("COM:", sim.𝒪est[:weak_final])

"""
 Test Scalar SDEs (iip)
"""

@info "Scalar iip noise"

f!(du, u, p, t) = du[1] = p[1] * u[1]
g!(du, u, p, t) = du[1] = p[2] * u[1]

numtraj = Int(5.0e6)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)
dts = 1 .// 2 .^ (5:-1:0)

prob = SDEProblem(f!, g!, [u₀], tspan, p)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h1(sol.u[end][1]), false),
    prob_func = prob_func
)

sim = test_convergence(
    dts, ensemble_prob, RS1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ * exp(1.0 * (p[1] + 0.5 * p[2]^2))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.4
println("RS1:", sim.𝒪est[:weak_final])

numtraj = Int(2.0e7)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RS2(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ * exp(1.0 * (p[1] + 0.5 * p[2]^2))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.45 #order is 2.415
println("RS2:", sim.𝒪est[:weak_final])

numtraj = Int(5.0e6)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, NON(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ * exp(1.0 * (p[1] + 0.5 * p[2]^2))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("NON:", sim.𝒪est[:weak_final])

numtraj = Int(5.0e6)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)
sim = test_convergence(
    dts, ensemble_prob, NON2(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ * exp(1.0 * (p[1] + 0.5 * p[2]^2))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("NON2:", sim.𝒪est[:weak_final])

dts = 1 .// 2 .^ (4:-1:0)
numtraj = Int(1.0e6)
seed = 10
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, COM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ * exp(1.0 * (p[1] + 0.5 * p[2]^2))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35
println("COM:", sim.𝒪est[:weak_final])

"""
 Test Diagonal noise SDEs (iip)
"""

@info "Diagonal noise"

u₀ = [0.1, 0.1]
function f3!(du, u, p, t)
    du[1] = 299 // 200 * u[1]
    return du[2] = 299 // 200 * u[2]
end
function g3!(du, u, p, t)
    du[1] = 1 // 10 * u[1]
    return du[2] = 1 // 10 * u[2]
end
dts = 1 .// 2 .^ (4:-1:0)
tspan = (0.0, 1.0)

h3(z) = z^2 # == 1//10**exp(3//2*t) if h3(z) = z and  == 1//100**exp(301//100*t) if h3(z) = z^2 )

prob = SDEProblem(f3!, g3!, u₀, tspan)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h3(sol.u[end][1]), false),
    prob_func = prob_func
)

numtraj = Int(5.0e5)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RS1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.4 # order is 1.67
println("RS1:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e5)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RS2(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RS2:", sim.𝒪est[:weak_final])

numtraj = Int(5.0e5)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, NON(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35
println("NON:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, NON2(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35
println("NON2:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e6)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, COM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("COM:", sim.𝒪est[:weak_final])

"""
 Tests for SIE and SME methods
"""

import Statistics # for mean values of trajectories
import LinearAlgebra # for the normn
using StochasticDiffEqWeak
using Test
using Random
using DiffEqDevTools
#using DiffEqGPU

function prob_func(prob, i, repeat)
    return remake(prob, seed = seeds[i])
end

"""
 Test Scalar SDEs (oop)
"""

@info "Scalar oop noise"

# PC exercise 14.2.2
numtraj = Int(1.0e5)
u₀ = 0.1
f(u, p, t) = p[1] * u
g(u, p, t) = p[2] * u
dts = 1 .// 2 .^ (6:-1:3)
tspan = (0.0, 1.0)
p = [3 // 2, 1 // 100]

h1(z) = z
#analytical_sol(t) = E(f(X(t))) =

seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

prob = SDEProblem(f, g, u₀, tspan, p)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h1(sol.u[end]), false),
    prob_func = prob_func
)

sim = test_convergence(
    dts, ensemble_prob, SIEA(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35 # order is 2.35
println("SIEA:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, SMEA(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35 # order is 2.34
println("SMEA:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, SIEB(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35 # order is 2.35
println("SIEB:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, SMEB(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35 # order is 2.34
println("SMEB:", sim.𝒪est[:weak_final])

"""
 Test Scalar SDEs (iip)
"""

@info "Scalar iip noise"

u₀ = [0.1]
f1!(du, u, p, t) = (du[1] = p[1] * u[1])
g1!(du, u, p, t) = (du[1] = p[2] * u[1])
dts = 1 .// 2 .^ (6:-1:3)
tspan = (0.0, 1.0)
p = [3 // 2, 1 // 100]

prob = SDEProblem(f1!, g1!, u₀, tspan, p)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h1(sol.u[end][1]), false),
    prob_func = prob_func
)

numtraj = Int(1.0e5)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, SIEA(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35 # order is 2.35
println("SIEA:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, SMEA(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35 # order is 2.34
println("SMEA:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, SIEB(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35 # order is 2.35
println("SIEB:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, SMEB(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = u₀ .* exp(1.0 * (p[1]))
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35 # order is 2.34
println("SMEB:", sim.𝒪est[:weak_final])

"""
 Test Diagonal noise SDEs (iip), SIAM Journal on Numerical Analysis, 47 (2009), pp. 1713–1738
"""

@info "Diagonal noise"

u₀ = [0.1, 0.1]
function f3!(du, u, p, t)
    du[1] = 3 // 2 * u[1]
    return du[2] = 3 // 2 * u[2]
end
function g3!(du, u, p, t)
    du[1] = 1 // 10 * u[1]
    return du[2] = 1 // 10 * u[2]
end
dts = 1 .// 2 .^ (5:-1:1)
tspan = (0.0, 1.0)

h3(z) = z^2 # == 1//10**exp(3//2*t) if h3(z) = z and  == 1//100**exp(301//100*t) if h3(z) = z^2 )

prob = SDEProblem(f3!, g3!, u₀, tspan)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h3(sol.u[end][1]), false),
    prob_func = prob_func
)

numtraj = Int(1.0e6)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, SIEA(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("SIEA:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, SMEA(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("SMEA:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, SIEB(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("SIEB:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, SMEB(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("SMEB:", sim.𝒪est[:weak_final])

using StochasticDiffEqWeak, Test, Random

function weak_error(
        prob, alg, numtraj, batchsize, f_true, trange;
        abstol = 1, reltol = 0, ensemblealg = EnsembleThreads()
    )
    sol = @time solve(
        prob, alg, ensemblealg,
        dt = 0.05f0, adaptive = true, abstol = abstol, reltol = reltol,
        trajectories = numtraj, batch_size = batchsize,
        saveat = trange
    )
    computed_exp = (sol.u / numtraj)[1, :]
    true_exp = f_true.(trange)
    return sum((computed_exp - true_exp) .^ 2) / length(trange)
end

function prob_func(prob, i, repeat)
    #(i%50000 == 0) && @show i
    return remake(prob, seed = seeds[i])
end

function reduction(u, batch, I)
    return u .+ sum(batch), false
end

function output_func(sol, i)
    #h1(asinh(sol.u[end][1])),false
    return h1.(asinh.(sol)), false
end

# prob 1
u₀ = [0.0f0]
tspan = (0.0f0, 2.0f0)
h1(z) = z^3 - 6 * z^2 + 8 * z

function f1!(du, u, p, t)
    @inbounds begin
        du[1] = 1 // 2 * u[1] + sqrt(u[1]^2 + 1)
    end
    return nothing
end

function g1!(du, u, p, t)
    @inbounds begin
        du[1] = sqrt(u[1]^2 + 1)
    end
    return nothing
end

f_true1(t) = t^3 - 3 * t^2 + 2 * t

prob1 = SDEProblem(f1!, g1!, u₀, tspan)
ensemble_prob1 = EnsembleProblem(
    prob1;
    output_func = output_func,
    prob_func = prob_func,
    reduction = reduction,
    u_init = Vector{eltype(prob1.u0)}([0.0])
)

# prob 2
u₀ = [0.1f0, 0.1f0]
function f2!(du, u, p, t)
    @inbounds begin
        du[1] = 3 // 2 * u[1]
        du[2] = 3 // 2 * u[2]
    end
    return nothing
end
function g2!(du, u, p, t)
    @inbounds begin
        du[1] = 1 // 10 * u[1]
        du[2] = 1 // 10 * u[2]
    end
    return nothing
end

f_true2(t) = 1 // 10 * exp(3 // 2 * t) #1//100*exp(301//100*t)

h2(z) = z #z^2

prob2 = SDEProblem(f2!, g2!, u₀, tspan)
ensemble_prob2 = EnsembleProblem(
    prob2;
    output_func = (sol, i) -> (h2.(sol), false),
    prob_func = prob_func,
    reduction = reduction,
    u_init = Vector{eltype(prob2.u0)}([0.0, 0.0])
)

tsave = 0.0f0:0.05f0:2.0f0

probs = Vector{EnsembleProblem}(undef, 2)
probs[1] = ensemble_prob1
probs[2] = ensemble_prob2

ftrue = Vector{}(undef, 2)
ftrue[1] = f_true1
ftrue[2] = f_true2

numtraj = Int(5.0e5)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

for i in 1:2
    @show i

    err1 = weak_error(
        probs[i], DRI1(), numtraj, Int(10), ftrue[i], tsave, abstol = 1.0f0, reltol = 1.0f0
    )
    @show err1
    err2 = weak_error(
        probs[i], DRI1(), numtraj, Int(10), ftrue[i], tsave, abstol = 0.5f0, reltol = 0.5f0
    )
    @show err2
    err3 = weak_error(
        probs[i], DRI1(), numtraj, Int(10), ftrue[i], tsave, abstol = 0.1f0, reltol = 0.1f0
    )
    @show err3
    @test err1 > err2
    @test err2 > err3
    println("")
end

numtraj = Int(5.0e5)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

for i in 1:2
    @show i
    err1 = weak_error(
        probs[i], DRI1NM(), numtraj, Int(1.0e1), ftrue[i],
        tsave, abstol = 1.0f0, reltol = 1.0f0
    )
    @show err1
    err2 = weak_error(
        probs[i], DRI1NM(), numtraj, Int(1.0e1), ftrue[i],
        tsave, abstol = 0.1f0, reltol = 0.1f0
    )
    @show err2
    #err3 = weak_error(probs[i],DRI1NM(),numtraj,Int(1e1),ftrue[i],tsave,abstol=0.01f0,reltol=0.01f0)
    #@show err3
    #@test err1 > err2
    @test err1 > err2
    println("")
end

"""
  Tests for W2Ito1 from Tang, X., & Xiao, A. (2017). Efficient weak second-order stochastic
  Runge–Kutta methods for Itô stochastic differential equations. BIT Numerical Mathematics,
  57, 241-260.
"""

import Statistics # for mean values of trajectories
import LinearAlgebra # for the normn
using StochasticDiffEqWeak
using Test
using Random
using DiffEqDevTools
seed = 103473
function prob_func(prob, i, repeat)
    return remake(prob, seed = seeds[i])
end

"""
 Test OOP
"""

@info "Scalar noise"

numtraj = Int(2.0e6) # in the paper they use 1e9
u₀ = 0.0
f(u, p, t) = 1 // 2 * u + sqrt(u^2 + 1)
g(u, p, t) = sqrt(u^2 + 1)
dts = 1 .// 2 .^ (4:-1:1)
tspan = (0.0, 2.0) # 2.0 in paper

h1(z) = z^3 - 6 * z^2 + 8 * z
#analytical_sol(t) = E(f(X(t))) = E(h1(arsinh(X(t))) = t^3-3*t^2+2*t
#analytical_sol(2) = 0 and analytical_sol(1)=0

Random.seed!(seed)
seeds = rand(UInt, numtraj)

prob = SDEProblem(f, g, u₀, tspan)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h1(asinh(sol.u[end])), false),
    prob_func = prob_func
)

sim = test_convergence(
    dts, ensemble_prob, W2Ito1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35
println("W2Ito1:", sim.𝒪est[:weak_final])

@info "Diagonal noise"

u₀ = [0.1, 0.1]
function f2(u, p, t)
    return [3 // 2 * u[1], 3 // 2 * u[2]]
end
function g2(u, p, t)
    return [1 // 10 * u[1], 1 // 10 * u[2]]
end
dts = 1 .// 2 .^ (3:-1:0)
tspan = (0.0, 1.0)

h2(z) = z^2 # == 1//10**exp(3//2*t) if h3(z) = z and  == 1//100**exp(301//100*t) if h3(z) = z^2 )

prob = SDEProblem(f2, g2, u₀, tspan)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h2(sol.u[end][1]), false),
    prob_func = prob_func
)

numtraj = Int(1.0e5)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, W2Ito1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test -(sim.𝒪est[:weak_final] - 2) < 0.3 # order is 2.4
println("W2Ito1:", sim.𝒪est[:weak_final])

@info "Non-commutative noise"

u₀ = [1.0, 1.0]
function f3(u, p, t)
    return [-273 // 512 * u[1], -1 // 160 * u[1] - (-785 // 512 + sqrt(2) / 8) * u[2]]
end
function g3(u, p, t)
    return [
        1 // 4 * u[1] 1 // 16 * u[1]
        (1 - 2 * sqrt(2)) / 4 * u[1] 1 // 10 * u[1] + 1 // 16 * u[2]
    ]
end
dts = 1 .// 2 .^ (3:-1:0)
tspan = (0.0, 3.0)

h3(z) = z^2 # but apply it only to u[1]

prob = SDEProblem(f3, g3, u₀, tspan, noise_rate_prototype = zeros(2, 2))
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h3(sol.u[end][1]), false),
    prob_func = prob_func
)

numtraj = Int(1.0e6)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, W2Ito1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = exp(-3.0)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35

println("W2Ito1:", sim.𝒪est[:weak_final])

# """
#  Test IIP
# """

@info "Scalar noise"

u₀ = [0.0]
f1!(du, u, p, t) = @.(du = 1 // 2 * u + sqrt(u^2 + 1))
g1!(du, u, p, t) = @.(du = sqrt(u^2 + 1))
dts = 1 .// 2 .^ (4:-1:1)
tspan = (0.0, 2.0)

h1(z) = z^3 - 6 * z^2 + 8 * z

prob = SDEProblem(f1!, g1!, u₀, tspan)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h1(asinh(sol.u[end][1])), false),
    prob_func = prob_func
)

numtraj = Int(1.0e6)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, W2Ito1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 0.0
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35
println("W2Ito1:", sim.𝒪est[:weak_final])

@info "Diagonal noise"

u₀ = [0.1, 0.1]
function f2!(du, u, p, t)
    du[1] = 3 // 2 * u[1]
    return du[2] = 3 // 2 * u[2]
end
function g2!(du, u, p, t)
    du[1] = 1 // 10 * u[1]
    return du[2] = 1 // 10 * u[2]
end
dts = 1 .// 2 .^ (3:-1:0)
tspan = (0.0, 1.0)

h2(z) = z^2 # == 1//10**exp(3//2*t) if h3(z) = z and  == 1//100**exp(301//100*t) if h3(z) = z^2 )

prob = SDEProblem(f2!, g2!, u₀, tspan)
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h2(sol.u[end][1]), false),
    prob_func = prob_func
)

numtraj = Int(1.0e5)
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, W2Ito1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = 1 // 100 * exp(301 // 100)
)
@test -(sim.𝒪est[:weak_final] - 2) < 0.3 # order is 2.4
println("W2Ito1:", sim.𝒪est[:weak_final])

@info "Non-commutative noise"

u₀ = [1.0, 1.0]
function f3!(du, u, p, t)
    du[1] = -273 // 512 * u[1]
    return du[2] = -1 // 160 * u[1] - (-785 // 512 + sqrt(2) / 8) * u[2]
end
function g3!(du, u, p, t)
    du[1, 1] = 1 // 4 * u[1]
    du[1, 2] = 1 // 16 * u[1]
    du[2, 1] = (1 - 2 * sqrt(2)) / 4 * u[1]
    return du[2, 2] = 1 // 10 * u[1] + 1 // 16 * u[2]
end
dts = 1 .// 2 .^ (3:-1:0)
tspan = (0.0, 3.0)

h3(z) = z^2 # but apply it only to u[1]

prob = SDEProblem(f3!, g3!, u₀, tspan, noise_rate_prototype = zeros(2, 2))
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h3(sol.u[end][1]), false),
    prob_func = prob_func
)

numtraj = Int(1.0e6)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, W2Ito1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = exp(-3.0)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.35

println("W2Ito1:", sim.𝒪est[:weak_final])

"""
 Tests for https://arxiv.org/abs/1303.5103 with test problems as in the paper.
 DRI1, RI1, RI3, RI5, RI6, RDI1WM, RDI2WM, RDI3WM, RDI4WM
"""

import Statistics # for mean values of trajectories
import LinearAlgebra # for the normn
using StochasticDiffEqWeak
using Test
using Random
using DiffEqDevTools
#using DiffEqGPU

function prob_func(prob, i, repeat)
    return remake(prob, seed = seeds[i])
end

"""
 Test non-commutative noise SDEs (iip)
"""

@info "Non-commutative noise"

u₀ = [1.0, 1.0]
function f2!(du, u, p, t)
    du[1] = -273 // 512 * u[1]
    return du[2] = -1 // 160 * u[1] - (-785 // 512 + sqrt(2) / 8) * u[2]
end
function g2!(du, u, p, t)
    du[1, 1] = 1 // 4 * u[1]
    du[1, 2] = 1 // 16 * u[1]
    du[2, 1] = (1 - 2 * sqrt(2)) / 4 * u[1]
    return du[2, 2] = 1 // 10 * u[1] + 1 // 16 * u[2]
end
dts = 1 .// 2 .^ (3:-1:0)
tspan = (0.0, 3.0)

h2(z) = z^2 # but apply it only to u[1]

prob = SDEProblem(f2!, g2!, u₀, tspan, noise_rate_prototype = zeros(2, 2))
ensemble_prob = EnsembleProblem(
    prob;
    output_func = (sol, i) -> (h2(sol.u[end][1]), false),
    prob_func = prob_func
)

numtraj = Int(1.0e6)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, DRI1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = exp(-3.0)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("DRI1:", sim.𝒪est[:weak_final])

numtraj = Int(2.0e6)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)
sim = test_convergence(
    dts, ensemble_prob, RI1(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = exp(-3.0)
)
@test -(sim.𝒪est[:weak_final] - 2) < 0.3 # order 3.43
println("RI1:", sim.𝒪est[:weak_final])

numtraj = Int(2.0e5)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)
sim = test_convergence(
    dts, ensemble_prob, RI3(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = exp(-3.0)
)
@test -(sim.𝒪est[:weak_final] - 2) < 0.3 # order 2.46
println("RI3:", sim.𝒪est[:weak_final])

numtraj = Int(2.0e5)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)
sim = test_convergence(
    dts, ensemble_prob, RI5(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = exp(-3.0)
)
@test -(sim.𝒪est[:weak_final] - 2) < 0.3 # order 2.57
println("RI5:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e7)
seed = 100
Random.seed!(seed)
seeds = rand(UInt, numtraj)
sim = test_convergence(
    dts, ensemble_prob, RI6(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = exp(-3.0)
)
@test abs(sim.𝒪est[:weak_final] - 2) < 0.3
println("RI6:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e5)
seed = 55
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RDI1WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = exp(-3.0)
)
@test_broken abs(sim.𝒪est[:weak_final] - 2.0) < 0.3 # seems closer to 1.5?
@test abs(sim.𝒪est[:weak_final] - 1.5) < 0.3 # seems closer to 1.5?
println("RDI1WM:", sim.𝒪est[:weak_final])

numtraj = Int(1.0e7)
seed = 10
Random.seed!(seed)
seeds = rand(UInt, numtraj)

sim = test_convergence(
    dts, ensemble_prob, RDI2WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = exp(-3.0)
)
@test abs(sim.𝒪est[:weak_final] - 2.0) < 0.3
println("RDI2WM:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, RDI3WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = exp(-3.0)
)
@test abs(sim.𝒪est[:weak_final] - 3) < 0.4
println("RDI3WM:", sim.𝒪est[:weak_final])

sim = test_convergence(
    dts, ensemble_prob, RDI4WM(),
    save_everystep = false, trajectories = numtraj, save_start = false, adaptive = false,
    weak_timeseries_errors = false, weak_dense_errors = false,
    expected_value = exp(-3.0)
)
@test abs(sim.𝒪est[:weak_final] - 3) < 0.4
println("RDI4WM:", sim.𝒪est[:weak_final])

using SafeTestsets

const TEST_GROUP = get(ENV, "ODEDIFFEQ_TEST_GROUP", "ALL")

if TEST_GROUP == "ALL" || TEST_GROUP == "Core"
    @time @safetestset "Module loads and constructors" begin
        using StochasticDiffEqWeak
        using Test

        @test DRI1() isa StochasticDiffEqAdaptiveAlgorithm
        @test DRI1NM() isa StochasticDiffEqAdaptiveAlgorithm
        @test RI1() isa StochasticDiffEqAdaptiveAlgorithm
        @test RI3() isa StochasticDiffEqAdaptiveAlgorithm
        @test RI5() isa StochasticDiffEqAdaptiveAlgorithm
        @test RI6() isa StochasticDiffEqAdaptiveAlgorithm
        @test RDI1WM() isa StochasticDiffEqAlgorithm
        @test RDI2WM() isa StochasticDiffEqAdaptiveAlgorithm
        @test RDI3WM() isa StochasticDiffEqAdaptiveAlgorithm
        @test RDI4WM() isa StochasticDiffEqAdaptiveAlgorithm
        @test W2Ito1() isa StochasticDiffEqAdaptiveAlgorithm
        @test RS1() isa StochasticDiffEqAlgorithm
        @test RS2() isa StochasticDiffEqAlgorithm
        @test PL1WM() isa StochasticDiffEqAlgorithm
        @test PL1WMA() isa StochasticDiffEqAlgorithm
        @test NON() isa StochasticDiffEqAlgorithm
        @test NON2() isa StochasticDiffEqAlgorithm
        @test COM() isa StochasticDiffEqAlgorithm
        @test SIEA() isa StochasticDiffEqAlgorithm
        @test SIEB() isa StochasticDiffEqAlgorithm
        @test SMEA() isa StochasticDiffEqAlgorithm
        @test SMEB() isa StochasticDiffEqAlgorithm
        @test IRI1() isa StochasticDiffEqNewtonAdaptiveAlgorithm
    end
end

if TEST_GROUP == "ALL" || TEST_GROUP == "WeakConvergence1"
    @time @safetestset "Platen's PL1WM weak second order" begin
        include("weak_convergence/PL1WM.jl")
    end
end

if TEST_GROUP == "ALL" || TEST_GROUP == "WeakConvergence2"
    @time @safetestset "Roessler weak SRK Tests" begin
        include("weak_convergence/srk_weak_final.jl")
    end
end

if TEST_GROUP == "ALL" || TEST_GROUP == "W2Ito1WeakConvergence"
    @time @safetestset "Tang & Xiao weak SRK Tests" begin
        include("weak_convergence/W2Ito1.jl")
    end
end

if TEST_GROUP == "ALL" || TEST_GROUP == "WeakConvergence3"
    @time @safetestset "Roessler weak SRK (non-diagonal) Tests" begin
        include("weak_convergence/srk_weak_final_non_diagonal.jl")
    end
end

if TEST_GROUP == "ALL" || TEST_GROUP == "SIESMEWeakConvergence"
    @time @safetestset "SIE SME weak Tests" begin
        include("weak_convergence/SIE_SME.jl")
    end
end

if TEST_GROUP == "ALL" || TEST_GROUP == "WeakConvergence4"
    @time @safetestset "Weak Stratonovich (non-diagonal) Tests" begin
        include("weak_convergence/weak_strat_non_diagonal.jl")
    end
end

if TEST_GROUP == "ALL" || TEST_GROUP == "WeakConvergence5"
    @time @safetestset "Weak Stratonovich Tests" begin
        include("weak_convergence/weak_strat.jl")
    end
end

if TEST_GROUP == "ALL" || TEST_GROUP == "WeakConvergence6"
    @time @safetestset "Roessler weak SRK diagonal Tests" begin
        include("weak_convergence/srk_weak_diagonal_final.jl")
    end
end

if TEST_GROUP == "ALL" || TEST_GROUP == "IRI1WeakConvergence"
    @time @safetestset "IRI1 Weak Convergence Tests" begin
        include("weak_convergence/iri1_weak.jl")
    end
end

if TEST_GROUP == "ALL" || TEST_GROUP == "WeakAdaptiveCPU"
    @time @safetestset "CPU Weak adaptive" begin
        include("adaptive/sde_weak_adaptive.jl")
    end
    @time @safetestset "CPU Weak adaptive step size Brusselator" begin
        include("adaptive/sde_weak_brusselator_adaptive.jl")
    end
end

################################################################################
# Ihat2 methods for weak-order cache types
# These extend StochasticDiffEqCore.Ihat2 with cache-type-specific dispatch.

function Ihat2(cache::Union{DRI1ConstantCache, DRI1Cache}, _dW, _dZ, sqdt, k, l)
    # compute elements of I^_(k,l) which is a mxm matrix
    if k < l
        return (_dW[k] * _dW[l] - sqdt * _dZ[k]) / 2
    elseif l < k
        return (_dW[k] * _dW[l] + sqdt * _dZ[l]) / 2
    else
        # l == k
        return (_dW[k]^2 - sqdt^2) / 2
    end
end

function Ihat2(cache::Union{RSConstantCache, RSCache}, _dW, _dZ, sqdt, k, l)
    # compute elements of I^_(k,l) which is a mxm matrix
    if k < l
        return -_dW[k] * _dZ[l]
    elseif l < k
        return _dW[k] * _dZ[l]
    else
        # l == k
        return zero(_dW[k])
    end
end

function Ihat2(cache::Union{PL1WMConstantCache, PL1WMCache}, _dW, _dZ, sqdt, k, l)
    # compute elements of I^_(k,l) which is a mxm matrix
    if k < l
        return -_dZ[Int(1 + 1 // 2 * (l - 3) * l + k)]
    elseif l < k
        return _dZ[Int(1 + 1 // 2 * (k - 3) * k + l)]
    else
        # l == k
        return -sqdt^2
    end
end

function Ihat2(cache::Union{NONConstantCache, NONCache}, _dW, _dZ, sqdt, k, l)
    # compute elements of I^_(k,l) which is a mxm matrix
    if k < l
        return _dZ[k]
    elseif l < k
        return _dW[l]
    else
        # l == k
        return _dW[k]
    end
end
